/*****************************************************************************/
/**
 *  @file   main.cpp
 *  @author Naohisa Sakamoto
 *  @brief  Example program for kvs::AnyValue class.
 */
/*----------------------------------------------------------------------------
 *
 *  Copyright (c) Visualization Laboratory, Kyoto University.
 *  All rights reserved.
 *  See http://www.viz.media.kyoto-u.ac.jp/kvs/copyright/ for details.
 *
 *  $Id: main.cpp 602 2010-08-19 02:43:34Z naohisa.sakamoto $
 */
/*****************************************************************************/
#include <iostream>
#include <kvs/AnyValue>


/*===========================================================================*/
/**
 *  @brief  Main function.
 */
/*===========================================================================*/
int main( void )
{
    double v1 = 12.3;
    kvs::AnyValue a1 = v1;
    std::cout << std::endl;
    std::cout << "double v1 = 12.3;" << std::endl;
    std::cout << "kvs::AnyValue a1 = v1;" << std::endl;
    std::cout << "value: " << a1 << std::endl;
    std::cout << "type: " << a1.typeInfo()->typeName() << std::endl;

    float v2 = 123.4f;
    kvs::AnyValue a2 = v2;
    std::cout << std::endl;
    std::cout << "float v2 = 123.4f;" << std::endl;
    std::cout << "kvs::AnyValue a2 = v2;" << std::endl;
    std::cout << "value: " << a2 << std::endl;
    std::cout << "type: " << a2.typeInfo()->typeName() << std::endl;

    char v3 = 100;
    kvs::AnyValue a3 = v3;
    std::cout << std::endl;
    std::cout << "char v3 = 100;" << std::endl;
    std::cout << "kvs::AnyValue a3 = v3;" << std::endl;
    std::cout << "value: " << a3 << " (" << int( a3 ) << ")" << std::endl;
    std::cout << "type: " << a3.typeInfo()->typeName() << std::endl;

    int v4 = a1;
    std::cout << std::endl;
    std::cout << "int v4 = a1" << std::endl;
    std::cout << "value: " << v4 << std::endl;

    kvs::AnyValue a4 = a1;
    std::cout << std::endl;
    std::cout << "kvs::AnyValue a4 = a1" << std::endl;
    std::cout << "value: " << a4 << std::endl;
    std::cout << "type: " << a4.typeInfo()->typeName() << std::endl;

    return 0;
}
