#ifndef __KVS_VISCLIENT_COMTHREAD_H__
#define __KVS_VISCLIENT_COMTHREAD_H__

#include <kvs/Thread>
#include "Command.h"
#include "PBVRParam.h"

namespace kvs {
namespace visclient {

class ComThread : public kvs::Thread {

public:
    enum ComStatus {
        Idle    = 0,
        Ready   = 1,
        Running = 2,
        Exit    = 3,
    };

private:
    Command* m_command;
    PBVRParam m_param;
    PBVRResult m_result;
    ComStatus m_status;

    kvs::Mutex m_mutex_param;
    kvs::Mutex m_mutex_result;
    kvs::Mutex m_mutex_status;

public:
    ComThread(Command* command);
    virtual ~ComThread();

    bool start();
    bool wait();
    void quit();
    void run();

    ComStatus getStatus();

private:
    void make_param();
    void emit_result();
    void setStatus(const ComStatus status);
};

}}

#endif // __KVS_VISCLIENT_COMTHREAD_H__

