#ifndef __FILE_PARAM_H__
#define __FILE_PARAM_H__

#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <fstream>
#include "Types.h"
#include "glui.h"

extern GLUI *glui_3vd;

extern int subpixellevela;
extern int subpixelleveld;
extern int repeatlevela;
extern int repeatleveld;
extern int plimitlevel;
extern int samplingtypelevel;
extern float lookat_eyex_level;
extern float lookat_eyey_level;
extern float lookat_eyez_level;
extern float lookat_centerx_level;
extern float lookat_centery_level;
extern float lookat_centerz_level;
extern float lookat_upvectorx_level;
extern float lookat_upvectory_level;
extern float lookat_upvectorz_level;
extern float resolution_width_level;
extern float resolution_height_level;
extern char pfi_path_server[256];

extern int   obj_3d;
extern float tbcxminlevel;
extern float tbcxmaxlevel;
extern float tbcyminlevel;
extern float tbcymaxlevel;
extern float tbczminlevel;
extern float tbczmaxlevel;

extern float tbsradius;
extern float tbscenterx;
extern float tbscentery;
extern float tbscenterz;

extern float tbpradius;
extern float tbpheight;
extern float tbpcenterx;
extern float tbpcentery;
extern float tbpcenterz;


extern GLUI_EditText* subpixeld;
extern GLUI_EditText* repeatd;
extern GLUI_EditText* plimit;
extern GLUI_EditText* lookat_eyex;
extern GLUI_EditText* lookat_eyey;
extern GLUI_EditText* lookat_eyez;
extern GLUI_EditText* lookat_centerx;
extern GLUI_EditText* lookat_centery;
extern GLUI_EditText* lookat_centerz;
extern GLUI_EditText* lookat_upvectorx;
extern GLUI_EditText* lookat_upvectory;
extern GLUI_EditText* lookat_upvectorz;
extern GLUI_EditText* resolution_width;
extern GLUI_EditText* resolution_height;

extern GLUI_EditText *crop_cxmin2;
extern GLUI_EditText *crop_cxmax2;
extern GLUI_EditText *crop_cymin2;
extern GLUI_EditText *crop_cymax2;
extern GLUI_EditText *crop_czmin2;
extern GLUI_EditText *crop_czmax2;

extern GLUI_EditText *sphere_radius;
extern GLUI_EditText *sphere_centerx;
extern GLUI_EditText *sphere_centery;
extern GLUI_EditText *sphere_centerz;

extern GLUI_EditText *pillar_radius;
extern GLUI_EditText *pillar_height;
extern GLUI_EditText *pillar_centerx;
extern GLUI_EditText *pillar_centery;
extern GLUI_EditText *pillar_centerz;

extern void cbcxminlevel2(int num);
extern void cbcyminlevel2(int num);
extern void cbczminlevel2(int num);
extern void cbcxmaxlevel2(int num);
extern void cbcymaxlevel2(int num);
extern void cbczmaxlevel2(int num);
extern void cbsradius(int num);
extern void cbscenterx(int num);
extern void cbscentery(int num);
extern void cbscenterz(int num);
extern void cbpradius(int num);
extern void cbpheight(int num);
extern void cbpcenterx(int num);
extern void cbpcentery(int num);
extern void cbpcenterz(int num);

// APPEND START FP)M.TANAKA 2015.03.16
extern float g_ro[3][3];
extern float g_tr[3];
extern float g_sc[3];
// APPEND END   FP)M.TANAKA 2015.03.16

class FileParam {

public:
//	FileParam();
	static int ReadParamFile(const char* fname, int readflag=1);
	static int WriteParamFile(const char* fname);
	static int updateWin3v(const char* fname);
};

#endif // __FILE_PARAM_H__
