#include <stdio.h>
#include <string.h>
#include "IoIni.h"

int kvs::visclient::outfile(rinidata_t* dt, char* fname)
{
        FILE* fp;
        if ((fp=fopen(fname, "w")) == NULL) {
                fprintf(stdout, "can't open file [%s]\n", fname);
                return(-1);
        }

        fprintf(fp, "%d\n", dt->resolution);
        fprintf(fp, "%d\n", dt->selected_transferfunc);
        for (int i=0;i<5;i++) {
                fprintf(fp, "%s\n", dt->transferfunc[i].name);
                fprintf(fp, "%s\n", dt->transferfunc[i].tfR);
                fprintf(fp, "%s\n", dt->transferfunc[i].tfG);
                fprintf(fp, "%s\n", dt->transferfunc[i].tfB);
                fprintf(fp, "%s\n", dt->transferfunc[i].tfA);
                fprintf(fp, "%f\n", dt->transferfunc[i].xmin);
                fprintf(fp, "%f\n", dt->transferfunc[i].xmax);
                fprintf(fp, "%s\n", dt->transferfunc[i].tfunc);
        }
        fprintf(fp, "%s\n", dt->tfsynthesis);
        fprintf(fp, "%s\n", dt->volumedatasynthesis);

        fclose(fp);

        return(0);
}

int kvs::visclient::infile(rinidata_t* dt, char* fname)
{
        FILE* fp;
        char    wk_buff[5];
        char    buf[256];

        if ((fp=fopen(fname, "r")) == NULL) {
                fprintf(stdout, "can't open file [%s]\n", fname);

                //ファイルが存在しなかったら、デフォルト値をセット
#ifdef notopen
                //
                dt->resolution = 256;
                dt->selected_transferfunc = 0;
                for (int i=0;i<5;i++) {
                        strcpy( dt->transferfunc[i].name, "t" );
                        sprintf( wk_buff, "%d", (i+1));
                        strcat( dt->transferfunc[i].name, wk_buff );
                        strcpy( dt->transferfunc[i].tfR, "0" );
                        strcpy( dt->transferfunc[i].tfG, "0" );
                        strcpy( dt->transferfunc[i].tfB, "0" );
                        strcpy( dt->transferfunc[i].tfA, "0" );
                        dt->transferfunc[i].xmin = 0.0F;
                        dt->transferfunc[i].xmax = 0.0F;
                        strcpy( dt->transferfunc[i].tfunc, "q1" );
                }
                strcpy( dt->tfsynthesis, "t1" );
                strcpy( dt->volumedatasynthesis, "" );
#endif
                return(-1);
        }

        fgets(buf, sizeof(buf), fp);
        sscanf(buf, "%d", &dt->resolution);
        fgets(buf, sizeof(buf), fp);
        sscanf(buf, "%d", &dt->selected_transferfunc);
        for (int i=0;i<5;i++) {
                fgets(buf, sizeof(buf), fp);
                sscanf(buf, "%s", dt->transferfunc[i].name);
                fgets(buf, sizeof(buf), fp);
                sscanf(buf, "%s", dt->transferfunc[i].tfR);
                fgets(buf, sizeof(buf), fp);
                sscanf(buf, "%s", dt->transferfunc[i].tfG);
                fgets(buf, sizeof(buf), fp);
                sscanf(buf, "%s", dt->transferfunc[i].tfB);
                fgets(buf, sizeof(buf), fp);
                sscanf(buf, "%s", dt->transferfunc[i].tfA);
                fgets(buf, sizeof(buf), fp);
                sscanf(buf, "%f", &dt->transferfunc[i].xmin);
                fgets(buf, sizeof(buf), fp);
                sscanf(buf, "%f", &dt->transferfunc[i].xmax);
                fgets(buf, sizeof(buf), fp);
                sscanf(buf, "%s", dt->transferfunc[i].tfunc);
        }
        fgets(buf, sizeof(buf), fp);
        sscanf(buf, "%s", dt->tfsynthesis);
        fgets(buf, sizeof(buf), fp);
        sscanf(buf, "%s", dt->volumedatasynthesis);

        fclose(fp);

        return(0);
}

#ifdef notopen
// test
main() {
        rinidata_t  d;
        rinidata_t  d2;

        char fn[] = "./outtest.txt";
        char fn2[] = "./outtest2.txt";

        d.resolution = 256;
        d.selected_transferfunc = 0; // 0-4

        // 0
        strcpy(d.transferfunc[0].name, "t1");
        for (int i=0;i<5;i++) {
         strcpy(d.transferfunc[i].tfR, "0");
         strcpy(d.transferfunc[i].tfG, "0");
         strcpy(d.transferfunc[i].tfB, "0");
         strcpy(d.transferfunc[i].tfA, "0");
         d.transferfunc[i].xmin = 0.0;
         d.transferfunc[i].xmax = 0.0;
         strcpy(d.transferfunc[i].tfunc, "q1");
        }
        // 1
        strcpy(d.transferfunc[1].name, "t2");
        // 2
        strcpy(d.transferfunc[2].name, "t3");
        // 3
        strcpy(d.transferfunc[3].name, "t4");
        // 4
        strcpy(d.transferfunc[4].name, "t5");

        strcpy(d.tfsynthesis, "t1");
        strcpy(d.volumedatasynthesis, "");

        outfile(&d, fn);

        infile(&d2, fn2);

        fprintf(stdout, "resolution=%d\n", d2.resolution);

        for (int i=0;i<5;i++) {
                fprintf(stdout, "%s\n", d2.transferfunc[i].name);
                fprintf(stdout, "%s\n", d2.transferfunc[i].tfR);
                fprintf(stdout, "%s\n", d2.transferfunc[i].tfG);
                fprintf(stdout, "%s\n", d2.transferfunc[i].tfB);
                fprintf(stdout, "%s\n", d2.transferfunc[i].tfA);
                fprintf(stdout, "%f\n", d2.transferfunc[i].xmin);
                fprintf(stdout, "%f\n", d2.transferfunc[i].xmax);
                fprintf(stdout, "%s\n", d2.transferfunc[i].tfunc);
        }

        fprintf(stdout, "tfsysnthesis=%d\n", d2.tfsynthesis);
        fprintf(stdout, "volumedatasysnthesis=%d\n", d2.volumedatasynthesis);
}

#endif
