#ifndef __KVS_VISCLIENT_PARTICLE_SERVER_H__
#define __KVS_VISCLIENT_PARTICLE_SERVER_H__

#include <string>
#include <iostream>
#include <vector>

#include "PBVRParam.h"
#include "PBVRResult.h"
#include "kvs/PointObject"
#include "Communication/ParticleTransferClient.h"
#include <kvs/Mutex>
#include "ParticleMergerUI.h"

namespace kvs{
	namespace visclient{
		
class ParticleServer
{
public:
         enum Status {
             Idle      = 0,
             Sending   = 1,
             Recieving = 2,
             Reading   = 3,
             Exit      = 4,
         };

private:
         int nrep;
         Status m_status;
         kvs::Mutex m_status_mutex;

public:

	ParticleServer( void ) :
            m_status(Idle)
	{
            nrep = 0;
	}

        kvs::PointObject* getPointObjectFromServer(const PBVRParam& param, PBVRResult* result, const int numvol);

	kvs::PointObject* getPointObjectFromLocal();
        void close(const PBVRParam& param);
    
        Status getStatus();

private:
        void setStatus(const Status status);
};

	}
}

#endif
