#ifndef KVS__GLUT__PROGRESS_BAR_H_INCLUDE
#define KVS__GLUT__PROGRESS_BAR_H_INCLUDE

#include "kvs/glut/WidgetBase"
#include "kvs/glut/Screen"
#include "kvs/ClassName"
#include "kvs/RGBColor"


namespace kvs
{

namespace visclient
{

class ProgressBar : public kvs::glut::WidgetBase
{
    // Class name.
    kvsClassName( kvs::glut::ProgressBar );

public:

    typedef kvs::glut::WidgetBase BaseClass;

protected:

    std::string   m_caption; ///< caption
    float         m_value; ///< value
    bool          m_change_value; ///< value change flag
    bool          m_show_range_value; ///< range value showing flag
    kvs::RGBColor m_slider_color; ///< slider (cursor) color
    kvs::RGBColor m_clicked_slider_color; ///< clicked slider (cursor) color
    kvs::RGBColor m_upper_edge_color; ///< upper edge color
    kvs::RGBColor m_lower_edge_color; ///< lower edge color

public:

    ProgressBar( kvs::ScreenBase* screen = 0 );

public:

    virtual void sliderPressed( void ){};

    virtual void sliderMoved( void ){};

    virtual void sliderReleased( void ){};

    virtual void valueChanged( void ){};

    virtual void screenUpdated( void ){};

    virtual void screenResized( void ){};

public:

    const std::string& caption( void ) const;

    const float value( void ) const;

    void setCaption( const std::string caption );

    void setValue( const float value );

    void setProgressBarColor( const kvs::RGBColor& color );

    void showRange( void );

    void hideRange( void );

private:

    void draw_slider_bar( const int x, const int y, const int width );

    //void draw_cursor( const int x, const int y, const int width );

    float get_value( const int x );

    int get_fitted_width( void );

    int get_fitted_height( void );

private:

    void paintEvent( void );

    void resizeEvent( int width, int height );
};

	}

}

#endif
