/****************************************************************************/
/**
 *  @file Constant.h
 */
/*----------------------------------------------------------------------------
 *
 *  Copyright (c) Visualization Laboratory, Kyoto University.
 *  All rights reserved.
 *  See http://www.viz.media.kyoto-u.ac.jp/kvs/copyright/ for details.
 *
 *  $Id: Constant.h 661 2011-01-15 05:22:33Z naohisa.sakamoto $
 */
/****************************************************************************/
#ifndef KVSMAKE__CONSTANT_H_INCLUDE
#define KVSMAKE__CONSTANT_H_INCLUDE

#include <cstdlib> // For std::getenv.
#include <string>  // For std::string.

#include "kvs/Compiler.h"


namespace kvsmake
{

//const std::string KVS_DIR( std::getenv( "KVS_DIR" ) );
const std::string KVS_DIR( "/usr/local/kvs" );

const std::string MakeCommand( "make" );
const std::string Makefile   ( "Makefile.kvs" );

const std::string MakefileTemplate ( KVS_DIR + "/bin/Makefile.kvs.template" );
const std::string QtProjectTemplate( KVS_DIR + "/bin/QtProject.template" );

} // end of namespace kvsmake

#endif // KVSMAKE__CONSTANT_H_INCLUDE
