#ifndef __IOINI_H__
#define __IOINI_H__

namespace kvs {
    namespace visclient {

typedef struct tf {
	char name[256];

	char tfR[256];
	char tfG[256];
	char tfB[256];
	char tfA[256];

	char xmin[256];
	char xmax[256];
	char tfunc[256];
} tf_t;

typedef struct inidata {
	char resolution[256];
	int  selected_transferfunc;
	tf_t transferfunc[5];
	char tfsynthesis[256];
	char volumedatasynthesis[256];
} inidata_t;

typedef struct rtf {
	char name[256];

	char tfR[256];
	char tfG[256];
	char tfB[256];
	char tfA[256];

	float xmin;
	float xmax;
	char tfunc[256];

    rtf() :
        xmin(0.0), xmax(1.0)
    {
        memset(name,'\0',sizeof(name));
        memset(tfR,'\0',sizeof(tfR));
        memset(tfG,'\0',sizeof(tfG));
        memset(tfB,'\0',sizeof(tfB));
        memset(tfA,'\0',sizeof(tfA));
        memset(tfunc,'\0',sizeof(tfunc));
    }
} rtf_t;

typedef struct rinidata {
	int resolution;
	int  selected_transferfunc;
	rtf_t transferfunc[5];
	char tfsynthesis[256];
	char volumedatasynthesis[256];

    rinidata() :
        resolution(256),
        selected_transferfunc(0)
    {
        memset(tfsynthesis,'\0',sizeof(tfsynthesis));
        memset(volumedatasynthesis,'\0',sizeof(volumedatasynthesis));
    }
} rinidata_t;

int outfile(rinidata_t*, char*);
int infile(rinidata_t*, char*);

    }
}

#endif // __IOINI_H__

