#ifndef __KVS_VISCLIENT_KEY_PRESS_EVENT_H__
#define __KVS_VISCLIENT_KEY_PRESS_EVENT_H__

#include "kvs/Message"
#include "kvs/Date"
#include "kvs/Time"
#include "kvs/KeyEvent"
#include "kvs/KeyPressEventListener"
#include "KeyFrameAnimation.h"

namespace kvs{
	namespace visclient{

class KeyPressEvent : public kvs::KeyPressEventListener
{

public:
    KeyPressEvent()
        {
        }

    void update( kvs::KeyEvent* event )
        {
            switch( event->key() )
            {
            case kvs::Key::l:
                screen()->controlTarget() = kvs::ScreenBase::TargetLight;
                break;
            case kvs::Key::c:
                screen()->controlTarget() = kvs::ScreenBase::TargetCamera;
                break;
            case kvs::Key::o:
                screen()->controlTarget() = kvs::ScreenBase::TargetObject;
                break;

            case kvs::Key::s:
            {
                kvs::Date today;
                kvs::Time now;
                std::string base1 = "test";
                std::string base2 = base1 + "_" + today.toString();
                std::string base3 = base2 + "_" + now.toString("-");
                std::string filename = base3 + ".bmp";
                kvs::ColorImage image( screen()->camera()->snapshot() );
                image.write( filename.c_str() );
                std::cout<<"Snapshot >>" << filename << std::endl;
                break;
            }

            case kvs::Key::x:
               /* printf(" [debug] 'x' pressed. (add Xform)\n"); */
               KeyFrameAnimation_add();
               break;
            case kvs::Key::d:
               /* printf(" [debug] 'd' pressed. (delete last Xform)\n"); */
               KeyFrameAnimation_erase();
               break;
            case kvs::Key::D:
               /* printf(" [debug] 'e' pressed. (delete all Xform)\n"); */
               KeyFrameAnimation_delete();
               break;
            case kvs::Key::M:
               /* printf(" [debug] 'M' pressed. (toggle animation with Xform)\n"); */
               /* KeyFrameAnimation_start(); */
               KeyFrameAnimation_toggle();
               break;
            /* case kvs::Key::m: */
            /*    printf(" [debug] 'm' pressed. (stop animation with Xform)\n"); */
            /*    KeyFrameAnimation_stop(); */
            /*    break; */
            case kvs::Key::S:
               /* printf(" [debug] 'S' pressed. (write Xform to file)\n"); */
               KeyFrameAnimation_write();
               break;
            case kvs::Key::F:
               /* printf(" [debug] 'F' pressed. (read Xform from file)\n"); */
               KeyFrameAnimation_read();
               break;
               
            default: break;
            }
        }
};
	}
}

#endif
