#ifndef __KVS_VISCLIENT_LABEL_H__
#define __KVS_VISCLIENT_LABEL_H__

#ifdef WIN32
#include "kvs/glut/Label"
#include "kvs/glut/Screen"
#else
#include "kvs/glut/Label.h"
#include "kvs/glut/Screen.h"
#endif

namespace kvs{
	namespace visclient{
		class Command;

class StepLabel : public kvs::glut::Label
{
private:
	Command* command;
public:

    StepLabel( Command* command );

    void screenUpdated( void );
};

class SizeLabel : public kvs::glut::Label
{
public:

	SizeLabel( Command* command );

	void screenUpdated( void );
};

class NodesLabel : public kvs::glut::Label
{
public:

	NodesLabel( kvs::visclient::Command* command );

	void screenUpdated( void );
};


class ElementsLabel : public kvs::glut::Label
{
public:

	ElementsLabel( kvs::visclient::Command* command );

	void screenUpdated( void );
};

class FPSLabel : public kvs::glut::Label
{
private:
	const kvs::RendererBase* renderer;

public:

	FPSLabel( kvs::ScreenBase* screen, const kvs::RendererBase* renderer );

    void screenUpdated( void );
};
	}
}

#endif
