#ifndef __PARAM_EX_TRANSFUNC_H__
#define __PARAM_EX_TRANSFUNC_H__

#include <string>
#include <vector>
#include "Types.h"
#include "ExtendTransferFunction.h"
#include "../Communication/ParticleTransferProtocol.h"

namespace kvs{
    namespace visclient{

class ParamExTransFunc
{
public:
    static const size_t NPRTF = 5;
    static const size_t NRGBA = 4;

public:
    int32_t ext_transferFunctionResolution;

    std::vector<NamedTransferFunction> transferFunction;

    std::string ext_transferFunctionSynthesis;
    std::string ext_volumeSynthesis;

    std::vector<bool> range_initialized;

public:
    ParamExTransFunc();
    virtual ~ParamExTransFunc();

    void ExTransFuncParaSet();
    void ExTransFuncParaDump();

public:
    void applyToClientMessage(jpv::ParticleTransferClientMessage* message) const;
};

    }
}

#endif // __PARAM_EX_TRANSFUNC_H__

