#include <signal.h>
#include "sighandler.h"
#include <iostream>
#include <kvs/Mutex>

kvs::Mutex sigmx;
bool SigClient = false;

void init_sighandler()
{
    signal(SIGABRT, &sighandler);
    signal(SIGTERM, &sighandler);
    signal(SIGINT,  &sighandler);
//  signal(SIGSEGV, &sighandler);
}

void sighandler(int sig)
{
    sigmx.lock();
    if (!SigClient) {
        std::cout << "SIGNALED!!!  ";
        if (sig == SIGABRT) {
            std::cout << "SIGABRT";
        } else if (sig == SIGINT) {
            std::cout << "SIGINT";
        } else if (sig == SIGTERM) {
            std::cout << "SIGTERM";
        } else if (sig == SIGSEGV) {
            std::cout << "SIGSEGV";
        }
        std::cout << "(" << sig << ")" << std::endl;
    }
    SigClient = true;
    sigmx.unlock();
}

bool issig()
{
    bool ret;
    sigmx.lock();
    ret = SigClient;
    sigmx.unlock();
    return ret;
}

