#include "DistributedUnstructuredVolumeImporter.h"
#include <kvs/UnstructuredVolumeObject>
#include <kvs/Type>
#include <kvs/ValueArray>
#include "FrontSTRFileReader.h"

namespace kvs
{

DistributedUnstructuredVolumeImporter::DistributedUnstructuredVolumeImporter( FrontSTRFileReader* reader ):
m_reader( NULL )
{
    attachReader( reader );
    import();
}

DistributedUnstructuredVolumeImporter::~DistributedUnstructuredVolumeImporter( void )
{
}

UnstructuredVolumeObject* DistributedUnstructuredVolumeImporter::import( void )
{
    this->setNNodes( m_reader->getAssignedNValues() );
    this->setCellType( m_reader->getCellType() );
    this->setNCells( m_reader->getAssignedNConnections() / m_reader->getEachNNodes() );
    this->setVeclen( 1 );
    this->setConnections( m_reader->getAssignedConnections() );
    this->setCoords( m_reader->getAssignedCoords() );
    this->setValues( AnyValueArray( m_reader->getAssignedValues() ) );
    this->updateMinMaxCoords();
    this->updateMinMaxValues();

    return ( this );
}

} // end of namespace kvs
