/* 
 * File:   filter_io_file_reader.h
 * Author: Martin Andersson, V.I.C 
 *
 * Created on September 29, 2015, 10:03 AM
 */

#ifndef FILTER_IO_FILE_READER_H
#define	FILTER_IO_FILE_READER_H
#include <stdio.h>
#include "filter_io_types.h"

typedef struct GridFile
{
    FILE* handle;
    ReadMode rMode;
    bool needsByteSwap;
    long int OpenFblockEnd;
    const char* filePath;
    bool usebytecount;
    DataTypeId blockDataTypeId;
} GridFile;

int filter_io_open_DataFile(GridFile* gFile, const char* filepath, ReadMode rMode);
int filter_io_close_dataFile(GridFile* gFile);
int filter_io_readObject(GridFile* gFile, void* var, DataTypeId type);
int filter_io_readBuffer(GridFile* gFile, void* var, long int count, DataTypeId typeId);
void filter_io_close_FortranBlock(GridFile * gFile);
long int filter_io_open_FortranBlock(GridFile * gFile);
int filter_io_checkFileEndian(GridFile* gFile);
void filter_io_skipToOffset(GridFile* gFile,long int bytes);
#endif	/* FILTER_IO_FILE_READER_H */

