#ifndef DISTRIBUTED_UNSTRUCTURED_VOLUME_IMPORTER_H
#define DISTRIBUTED_UNSTRUCTURED_VOLUME_IMPORTER_H

#include "UnstructuredVolumeObject.h"
#include "Type.h"
#include "ValueArray.h"
#include "FrontSTRFileReader.h"

namespace kvs
{

class DistributedUnstructuredVolumeImporter:
    public UnstructuredVolumeObject
{

private:
    FrontSTRFileReader* m_reader;

    Vector3f m_min_object_coord;           //!< min coord in the object coordinate system
    Vector3f m_max_object_coord;           //!< max coord in the object coordinate system
    Vector3f m_min_external_coord;         //!< min coord in the external coordinate system
    Vector3f m_max_external_coord;         //!< max coord in the external coordinate system

public:
    DistributedUnstructuredVolumeImporter( FrontSTRFileReader* reader );

    virtual ~DistributedUnstructuredVolumeImporter( void );

private:

    UnstructuredVolumeObject* import( void );

    void attachReader( FrontSTRFileReader* reader )
    {
        m_reader = reader;
    }

};

} // end of namespace kvs

#endif // DISTRIBUTED_UNSTRUCTURED_VOLUME_IMPORTER_H
