#ifndef  __FILTER_INFO_H__
#define __FILTER_INFO_H__

#include <string>
#include <vector>
#include "Types.h"
#include "Vector3.h"

class FilterInfo
{
public:
    struct ingredientsMinMax {
        float min;
        float max;
    };
    struct ingredientsStep {
        std::vector<ingredientsMinMax> ingred;
    };

public:
    int32_t numNodes;
    int32_t numElements;
    int32_t elemType;
    int32_t fileType;
    int32_t numFiles;
    int32_t numIngredients;
    int32_t staSteps;
    int32_t endSteps;
    int32_t numSteps;
    int32_t numSubVolumes;
    kvs::Vector3f minObjectCoord;
    kvs::Vector3f maxObjectCoord;
    std::vector<kvs::Vector3f> minSubVolumeCoord;
    std::vector<kvs::Vector3f> maxSubVolumeCoord;
    float   minValue;
    float   maxValue;

    std::vector<ingredientsStep> ingredStep;

public:
    int LoadPFI( std::string& filename );
};

#endif // __FILTER_INFO_H__

