#ifndef KVSML_OBJECT_POINT_MPI_WRITER_H_INCLUDE
#define KVSML_OBJECT_POINT_MPI_WRITER_H_INCLUDE

#include <string>
#include "PointObject.h"
//#include "KVSMLObjectPointWriter.h"
#include "JobDispatcher.h"

class KVSMLObjectPointMPIWriter //: public KVSMLObjectPointWriter
{
    kvs::PointObject* m_object;
    std::string m_basename;
    JobDispatcher* jd;
    int m_lastRank;

public:

    KVSMLObjectPointMPIWriter( JobDispatcher* jd );
    void Write( kvs::PointObject* object, std::string basename );
    int lastRank()
    {
        return m_lastRank;
    }

protected:

    void write_main_tag( int src, size_t nvertices );
    void write_coords( int src, size_t nvertices );
    void write_colors( int src, size_t nvertices );
    void write_normals( int src, size_t nvertices );

    void send_coords( size_t nvertices );
    void send_colors( size_t nvertices );
    void send_normals( size_t nvertices );
};

#endif //  KVSML_OBJECT_POINT_WRITER_MPI_H_INCLUDE
