#ifndef POINTSHUFFLE_H
#define	POINTSHUFFLE_H

#include <vector>

namespace kvs
{
class PointObject;

class PointShuffle
{
public:

    void setPointObject( PointObject* object );

    void shuffleWithRandom();

    void shuffleWithSingle( const int repeatLevel );

    void shuffleWithOpenMP( const int repeatLevel );

    void shuffleWithCUDA( const int repeatLevel );

    PointObject* getAbstractPointObject( const int repeatLevel );

    std::vector<PointObject*> getDetailedPointObject( const int repeatLevel );

private:
    void shuffle( const int howManyParticles, const int repeatLevel );

    void shuffleWithOpenMP( const int howManyParticles, const int repeatLevel );

private:
    PointObject* object;

    std::vector<int> indices;
    std::vector<float> positions;
    std::vector<float> normals;
    std::vector<unsigned char> colors;

    std::vector<int> shuffledIndices;
    std::vector<float> shuffledPositions;
    std::vector<float> shuffledNormals;
    std::vector<unsigned char> shuffledColors;
};

}

#endif
