/*****************************************************************************/
/**
 *  @file   point_object.cpp
 *  @brief
 *
 *  @author Yukio YASUHARA
 *  @date   2007/04/18 19:23:45
 */
/*----------------------------------------------------------------------------
 *
 *  $Author: yamasaki $
 *  $Date: 2002/03/15 02:05:11 $
 *  $Source: /home2/cvsroot/KVS/Library/Visualization/Object/point_object.cpp,v $
 *  $Revision: 1.4 $
 */
/*****************************************************************************/
#include "point_object_summation.h"

using namespace std;

namespace kvs
{
//namespace test
//{
/*===========================================================================*/
/**
 *  @brief  Default constructor.
 */
/*===========================================================================*/
PointObjectSummation::PointObjectSummation( kvs::PointObject** obj , const size_t nobjects , const size_t total_particles )
{
    sumPointData( obj , nobjects , total_particles );
}

void PointObjectSummation::sumPointData( kvs::PointObject** obj , const size_t nobjects , const size_t total_particles )
{
//    m_dimension = 3;
    m_coords.allocate( total_particles * 3 );
    m_colors.allocate( total_particles * 3 );
    m_normals.allocate( total_particles * 3 );

    //input vertex//

    int sum_nparticles = 0;

    for( size_t i = 0 ; i < nobjects ; i++ )
    {
        const int nparticles = obj[i]->nvertices();
        int p3 = 0;

        std::cout<<"total_particles = "<<total_particles<<" nparticles = "<<nparticles<<std::endl;

        for( int p = 0 ; p < nparticles ; p++, p3 += 3 )
        {
            m_coords[ p3 + sum_nparticles     ] = obj[i]->coords()[ p3     ];
            m_coords[ p3 + sum_nparticles + 1 ] = obj[i]->coords()[ p3 + 1 ];
            m_coords[ p3 + sum_nparticles + 2 ] = obj[i]->coords()[ p3 + 2 ];

            m_colors[ p3 + sum_nparticles     ] = obj[i]->colors()[ p3     ];
            m_colors[ p3 + sum_nparticles + 1 ] = obj[i]->colors()[ p3 + 1 ];
            m_colors[ p3 + sum_nparticles + 2 ] = obj[i]->colors()[ p3 + 2 ];

            m_normals[ p3 + sum_nparticles     ] = obj[i]->normals()[ p3     ];
            m_normals[ p3 + sum_nparticles + 1 ] = obj[i]->normals()[ p3 + 1 ];
            m_normals[ p3 + sum_nparticles + 2 ] = obj[i]->normals()[ p3 + 2 ];
        }

        sum_nparticles += nparticles * 3;
    }
}

//} // end of namespace test
} // end of namespace kvs
