//#define	NOTOPEN

#ifdef NOTOPEN
#include <stdio.h>
#include <math.h>
#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif
#include <glui.h>

#else
#include <kvs/glut/Application>
#include <kvs/glut/Screen>
#include <kvs/PolygonObject>
#endif

#include "CropParam.h"

// APPEND START FP)M.Tanaka 2015.03.02
#include "FileDialog.h"
GLUI_EditText *g_paramfile;
// APPEND END   FP)M.Tanaka 2015.03.02

//テスト用
//---------------------------------

void	display(void);
int		iwin_main;

//---------------------------------

void	CalcCropCoord(void);
void	CalcSphereCoord(void);
void	CalcPillarCoord(void);
void	CalcPillarXZCoord(void);
void	CalcPillarYZCoord(void);

void	DrawCrop( int type );
void	DrawSphere( int type );
void	DrawPillar( int type );

// APPEND START FP)K.YAJIMA 2015.02.26
GLUI_FileBrowser *fb;
// APPEND END FP)K.YAJIMA 2015.02.26

//描画するオブジェクトの種類

#define	CROP		1
#define	SPHERE		2
#define	PILLAR		3
#define	PILLARXY	3
#define	PILLARYZ	4
#define	PILLARXZ	5

//視点
#define	NO_SEL	0			//未選択
#define	X_VIEW	1			//X軸視点
#define	Y_VIEW	2			//Y軸視点
#define	Z_VIEW	3			//Z軸視点

//ボタンの状態
#define	ON	1
#define	OFF	0

//フラグの状態
#define	FALSE	0
#define	TRUE	1

//メインウィンドウ・サイズ(テスト用）
#define	MAINWINDOW_W	300
#define	MAINWINDOW_H	300

//デフォルトウィンドウ・サイズ
#define	WINDOW_W		660
#define	WINDOW_H		660

//ビューポート・サイズ(ウィンドウ・サイズの 1 / 2)
#define	VIEWPORT_WIDTH	330
#define	VIEWPORT_HEIGHT	330

//法線の長さ
#define	VEC_LEN			0.8

//法線の表示領域のサイズ
#define	VECTOR_VIEW_SIZE	80

//π
#define	PI			3.1415

//拡大/縮小の割合
#define	REDSCALE		0.9F		//縮小スケール
#define	MAGSCALE		1.1F		//拡大スケール
#define	SCALEMAX		2.0F		//拡大最大倍率
#define	SCALEMIN		0.01F		//拡大最小倍率

#define	COORDNATESMAX	1.0F		//座標の最大値
#define	COORDNATESMIN	-1.0F		//	〃	最小値

#define	RADIUSMAX	1.0F		//球体・円柱の半径最大値
#define	RADIUSMIN	0.0F	//	0.01F		//		〃		  最小値
#define	HEIGHTMAX	2.0F	//円柱の高さ最大値
#define	HEIGHTMIN	0.0F	//		0.01F		//		〃	最小値

//SIDE数
//#define	SIDES		8
#define	SIDES		16

//PBVRウィンドウ用倍率
#define	PBVRSCALE	3.0F
//#define	PBVRSCALE	5.0F

//3VDウィンドウ用倍率
#define	WIN3VDSCALE	0.5F

//CROPのデフォルト値

#define	CROPXMIN	-0.5F
#define	CROPXMAX	0.5F
#define	CROPYMIN	-0.5F
#define	CROPYMAX	0.5F
#define	CROPZMIN	-0.5F
#define	CROPZMAX	0.5F
/*
#define CROPXMIN        -0.714F
#define CROPXMAX         0.714F
#define CROPYMIN        -0.357F
#define CROPYMAX         0.357F
#define CROPZMIN        -1.0F
#define CROPZMAX         1.0F
*/
//SPHEREのデフォルト値
#define	SRADIUS	1.0F //0.5F

//PILLARのデフォルト値
#define	PRADIUS	1.0F //0.5F
#define	PHEIGHT	1.0F //0.8F

//変形、移動処理のモード
#define BIT(num)		((unsigned int)1 << (num))
#define MODIFIMODE		BIT(0)				//変形モードON
#define RIGHTSIDE		BIT(1)				//右サイド
#define LEFTSIDE		BIT(2)				//左サイド
#define TOPSIDE			BIT(3)				//上サイド
#define BOTTOMSIDE		BIT(4)				//下サイド
#define SURFSIDE		BIT(5)				//前サイド
#define DEPTHSIDE		BIT(6)				//奥サイド

#define SOLID			0					//オブジェクトの塗りつぶし指定
#define WIRE			1					//ワイヤーフレーム
#define ALPHA			0.3F				//アルファ値

// cropping parameter
CropParam* paramCrop;

void setCropParam(CropParam* param)
{
    paramCrop = param;
}

CropParam* getCropParam()
{
    return paramCrop;
}

float rotate[16] = {
  1,0,0,0,
  0,1,0,0,
  0,0,1,0,
  0,0,0,1
};

//PBVR最大／最小座標値(サーバー（Command::generateAbstractParticles）より)
extern	float	PVBRmaxcoords[3];
extern	float	PVBRmincoords[3];

int	obj_sel				= CROP-1;			//表示するオブジェクトタイプの選択
int	obj_3d				= CROP;

int	iwin_3vd;								//３面図用ウィンドウのID
int	clicking			= OFF;				//マウスの左ボタン押下状態
int	win_sel				= NO_SEL;			//ビューポート選択状態
int	modifier			= OFF;				//特殊キー押下状態
unsigned int ModifyMode = OFF;				//変形モード
unsigned int CropTrans	= OFF;				//CROP座標変換モード
int	WindowWidth			= WINDOW_W;			//現在のウィンドウ・サイズ(幅）
int	WindowHeight		= WINDOW_H;			//現在のウィンドウ・サイズ(高さ）
float	mapscale;							//現在の座標系の倍率
float	PBVRscale		= PBVRSCALE;		//PBVRウィンドウの座標系の倍率
#ifdef NOTOPEN
int	crop_flg			= TRUE;				//領域選択有効フラグ
#else
int	crop_flg			= FALSE;			//領域選択有効フラグ
#endif
double	PBVRCoordScale;						//PVBR座標変換スケール
double	PBVRxmin, PBVRxmax, PBVRymin, PBVRymax, PBVRzmin, PBVRzmax;							//PBVR最大／最小値
double	PBVRxminChk, PBVRxmaxChk, PBVRyminChk, PBVRymaxChk, PBVRzminChk, PBVRzmaxChk;		//PBVR最大／最小値チェック用（立方体空間）
double	PBVRsides;																			//PBVR領域の最大の辺
float	Xmin, Xmax, Ymin, Ymax, Zmin, Zmax;													//3vdウインドウ内で取りうる最大値／最小値
float	CropXmin, CropXmax, CropYmin, CropYmax, CropZmin, CropZmax;							//Cropの座標の最大値／最小値（-1.0〜1.0）
float	SphereXmin, SphereXmax, SphereYmin, SphereYmax, SphereZmin, SphereZmax;				//Sphereの座標の最大値／最小値（-1.0〜1.0）
float	PillarXYXmin, PillarXYXmax, PillarXYYmin, PillarXYYmax, PillarXYZmin, PillarXYZmax;	//PillarXYの座標の最大値／最小値（-1.0〜1.0）
float	PillarYZXmin, PillarYZXmax, PillarYZYmin, PillarYZYmax, PillarYZZmin, PillarYZZmax;	//PillarYZの座標の最大値／最小値（-1.0〜1.0）
float	PillarXZXmin, PillarXZXmax, PillarXZYmin, PillarXZYmax, PillarXZZmin, PillarXZZmax;	//PillarXZの座標の最大値／最小値（-1.0〜1.0）


//３面図表示（本体組み込み時には、これをコールする）

void	Win3vd( void );
// APPEND START FP)K.YAJIMA 2015.03.11

void	FILEpanelCreate( void );
// APPEND END FP)K.YAJIMA 2015.03.11

void	sel_3vd(int num);

void	glDrawxisd(double length, int dirx, int diry, int dirz, int viewport_x, int viewport_y);
void	disp_str( float x, float  y, float z, const char* str );
void	draw_frame( double size );

void	init_3vd(int winid);
void	end_3vd(int winid);

double	degree2Radian( double degree );
int		CalculateNormal( float* p1, float* p2, float* p3, float* n );

void	PBVRScaling(void);
void	CalcCoordnatesScaling( double xmin, double xmax, 
		double ymin, double ymax, double zmin, double zmax, double* sides, double* CScale );

void	Calc3vdCoord( float max, float min, float p, float* point );
void	CalcPBVRCoord( float max, float min, float p, float* point );
void	init_PBVRpara( void );
void	set_3vdmax( float max, float min, float* areamax, float* areamin ); 
void	set_PBVRmax( double max, double min, double* areamax, double* areamin ); 
void	SetCropMaxMin( float x, float y, float z );
void	SetSphereMaxMin( float x, float y, float z, float rad );
void	SetPillarXYMaxMin( float x, float y, float z, float rad, float heigttop, float heigtbase );
void	SetPillarYZMaxMin( float x, float y, float z, float rad, float heigttop, float heigtbase );
void	SetPillarXZMaxMin( float x, float y, float z, float rad, float heigttop, float heigtbase );

//各種コールバック

void	display_3vd(void);

void	gluiCallback(int num);
void	gui_Reset( int num );
void	gui_Apply( int num );
void	Resize( int w, int h );

void	MouseFunc( int button, int state, int x, int y);
void	MouseCropX( int button, int state, int x, int y);
void	MouseCropY( int button, int state, int x, int y);
void	MouseCropZ( int button, int state, int x, int y);
void	MouseSphereX( int button, int state, int x, int y);
void	MouseSphereY( int button, int state, int x, int y);
void	MouseSphereZ( int button, int state, int x, int y);
void	MousePillarXY_X( int button, int state, int x, int y);
void	MousePillarXY_Y( int button, int state, int x, int y);
void	MousePillarXY_Z( int button, int state, int x, int y);
void	MousePillarXZ_X( int button, int state, int x, int y);
void	MousePillarXZ_Y( int button, int state, int x, int y);
void	MousePillarXZ_Z( int button, int state, int x, int y);
void	MousePillarYZ_X( int button, int state, int x, int y);
void	MousePillarYZ_Y( int button, int state, int x, int y);
void	MousePillarYZ_Z( int button, int state, int x, int y);

void	MouseMotion( int x, int y );
void	MotionCropX( int x, int y );
void	MotionCropY( int x, int y );
void	MotionCropZ( int x, int y );
void	MotionSphereX( int x, int y );
void	MotionSphereY( int x, int y );
void	MotionSphereZ( int x, int y );
void	MotionPillarXY_X( int x, int y );
void	MotionPillarXY_Y( int x, int y );
void	MotionPillarXY_Z( int x, int y );
void	MotionPillarXZ_X( int x, int y );
void	MotionPillarXZ_Y( int x, int y );
void	MotionPillarXZ_Z( int x, int y );
void	MotionPillarYZ_X( int x, int y );
void	MotionPillarYZ_Y( int x, int y );
void	MotionPillarYZ_Z( int x, int y );

void	SpecialFunc( int key, int x, int y );
void	SpecialFuncCropX( int key, int x, int y );
void	SpecialFuncCropY( int key, int x, int y );
void	SpecialFuncCropZ( int key, int x, int y );
void	SpecialFuncSphereX( int key, int x, int y );
void	SpecialFuncSphereY( int key, int x, int y );
void	SpecialFuncSphereZ( int key, int x, int y );
void	SpecialFuncPillarXY_X( int key, int x, int y );
void	SpecialFuncPillarXY_Y( int key, int x, int y );
void	SpecialFuncPillarXY_Z( int key, int x, int y );
void	SpecialFuncPillarXZ_X( int key, int x, int y );
void	SpecialFuncPillarXZ_Y( int key, int x, int y );
void	SpecialFuncPillarXZ_Z( int key, int x, int y );
void	SpecialFuncPillarYZ_X( int key, int x, int y );
void	SpecialFuncPillarYZ_Y( int key, int x, int y );
void	SpecialFuncPillarYZ_Z( int key, int x, int y );

//編集可能テキストボックス用コールバック

void	cbcxminlevel2(int num);
void	cbcyminlevel2(int num);
void	cbczminlevel2(int num);
void	cbcxmaxlevel2(int num);
void	cbcymaxlevel2(int num);
void	cbczmaxlevel2(int num);
void	cbsradius(int num);
void	cbscenterx(int num);
void	cbscentery(int num);
void	cbscenterz(int num);
void	cbpradius(int num);
void	cbpheight(int num);
void	cbpcenterx(int num);
void	cbpcentery(int num);
void	cbpcenterz(int num);

void	CropCallback(int num);

// APPEND START FP)K.YAJIMA 2015.02.20
void	FileCallback(int num);
void	FdCallback(int num);
void	ParticleCallback(int num);
void    control_Fd_cb(int control);//ファイルブラウザ
void	DdCallback(int num);
void    control_Dd_cb(int control);//ディレクトリブラウザ

bool	FileCallback_Cancel = false;
// APPEND END FP)K.YAJIMA 2015.02.20
// APPEND START FP)M.Tanaka 2015.03.05
void    cbfileclose(int num);
GLUI* g_glui_filepanel;
// APPEND END   FP)M.Tanaka 2015.03.05

//GUIパネル用

int SubWinID; 						//サブウィンドウのID

GLUI *glui_3vd;
GLUI_Panel      *obj_panel;
GLUI_RadioGroup *obj_sel_b;

float cxminlevel2 = CROPXMIN;						//CROP座標計算用
float cxmaxlevel2 = CROPXMAX;
float cyminlevel2 = CROPYMIN;
float cymaxlevel2 = CROPYMAX;
float czminlevel2 = CROPZMIN;
float czmaxlevel2 = CROPZMAX;

float tbcxminlevel = CROPXMIN;						//CROPテキストボックス入力用
float tbcxmaxlevel = CROPXMAX;
float tbcyminlevel = CROPYMIN;
float tbcymaxlevel = CROPYMAX;
float tbczminlevel = CROPZMIN;
float tbczmaxlevel = CROPZMAX;

float rgcxminlevel = CROPXMIN;						//CROP選択領域受け渡し用
float rgcxmaxlevel = CROPXMAX;
float rgcyminlevel = CROPYMIN;
float rgcymaxlevel = CROPYMAX;
float rgczminlevel = CROPZMIN;
float rgczmaxlevel = CROPZMAX;

float save_cxmin	= CROPXMIN;
float save_cxmax	= CROPXMAX;
float save_cymin	= CROPYMIN;
float save_cymax	= CROPYMAX;
float save_czmin	= CROPZMIN;
float save_czmax	= CROPZMAX;

float sradius = SRADIUS;							//SPHERE座標計算用
float scenterx = 0.0F;
float scentery = 0.0F;
float scenterz = 0.0F;

float tbsradius = SRADIUS;							//SPHEREテキストボックス入力用
float tbscenterx = 0.0F;
float tbscentery = 0.0F;
float tbscenterz = 0.0F;

float rgsradius = SRADIUS;							//SPHERE選択領域受け渡し用
float rgscenterx = 0.0F;
float rgscentery = 0.0F;
float rgscenterz = 0.0F;

float save_sradius = SRADIUS;						//SPHERE変形処理時のサイズ保存用

float pradius = PRADIUS;							//PILLAR座標計算用
float pheight = PHEIGHT;
float pcenterx = 0.0F;
float pcentery = 0.0F;
float pcenterz = -0.5F; //0.0F;

float tbpradius;									//PILLARテキストボックス入力用
float tbpheight;
float tbpcenterx;
float tbpcentery;
float tbpcenterz;

float rgpradius;									//PILLAR選択領域受け渡し用
float rgpheight;
float rgpcenterx;
float rgpcentery;
float rgpcenterz;

float save_pradius = PRADIUS;						//PILLAR変形処理時のサイズ保存用
float save_pheight = PHEIGHT;

float save_pYZradius = PRADIUS;
float save_pYZheight = PHEIGHT;

float save_pXZradius = PRADIUS;
float save_pXZheight = PHEIGHT;

GLUI_EditText *crop_cxmin2;
GLUI_EditText *crop_cxmax2;
GLUI_EditText *crop_cymin2;
GLUI_EditText *crop_cymax2;
GLUI_EditText *crop_czmin2;
GLUI_EditText *crop_czmax2;

GLUI_EditText *sphere_radius;
GLUI_EditText *sphere_centerx;
GLUI_EditText *sphere_centery;
GLUI_EditText *sphere_centerz;

GLUI_EditText *pillar_radius;
GLUI_EditText *pillar_height;
GLUI_EditText *pillar_centerx;
GLUI_EditText *pillar_centery;
GLUI_EditText *pillar_centerz;

GLUI_Panel *obj_panelcr_col;

// APPEND START FP)M.Tanaka 2015.03.02
GLUI_Button* g_btn_vdd;
// APPEND END   FP)M.Tanaka 2015.03.02

//パラメータセット用クラス

class	ParamCrop{
	public:
		float paramcxmin;
		float paramcxmax;
		float paramcymin;
		float paramcymax;
		float paramczmin;
		float paramczmax;

		ParamCrop();
		void	CropParaSet();
};

class	ParamSphere{
	public:
		float paramsradius;
		float paramscenterx;
		float paramscentery;
		float paramscenterz;

		ParamSphere();
		void	SphereParaSet();
};

class	ParamPillar{
	public:
		float parampradius;
		float parampheight;
		float parampcenterx;
		float parampcentery;
		float parampcenterz;

		ParamPillar();
		void	PillarParaSet();
};

class	Param3vd	:	public ParamCrop, 
					public ParamSphere, 
					public ParamPillar{
	public:
		int	sel_area;							//選択領域の形状（ CROP or SPHERE or PILLAR )
		int	Apply;								//APPLYボタン押下フラグ（本体側でOFFにする）
		Param3vd();
};

ParamCrop::ParamCrop(){
	paramcxmin  = cxminlevel2;
	paramcxmax  = cxmaxlevel2;
	paramcymin  = cyminlevel2;
	paramcymax  = cymaxlevel2;
	paramczmin  = czminlevel2;
	paramczmax  = czmaxlevel2;
}

ParamSphere::ParamSphere(){
	paramsradius  = sradius;
	paramscenterx = scenterx;
	paramscentery = scentery;
	paramscenterz = scenterz;
}

ParamPillar::ParamPillar(){
	parampradius  = pradius;
	parampheight  = pheight;
	parampcenterx = pcenterx;
	parampcentery = pcentery;
	parampcenterz = pcenterz;
}

Param3vd::Param3vd(){
	sel_area = CROP;
	Apply = OFF;
}

//オブジェクト操作用クラス
class	Motion{
	public:
		int	prev_x;												//マウスボタン押下時のX座標
		int	prev_y;												//		〃			  Y座標
		int	prev_z;												//		〃			  Z座標
		int	save_x;												//マウスボタンUP時の移動量のX座標
		int	save_y;												//		〃			        Y座標
		int	save_z;												//		〃			        Z座標
		double	scale_x;										//X軸方向の拡大/縮小倍率
		double	scale_y;										//Y軸方向		〃
		double	scale_z;										//Z軸方向		〃
		int	move_x;												//オブジェクトのの移動量のX座標
		int	move_y;												//		〃			  	  Y座標
		int	move_z;												//		〃			 	  Z座標

		Motion();
		void	motion_init();
		void	set_prev( int x, int y, int z );
		void	set_pos(  int x, int y, int z );
		void	scaling( float x, float y, float z );
		void	set_scale( float x, float y, float z );
		void	save_pos( int x, int y, int z );
		void	obj_ctl();
};

//領域選択用オブジェクトのクラス
//直方体
class	Crop : public	Motion{
	public:
		int		sides;											//SIDE数
		double	side_len;										//一辺の長さ(初期値）
		float	side_x;											//X軸方向の一辺の長さ（side_len * scale_x)
		float	side_y;											//Y    〃
		float	side_z;											//Z    〃
		Crop();
		void	crop_init(int flag=0);
		void	draw_crop( int angle, int dirx, int diry, int dirz, int type );
		void	crop_scaling( float scalex, float scaley, float scalez );
		void	set_crop_textdata(void);
		void	set_crop_textbox(void);
};

//球体
class	Sphere : public	Motion{
	public:
		double	radius;											//半径（0〜1.0）
		int		sides;											//SIDE数
		float	center_x;										//-1.0〜1.0
		float	center_y;										//	〃
		float	center_z;										//	〃
		float	save_center_x;									//マウスボタンUP時の中心座標
		float	save_center_y;									//	〃
		float	save_center_z;									//	〃
		double	save_radius;									//マウスボタンUP時の半径

		Sphere();
		void	sphere_init(int flag=0);
		void	draw_sphere(int angle ,int dirx, int diry, int dirz, int type );
		void	sphere_scaling( float scalex, float scaley, float scalez );
		void	set_sphere_textdata(void);
		void	set_sphere_textbox(void);
};

//円柱
class	Pillar : public	Motion{
	public:
		double	radius;											//半径（0〜1.0）
		double	height;											//高さ（0〜2.0）
		int		sides; ;										//SIDE数
		float	center_x;										//中心座標（-1.0〜1.0）
		float	center_y;										//	〃
		float	center_z;										//	〃
		float	save_center_x;									//マウスボタンUP時の中心座標
		float	save_center_y;									//	〃
		float	save_center_z;									//	〃
		double	save_height;  									//マウスボタンUP時の高さ
		double	save_radius;  									//マウスボタンUP時の半径

		float	save_tbpradius;									//PILLARテキストボックス入力値保存用
		float	save_tbpheight;
		float	save_tbpcenterx;
		float	save_tbpcentery;
		float	save_tbpcenterz;

		Pillar();
		void	pillar_init(int flag=0);
		void	draw_pillar( int angle ,int dirx, int diry, int dirz, int type );
		void	pillar_scaling( float scalex, float scaley, float scalez );
		void	set_pillar_textdata( void );
		void	set_pillar_textbox (void );
		void	reload_pillar_textbox (void );
		void	reload_pillar(void);
		void	PillarChkTextBox( void );
};

Motion::Motion()
{
	prev_x = 0;
	prev_y = 0;
	prev_z = 0;
	move_x = 0;
	move_y = 0;
	move_z = 0;
	save_x = 0;
	save_y = 0;
	save_z = 0;
	scale_x = 1.0;
	scale_y = 1.0;
	scale_z = 1.0;	
}

Sphere::Sphere()
{
	radius = SRADIUS;
	sides = SIDES;
	center_x = 0.0F;
	center_y = 0.0F;
	center_z = 0.0F;
	save_center_x = 0.0F;
	save_center_y = 0.0F;
	save_center_z = 0.0F;
	save_radius = PRADIUS;
}

Crop::Crop()
{
	side_len = 1.0;
	sides = SIDES;
	side_x = 1.0;
	side_y = 1.0;
	side_z = 1.0;
}

Pillar::Pillar()
{
	radius = PRADIUS;
	height = PHEIGHT;
	sides = SIDES;
	center_x = 0.0F;
	center_y = 0.0F;
	center_z = -0.5F; //0.0F;
	save_center_x = 0.0F;
	save_center_y = 0.0F;
	save_center_z = -0.5F; //0.0F;
	save_radius = PRADIUS;
	save_height = PHEIGHT;

	save_tbpradius  = tbpradius;
	save_tbpheight  = tbpheight;
	save_tbpcenterx = tbpcenterx;
	save_tbpcentery = tbpcentery;
	save_tbpcenterz = tbpcenterz;
}


//表示するオブジェクトの生成
	Crop	crop;
	Sphere	sphere;
	Pillar	pillar, pillarYZ, pillarXZ;

//パラメータ用オブジェクトの生成
	Param3vd	param3vd;

//kvs オブジェクト描画用配列

//CROP
#ifdef NOTOPEN
	GLfloat	verticesCrop[8*3];
	float	NormalArrayCrop[6*3];
	int		ConnectionArrayCrop[6*4] = {
#else
	kvs::Real32	verticesCrop[8*3];
	kvs::Real32	NormalArrayCrop[6*3];
	kvs::UInt32	ConnectionArrayCrop[6*4] = {
#endif
		 4, 0, 1, 5 ,											//左
		 5, 1, 2, 6 ,											//前
		 6, 2, 3, 7 ,											//右
		 7, 3, 0, 4 ,											//後
		 4, 5, 6, 7 ,											//上
		 1, 0, 3, 2 											//下
	};

//SPHERE
#ifdef NOTOPEN
	GLfloat	verticesSphere[(2+SIDES*(SIDES-1))*3];
	float	NormalArraySphere[(SIDES*2+SIDES*2*(SIDES-2))*3];
	int		ConnectionArraySphere[(SIDES*2+SIDES*2*(SIDES-2))*3];
#else
	kvs::Real32	verticesSphere[(2+SIDES*(SIDES-1))*3];
	kvs::Real32	NormalArraySphere[(SIDES*2+SIDES*2*(SIDES-2))*3];
	kvs::UInt32	ConnectionArraySphere[(SIDES*2+SIDES*2*(SIDES-2))*3];
#endif

//PILLAR
#ifdef NOTOPEN
	GLfloat	verticesPillar [(SIDES*2+2)*3];
	float	NormalArrayPillar[(SIDES*4)*3];
	int		ConnectionArrayPillar [(SIDES*4)*3];
#else
	kvs::Real32		verticesPillar [(SIDES*2+2)*3];
	kvs::Real32		NormalArrayPillar[(SIDES*4)*3];
	kvs::UInt32		ConnectionArrayPillar[(SIDES*4)*3];
#endif

//編集可能テキストボックス用コールバック（直方体用）
void	cbcxminlevel2(int num)
{
	//最大／最小値のチェック
	if( tbcxminlevel < PBVRxminChk )
		tbcxminlevel = PBVRxminChk;

	if( tbcxminlevel >= tbcxmaxlevel )
		tbcxminlevel = tbcxmaxlevel - SCALEMIN;

	//テキストボックス入力値を3vdウィンドウの座標に変換
	Calc3vdCoord( PBVRxmax, PBVRxmin, tbcxminlevel, &cxminlevel2 );

	crop.side_x = cxmaxlevel2 - cxminlevel2;
	crop.move_x = ( cxmaxlevel2 + cxminlevel2 ) * ( VIEWPORT_WIDTH / 2 ) / 2;
	crop.save_pos( crop.move_x, 0, 0 );
	save_cxmin = cxminlevel2;

	crop_cxmin2->set_float_val( tbcxminlevel );
	param3vd.CropParaSet();
}

void	cbcxmaxlevel2(int num)
{
	//最大／最小値のチェック
	if( tbcxmaxlevel > PBVRxmaxChk )
		tbcxmaxlevel = PBVRxmaxChk;

	if( tbcxmaxlevel <= tbcxminlevel )
		tbcxmaxlevel = tbcxminlevel + SCALEMIN;

	//テキストボックス入力値を3vdウィンドウの座標に変換
	Calc3vdCoord( PBVRxmax, PBVRxmin, tbcxmaxlevel, &cxmaxlevel2 );

	crop.side_x = cxmaxlevel2 - cxminlevel2;
	crop.move_x = ( cxmaxlevel2 + cxminlevel2 ) * ( VIEWPORT_WIDTH / 2 ) / 2;
	crop.save_pos( crop.move_x, 0, 0 );
	save_cxmax = cxmaxlevel2;

	crop_cxmax2->set_float_val( tbcxmaxlevel );
	param3vd.CropParaSet();
}

void	cbcyminlevel2(int num)
{
	//最大／最小値のチェック
	if( tbcyminlevel < PBVRyminChk )
		tbcyminlevel = PBVRyminChk;

	if( tbcyminlevel >= tbcymaxlevel )
		tbcyminlevel = tbcymaxlevel - SCALEMIN;

	//テキストボックス入力値を3vdウィンドウの座標に変換
	Calc3vdCoord( PBVRymax, PBVRymin, tbcyminlevel, &cyminlevel2 );

	crop.side_y = cymaxlevel2 - cyminlevel2;
	crop.move_y = ( cymaxlevel2 + cyminlevel2 ) * ( VIEWPORT_WIDTH / 2 ) / 2;
	crop.save_pos( 0, crop.move_y, 0 );
	save_cymin = cyminlevel2;

	crop_cymin2->set_float_val( tbcyminlevel );
	param3vd.CropParaSet();
}

void	cbcymaxlevel2(int num)
{
	//最大／最小値のチェック
	if( tbcymaxlevel > PBVRymaxChk )
		tbcymaxlevel = PBVRymaxChk;

	if( tbcymaxlevel <= tbcyminlevel )
		tbcymaxlevel = tbcyminlevel + SCALEMIN;

	//テキストボックス入力値を3vdウィンドウの座標に変換
	Calc3vdCoord( PBVRymax, PBVRymin, tbcymaxlevel, &cymaxlevel2 );

	crop.side_y = cymaxlevel2 - cyminlevel2;
	crop.move_y = ( cymaxlevel2 + cyminlevel2 ) *( VIEWPORT_WIDTH / 2 ) / 2;
	crop.save_pos( 0, crop.move_y, 0 );
	save_cymax = cymaxlevel2;

	crop_cymax2->set_float_val( tbcymaxlevel );
	param3vd.CropParaSet();
}

void	cbczminlevel2(int num)
{
	//最大／最小値のチェック
	if( tbczminlevel < PBVRzminChk )
		tbczminlevel = PBVRzminChk;

	if( tbczminlevel >= tbczmaxlevel )
		tbczminlevel = tbczmaxlevel - SCALEMIN;

	//テキストボックス入力値を3vdウィンドウの座標に変換
	Calc3vdCoord( PBVRzmax, PBVRzmin, tbczminlevel, &czminlevel2 );

	crop.side_z = czmaxlevel2 - czminlevel2;
	crop.move_z = ( czmaxlevel2 + czminlevel2 ) *(  VIEWPORT_WIDTH / 2 ) / 2;
	crop.save_pos( 0, 0, crop.move_z );
	save_czmin = czminlevel2;

	crop_czmin2->set_float_val( tbczminlevel );
	param3vd.CropParaSet();
}

void	cbczmaxlevel2(int num)
{
	//最大／最小値のチェック
	if( tbczmaxlevel > PBVRzmaxChk )
		tbczmaxlevel = PBVRzmaxChk;

	if( tbczmaxlevel <= tbczminlevel )
		tbczmaxlevel = tbczminlevel + SCALEMIN;

	//テキストボックス入力値を3vdウィンドウの座標に変換
	Calc3vdCoord( PBVRzmax, PBVRzmin, tbczmaxlevel, &czmaxlevel2 );

	crop.side_z = czmaxlevel2 - czminlevel2;
	crop.move_z = ( czmaxlevel2 + czminlevel2 ) * ( VIEWPORT_WIDTH / 2 ) / 2;
	crop.save_pos( 0, 0, crop.move_z );
	save_czmax = czmaxlevel2;

	crop_czmax2->set_float_val( tbczmaxlevel );
	param3vd.CropParaSet();
}

//編集可能テキストボックス用コールバック（球体用）
void	cbsradius(int num)
{
	sradius = tbsradius * PBVRCoordScale;
#if 0
	//最大／最小値のチェック
	if( sradius < RADIUSMIN )
	{
		sradius = RADIUSMIN;
		tbsradius = sradius / PBVRCoordScale;
	}

	else if( sradius > RADIUSMAX )
	{
		sradius = RADIUSMAX;
		tbsradius = sradius / PBVRCoordScale;
	}
#endif
	sphere.radius = sradius;
	sphere.set_scale( 1.0F , 1.0F, 1.0F );

	sphere_radius->set_float_val( tbsradius );
	param3vd.SphereParaSet();
}

void	cbscenterx(int num)
{
	//最大／最小値のチェック
	if( tbscenterx < PBVRxminChk )
		tbscenterx = PBVRxminChk;

	if( tbscenterx > PBVRxmaxChk )
		tbscenterx = PBVRxmaxChk;

	//テキストボックス入力値を3vdウィンドウの座標に変換
	Calc3vdCoord( PBVRxmax, PBVRxmin, tbscenterx, &scenterx );

	sphere.center_x = scenterx;
	sphere.move_x = sphere.center_x * ( VIEWPORT_WIDTH / 2 );
	sphere.save_pos( sphere.move_x, 0, 0 );

	sphere_centerx->set_float_val( tbscenterx );
	param3vd.SphereParaSet();
}

void	cbscentery(int num)
{
	//最大／最小値のチェック
	if( tbscentery < PBVRyminChk )
		tbscentery = PBVRyminChk;

	if( tbscentery > PBVRymaxChk )
		tbscentery = PBVRymaxChk;

	//テキストボックス入力値を3vdウィンドウの座標に変換
	Calc3vdCoord( PBVRymax, PBVRymin, tbscentery, &scentery );

	sphere.center_y = scentery;
	sphere.move_y = sphere.center_y * ( VIEWPORT_HEIGHT / 2 );
	sphere.save_pos( 0, sphere.move_y, 0 );

	sphere_centery->set_float_val( tbscentery );
	param3vd.SphereParaSet();
}

void	cbscenterz(int num)
{
	//最大／最小値のチェック
	if( tbscenterz < PBVRzminChk )
		tbscenterz = PBVRzminChk;

	if( tbscenterz > PBVRzmaxChk )
		tbscenterz = PBVRzmaxChk;

	//テキストボックス入力値を3vdウィンドウの座標に変換
	Calc3vdCoord( PBVRzmax, PBVRzmin, tbscenterz, &scenterz );

	sphere.center_z = scenterz;
	sphere.move_z = sphere.center_z * ( VIEWPORT_WIDTH / 2 );
	sphere.save_pos( 0, 0, sphere.move_z );

	sphere_centerz->set_float_val( tbscenterz );
	param3vd.SphereParaSet();
}

//編集可能テキストボックス用コールバック（円柱用）
void	cbpradius(int num)
{
	pradius = tbpradius * PBVRCoordScale;
#if 0
	//最大／最小値のチェック
	if( pradius < RADIUSMIN )
	{
		pradius = RADIUSMIN;
		tbpradius = pradius / PBVRCoordScale;
	}

	else if( pradius > RADIUSMAX )
	{
		pradius = RADIUSMAX;
		tbpradius = pradius / PBVRCoordScale;
	}
#endif
	switch( obj_3d ){

		case	PILLARXY:
			pillar.radius = pradius;
			pillar.set_scale( 1.0F , 1.0F, 1.0F );
		break;

		case	PILLARYZ:
			pillarYZ.radius = pradius;
			pillarYZ.set_scale( 1.0F , 1.0F, 1.0F );
		break;

		case	PILLARXZ:
			pillarXZ.radius = pradius;
			pillarXZ.set_scale( 1.0F , 1.0F, 1.0F );
		break;

		default:
		break;
	}

	pillar_radius->set_float_val( tbpradius );
	param3vd.PillarParaSet();
}

void	cbpheight(int num)
{
	pheight = tbpheight * PBVRCoordScale;

	//最大／最小値のチェック
	if( pheight < HEIGHTMIN )
	{
		pheight = HEIGHTMIN;
		tbpheight = pheight / PBVRCoordScale;
	}

	else if( pheight > HEIGHTMAX )
	{
		pheight = HEIGHTMAX;
		tbpheight = pheight / PBVRCoordScale;
	}

	switch( obj_3d ){

		case	PILLARXY:
			pillar.height = pheight;
			pillar.set_scale( 1.0F , 1.0F, 1.0F );
		break;

		case	PILLARYZ:
			pillarYZ.height = pheight;
			pillarYZ.set_scale( 1.0F , 1.0F, 1.0F );
		break;

		case	PILLARXZ:
			pillarXZ.height = pheight;
			pillarXZ.set_scale( 1.0F , 1.0F, 1.0F );
		break;

	default:
		break;
	}

	pillar_height->set_float_val( tbpheight );
	param3vd.PillarParaSet();
}

void	cbpcenterx(int num)
{
	//最大／最小値のチェック
	if( tbpcenterx < PBVRxminChk )
		tbpcenterx = PBVRxminChk;

	if( tbpcenterx > PBVRxmaxChk )
		tbpcenterx = PBVRxmaxChk;

	//テキストボックス入力値を3vdウィンドウの座標に変換
	Calc3vdCoord( PBVRxmax, PBVRxmin, tbpcenterx, &pcenterx );

	switch( obj_3d ){

		case	PILLARXY:
			pillar.center_x = pcenterx;
			pillar.move_x = pillar.center_x * ( VIEWPORT_WIDTH / 2 );
			pillar.save_pos( pillar.move_x, 0, 0 );
		break;

		case	PILLARYZ:
			pillarYZ.center_x = pcenterx;
			pillarYZ.move_x = pillarYZ.center_x * ( VIEWPORT_WIDTH / 2 );
			pillarYZ.save_pos( pillarYZ.move_x, 0, 0 );
		break;

		case	PILLARXZ:
			pillarXZ.center_x = pcenterx;
			pillarXZ.move_x = pillarXZ.center_x * ( VIEWPORT_WIDTH / 2 );
			pillarXZ.save_pos( pillarXZ.move_x, 0, 0 );
		break;

	default:
		break;
	}

	pillar_centerx->set_float_val( tbpcenterx );
	param3vd.PillarParaSet();
}

void	cbpcentery(int num)
{
	//最大／最小値のチェック
	if( tbpcentery < PBVRyminChk )
		tbpcentery = PBVRyminChk;

	if( tbpcentery > PBVRymaxChk )
		tbpcentery = PBVRymaxChk;

	//テキストボックス入力値を3vdウィンドウの座標に変換
	Calc3vdCoord( PBVRymax, PBVRymin, tbpcentery, &pcentery );

	switch( obj_3d ){

		case	PILLARXY:
			pillar.center_y = pcentery;
			pillar.move_y = pillar.center_y * ( VIEWPORT_WIDTH / 2 );
			pillar.save_pos( 0, pillar.move_y, 0 );
		break;

		case	PILLARYZ:
			pillarYZ.center_y = pcentery;
			pillarYZ.move_y = pillarYZ.center_y * ( VIEWPORT_WIDTH / 2 );
			pillarYZ.save_pos( 0, pillarYZ.move_y, 0 );
		break;

		case	PILLARXZ:
			pillarXZ.center_y = pcentery;
			pillarXZ.move_y = pillarXZ.center_y * ( VIEWPORT_WIDTH / 2 );
			pillarXZ.save_pos( 0, pillarXZ.move_y, 0 );
		break;

	default:
		break;
	}

	pillar_centery->set_float_val( tbpcentery );
	param3vd.PillarParaSet();
}

void	cbpcenterz(int num)
{
	//最大／最小値のチェック
	if( tbpcenterz < PBVRzminChk )
		tbpcenterz = PBVRzminChk;

	if( tbpcenterz > PBVRzmaxChk )
		tbpcenterz = PBVRzmaxChk;

	//テキストボックス入力値を3vdウィンドウの座標に変換
	Calc3vdCoord( PBVRzmax, PBVRzmin, tbpcenterz, &pcenterz );

	switch( obj_3d ){

		case	PILLARXY:
			pillar.center_z = pcenterz;
			pillar.move_z = pillar.center_z * ( VIEWPORT_WIDTH / 2 );
			pillar.save_pos( 0, 0, pillar.move_z );
		break;

		case	PILLARYZ:
			pillarYZ.center_z = pcenterz;
			pillarYZ.move_z = pillarYZ.center_z * ( VIEWPORT_WIDTH / 2 );
			pillarYZ.save_pos( 0, 0, pillarYZ.move_z );

		case	PILLARXZ:
			pillarXZ.center_z = pcenterz;
			pillarXZ.move_z = pillarXZ.center_z * ( VIEWPORT_WIDTH / 2 );
			pillarXZ.save_pos( 0, 0, pillarXZ.move_z );
		break;

		break;
	default:
		break;
	}

	pillar_centerz->set_float_val( tbpcenterz );
	param3vd.PillarParaSet();
}

//CROP テキストボックスに値をセット
void	Crop::set_crop_textbox(void)
{
	CalcPBVRCoord( PBVRxmax, PBVRxmin, cxminlevel2, &tbcxminlevel );
	CalcPBVRCoord( PBVRxmax, PBVRxmin, cxmaxlevel2, &tbcxmaxlevel );
	CalcPBVRCoord( PBVRymax, PBVRymin, cyminlevel2, &tbcyminlevel );
	CalcPBVRCoord( PBVRymax, PBVRymin, cymaxlevel2, &tbcymaxlevel );
	CalcPBVRCoord( PBVRzmax, PBVRzmin, czminlevel2, &tbczminlevel );
	CalcPBVRCoord( PBVRzmax, PBVRzmin, czmaxlevel2, &tbczmaxlevel );

	crop_cxmax2->set_float_val( tbcxmaxlevel );
	crop_cxmin2->set_float_val( tbcxminlevel );
	crop_cymax2->set_float_val( tbcymaxlevel );
	crop_cymin2->set_float_val( tbcyminlevel );
	crop_czmax2->set_float_val( tbczmaxlevel );
	crop_czmin2->set_float_val( tbczminlevel );
}

//SPHERE テキストボックスに値をセット
void	Sphere::set_sphere_textbox(void)
{
	CalcPBVRCoord( PBVRxmax, PBVRxmin, scenterx, &tbscenterx );
	CalcPBVRCoord( PBVRymax, PBVRymin, scentery, &tbscentery );
	CalcPBVRCoord( PBVRzmax, PBVRzmin, scenterz, &tbscenterz );
	tbsradius = sradius / PBVRCoordScale;

	sphere_radius->set_float_val( tbsradius );
	sphere_centerx->set_float_val( tbscenterx );
	sphere_centery->set_float_val( tbscentery );
	sphere_centerz->set_float_val( tbscenterz );
}

//PILLAR テキストボックスに値をセット
void	Pillar::set_pillar_textbox(void)
{
	pradius  = radius;
	pheight  = height;
	pcenterx = center_x;
	pcentery = center_y;
	pcenterz = center_z;

	CalcPBVRCoord( PBVRxmax, PBVRxmin, pcenterx, &tbpcenterx );
	CalcPBVRCoord( PBVRymax, PBVRymin, pcentery, &tbpcentery );
	CalcPBVRCoord( PBVRzmax, PBVRzmin, pcenterz, &tbpcenterz );

	tbpradius = pradius / PBVRCoordScale;
	tbpheight = pheight / PBVRCoordScale;

	pillar_radius->set_float_val( tbpradius );
	pillar_height->set_float_val( tbpheight );
	pillar_centerx->set_float_val( tbpcenterx );
	pillar_centery->set_float_val( tbpcentery );
	pillar_centerz->set_float_val( tbpcenterz );

	save_tbpradius = tbpradius;
	save_tbpheight = tbpheight;
	save_tbpcenterx = tbpcenterx;
	save_tbpcentery = tbpcentery;
	save_tbpcenterz = tbpcenterz;
}

//PILLAR テキストボックスに値をリロード
void	Pillar::reload_pillar_textbox(void)
{
	pillar_radius->set_float_val( save_tbpradius );
	pillar_height->set_float_val( save_tbpheight );
	pillar_centerx->set_float_val( save_tbpcenterx );
	pillar_centery->set_float_val( save_tbpcentery );
	pillar_centerz->set_float_val( save_tbpcenterz );
}

//PILLAR テキストボックスセーブ値をリロード
void	Pillar::reload_pillar(void)
{
	save_tbpradius = tbpradius;
	save_tbpheight = tbpheight;
	save_tbpcenterx = tbpcenterx;
	save_tbpcentery = tbpcentery;
	save_tbpcenterz = tbpcenterz;
}

//CROP テキストボックスに値を計算してセット
void	Crop::set_crop_textdata(void)
{
//	printf("before : cxminlevel2=%f cxmaxlevel2=%f\n",cxminlevel2,cxmaxlevel2);
	cxmaxlevel2 = ( crop.side_x / (float)2 ) + ( move_x / ((float)VIEWPORT_WIDTH/2 ));
	cxminlevel2 = cxmaxlevel2 - side_x;

	cymaxlevel2 = ( crop.side_y / (float)2 ) + ( move_y / ((float)VIEWPORT_HEIGHT/2 ));
	cyminlevel2 = cymaxlevel2 - side_y;

	czmaxlevel2 = ( crop.side_z / (float)2 ) + ( move_z / ((float)VIEWPORT_WIDTH/2 ));
	czminlevel2 = czmaxlevel2 - side_z;

	set_crop_textbox();
//	printf("After : cxminlevel2=%f cxmaxlevel2=%f\n",cxminlevel2,cxmaxlevel2);
}

//SPHERE テキストボックスに値を計算してセット
void	Sphere::set_sphere_textdata(void)
{
	center_x = ( move_x / ((float)VIEWPORT_WIDTH/2 ));
	center_y = ( move_y / ((float)VIEWPORT_HEIGHT/2 ));
	center_z = ( move_z / ((float)VIEWPORT_WIDTH/2 ));

	sradius  = radius;
	scenterx = center_x;
	scentery = center_y;
	scenterz = center_z;

	set_sphere_textbox();
}

//PILLAR テキストボックスに値を計算してセット
void	Pillar::set_pillar_textdata(void)
{
	center_x = ( move_x / ((float)VIEWPORT_WIDTH/2 ));
	center_y = ( move_y / ((float)VIEWPORT_HEIGHT/2 ));
	center_z = ( move_z / ((float)VIEWPORT_WIDTH/2 ));

	set_pillar_textbox();
}

//guiパネルを表示するサブウィンドウのコールバック
void display_cont(void)
{
	glutSetWindow( SubWinID );
	glClear(GL_COLOR_BUFFER_BIT);

//gui ウィンドウと同じ灰色でウィンドウをクリア
  	glClearColor(0.8, 0.8, 0.8, 1.0);

	glutSwapBuffers();
	glutPostRedisplay();
}

//サブウィンドウにguiパネルを表示
void	gui_panel(){

//サブウィンドウ生成
   SubWinID = glutCreateSubWindow(iwin_3vd, 0, VIEWPORT_HEIGHT, VIEWPORT_WIDTH,VIEWPORT_HEIGHT);						//左上原点
   glui_3vd = GLUI_Master.create_glui_subwindow( SubWinID, GLUI_SUBWINDOW_BOTTOM );
   glutDisplayFunc(display_3vd);

//   glui_3vd->set_main_gfx_window( SubWinID );
//   glutDisplayFunc(display_cont);

 //---------------
	GLUI_Panel *obj_panelcr = glui_3vd->add_panel("CROP", 1);
	obj_panelcr->set_alignment(GLUI_ALIGN_LEFT);

	crop_cxmin2 = glui_3vd->add_edittext_to_panel(obj_panelcr, "            XMIN:", GLUI_EDITTEXT_FLOAT, &tbcxminlevel, 1, cbcxminlevel2 );
	crop_cxmin2->set_alignment(GLUI_ALIGN_RIGHT);
	crop_cxmin2->set_w(80);

	crop_cxmax2 = glui_3vd->add_edittext_to_panel(obj_panelcr, "XMAX:", GLUI_EDITTEXT_FLOAT, &tbcxmaxlevel, 1, cbcxmaxlevel2 );
	crop_cxmax2->set_alignment(GLUI_ALIGN_RIGHT);
	crop_cxmax2->set_w(80);

	crop_cymin2 = glui_3vd->add_edittext_to_panel(obj_panelcr, "YMIN:", GLUI_EDITTEXT_FLOAT, &tbcyminlevel, 1, cbcyminlevel2 );
	crop_cymin2->set_alignment(GLUI_ALIGN_RIGHT);
	crop_cymin2->set_w(80);

	crop_cymax2 = glui_3vd->add_edittext_to_panel(obj_panelcr, "YMAX:", GLUI_EDITTEXT_FLOAT, &tbcymaxlevel, 1, cbcymaxlevel2 );
	crop_cymax2->set_alignment(GLUI_ALIGN_RIGHT);
	crop_cymax2->set_w(80);

	crop_czmin2 = glui_3vd->add_edittext_to_panel(obj_panelcr, "ZMIN:", GLUI_EDITTEXT_FLOAT, &tbczminlevel, 1, cbczminlevel2 );
	crop_czmin2->set_alignment(GLUI_ALIGN_RIGHT);
	crop_czmin2->set_w(80);

	crop_czmax2 = glui_3vd->add_edittext_to_panel(obj_panelcr, "ZMAX:", GLUI_EDITTEXT_FLOAT, &tbczmaxlevel, 1, cbczmaxlevel2 );
	crop_czmax2->set_alignment(GLUI_ALIGN_RIGHT);
	crop_czmax2->set_w(80);

//--------------------

	GLUI_Panel *obj_panelcr_sp = glui_3vd->add_panel("SPHERE", 1);
	obj_panelcr_sp->set_alignment(GLUI_ALIGN_RIGHT);

	sphere_radius = glui_3vd->add_edittext_to_panel(obj_panelcr_sp, "         RADIUS:", GLUI_EDITTEXT_FLOAT, &tbsradius, 1, cbsradius );
	sphere_radius->set_alignment(GLUI_ALIGN_RIGHT);
	sphere_radius->set_w(80);

	sphere_centerx = glui_3vd->add_edittext_to_panel(obj_panelcr_sp, "CENTER X:", GLUI_EDITTEXT_FLOAT, &tbscenterx, 1, cbscenterx );
	sphere_centerx->set_alignment(GLUI_ALIGN_RIGHT);
	sphere_centerx->set_w(80);

	sphere_centery = glui_3vd->add_edittext_to_panel(obj_panelcr_sp, "CENTER Y:", GLUI_EDITTEXT_FLOAT, &tbscentery, 1, cbscentery );
	sphere_centery->set_alignment(GLUI_ALIGN_RIGHT);
	sphere_centery->set_w(80);

	sphere_centerz = glui_3vd->add_edittext_to_panel(obj_panelcr_sp, "CENTER Z:", GLUI_EDITTEXT_FLOAT, &tbscenterz, 1, cbscenterz );
	sphere_centerz->set_alignment(GLUI_ALIGN_RIGHT);
	sphere_centerz->set_w(80);

	glui_3vd->add_statictext("");

	glui_3vd->add_button("APPLY", 0, gui_Apply);

	glui_3vd->add_column(true);

//--------------------
	obj_panelcr_col = glui_3vd->add_panel("PILLAR", 1);
	obj_panelcr_col->set_alignment(GLUI_ALIGN_RIGHT);

	pillar_radius = glui_3vd->add_edittext_to_panel(obj_panelcr_col, "         RADIUS:", GLUI_EDITTEXT_FLOAT, &tbpradius, 1, cbpradius );
	pillar_radius->set_alignment(GLUI_ALIGN_RIGHT);
	pillar_radius->set_w(80);

	pillar_height = glui_3vd->add_edittext_to_panel(obj_panelcr_col, "HEIGHT:", GLUI_EDITTEXT_FLOAT, &tbpheight, 1, cbpheight );
	pillar_height->set_alignment(GLUI_ALIGN_RIGHT);
	pillar_height->set_w(80);

	pillar_centerx = glui_3vd->add_edittext_to_panel(obj_panelcr_col, "CENTER X:", GLUI_EDITTEXT_FLOAT, &tbpcenterx, 1, cbpcenterx );
	pillar_centerx->set_alignment(GLUI_ALIGN_RIGHT);
	pillar_centerx->set_w(80);

	pillar_centery = glui_3vd->add_edittext_to_panel(obj_panelcr_col, "CENTER Y:", GLUI_EDITTEXT_FLOAT, &tbpcentery, 1, cbpcentery );
	pillar_centery->set_alignment(GLUI_ALIGN_RIGHT);
	pillar_centery->set_w(80);

	pillar_centerz = glui_3vd->add_edittext_to_panel(obj_panelcr_col, "CENTER Z:", GLUI_EDITTEXT_FLOAT, &tbpcenterz, 1, cbpcenterz );
	pillar_centerz->set_alignment(GLUI_ALIGN_RIGHT);
	pillar_centerz->set_w(80);

//--------------------

//	glui_3vd->add_statictext("");

	GLUI_Panel *t_panel = glui_3vd->add_panel("  Select Object  ",GLUI_PANEL_EMBOSSED);

	obj_sel_b = glui_3vd->add_radiogroup_to_panel( t_panel, &obj_sel, 3, sel_3vd );
	glui_3vd->add_radiobutton_to_group( obj_sel_b, "CROP               " );
	glui_3vd->add_radiobutton_to_group( obj_sel_b, "SPHERE" );
	glui_3vd->add_radiobutton_to_group( obj_sel_b, "PILLAR - XY base " );
	glui_3vd->add_radiobutton_to_group( obj_sel_b, "PILLAR - YZ base " );
	glui_3vd->add_radiobutton_to_group( obj_sel_b, "PILLAR - XZ base " );


	glui_3vd->add_statictext("");

	glui_3vd->add_button("RESET", 0, gui_Reset);
	glui_3vd->add_statictext("");
//	glui_3vd->add_statictext("");

	glui_3vd->add_button("CLOSE", 0, gluiCallback);
}

//オブジェクトをポリゴンに分割して描画
void	CalcCropCoord(void){

	int	i;

	verticesCrop[0*3+0]  = param3vd.paramcxmin; verticesCrop[0*3+1] = param3vd.paramcymin; verticesCrop[0*3+2] = param3vd.paramczmin;			//上
	verticesCrop[1*3+0]  = param3vd.paramcxmin; verticesCrop[1*3+1] = param3vd.paramcymin; verticesCrop[1*3+2] = param3vd.paramczmax;
	verticesCrop[2*3+0]  = param3vd.paramcxmax; verticesCrop[2*3+1] = param3vd.paramcymin; verticesCrop[2*3+2] = param3vd.paramczmax;
	verticesCrop[3*3+0]  = param3vd.paramcxmax; verticesCrop[3*3+1] = param3vd.paramcymin; verticesCrop[3*3+2] = param3vd.paramczmin;

	verticesCrop[4*3+0]  = param3vd.paramcxmin; verticesCrop[4*3+1] = param3vd.paramcymax; verticesCrop[4*3+2] = param3vd.paramczmin;			//下
	verticesCrop[5*3+0]  = param3vd.paramcxmin; verticesCrop[5*3+1] = param3vd.paramcymax; verticesCrop[5*3+2] = param3vd.paramczmax;
	verticesCrop[6*3+0]  = param3vd.paramcxmax; verticesCrop[6*3+1] = param3vd.paramcymax; verticesCrop[6*3+2] = param3vd.paramczmax;
	verticesCrop[7*3+0]  = param3vd.paramcxmax; verticesCrop[7*3+1] = param3vd.paramcymax; verticesCrop[7*3+2] = param3vd.paramczmin;

	//法線ベクトルの計算
	for( i = 0; i < 6 ; i++ ){
		CalculateNormal( &verticesCrop[ConnectionArrayCrop[i*4+0]*3], &verticesCrop[ConnectionArrayCrop[i*4+1]*3], 
		&verticesCrop[ConnectionArrayCrop[i*4+2]*3], &NormalArrayCrop[i*3] );
	}
}

void	CalcSphereCoord(void){

	int	i, sides;

	int div_h = SIDES*2;						// 水平方向分割数
	int div_v = div_h/2;						// 垂直方向分割数
	float theta = (float)(PI * 2.0 / div_h);
	float sinTheta = (float)sin( theta );
	float cosTheta = (float)cos( theta );
	float radius = param3vd.paramsradius;			// 球の半径

	float accu_v_s = sinTheta;					// 垂直方向 sin
	float accu_v_c = cosTheta;					// 垂直方向 cos
	float ru = radius * accu_v_s;				// 現theta値で水平スライスした時の半径
	float yu = radius * accu_v_c;				// 垂直方向Y軸値

	//頂点座標の計算
	verticesSphere[0] = param3vd.paramscenterx;							//センター(北極点）
	verticesSphere[1] = param3vd.paramscentery+radius;
	verticesSphere[2] = param3vd.paramscenterz;

	verticesSphere[3] = param3vd.paramscenterx;							//センター(南極点）
	verticesSphere[4] = param3vd.paramscentery-radius;
	verticesSphere[5] = param3vd.paramscenterz;

	for( int y = 0; y < (div_v-1); ++y ) {

		// 加法定理によって、垂直方向のsin/cos値を更新する
		float tmp = cosTheta * accu_v_c - sinTheta * accu_v_s;
		accu_v_s = sinTheta * accu_v_c + cosTheta * accu_v_s;
		accu_v_c = tmp;

		float rd = radius * accu_v_s;			// 1個後の半径
		float yd = radius * accu_v_c;			// 1個後の垂直方向Y軸値
		float accu_s = sinTheta;				// 水平方向sin
		float accu_c = cosTheta;				// 水平方向cos

		for( int x = 0, sides = 0; sides < SIDES ; ++x, ++sides ) {

			verticesSphere[(2+y*SIDES+x)*3+0] = ru * accu_c+param3vd.paramscenterx;
			verticesSphere[(2+y*SIDES+x)*3+1] = yu+param3vd.paramscentery;
			verticesSphere[(2+y*SIDES+x)*3+2] = ru * accu_s+param3vd.paramscenterz;

			// 加法定理によって、水平方向のsin/cos値を更新する
			tmp = cosTheta * accu_c - sinTheta * accu_s;
			accu_s = sinTheta * accu_c + cosTheta * accu_s;
			accu_c = tmp;

			tmp = cosTheta * accu_c - sinTheta * accu_s;
			accu_s = sinTheta * accu_c + cosTheta * accu_s;
			accu_c = tmp;
		}
		ru = rd;
		yu = yd;
	}

	//ConnectionArray の設定

	//上面
	for ( i = 0, sides = 0 ; sides < SIDES; ++sides, ++i )
	{
		ConnectionArraySphere[i*3]   = 0;															//センター
		ConnectionArraySphere[i*3+1] = i+2;	
		ConnectionArraySphere[i*3+2] = i+3;	
	}
	ConnectionArraySphere[SIDES*1*3-1] = ConnectionArraySphere[1];									//始点に戻る

	//側面
	for( int y = 0; y < (div_v-2); ++y ) {
		for ( i = SIDES, sides = 0 ; sides < SIDES ; ++sides, ++i )
		{	
			ConnectionArraySphere[(SIDES*y+i)*3]   = SIDES*(y+1)+sides+2;
			ConnectionArraySphere[(SIDES*y+i)*3+1] = SIDES*(y+1)+sides+3;
			ConnectionArraySphere[(SIDES*y+i)*3+2] = SIDES*(y)+sides+3;
		}
		ConnectionArraySphere[(SIDES*y+i-1)*3+1] = SIDES*(y+1)+2;									//始点に戻る
		ConnectionArraySphere[(SIDES*y+i-1)*3+2] = SIDES*(y)+2;
	}

	for( int y = 0; y < (div_v-2); ++y ) {
		for ( i = SIDES*(1+div_v-2), sides = 0 ; sides < SIDES ; ++sides, ++i )
		{
			ConnectionArraySphere[(SIDES*y+i)*3]   = SIDES*(y)+sides+3;
			ConnectionArraySphere[(SIDES*y+i)*3+1] = SIDES*(y)+sides+2;
			ConnectionArraySphere[(SIDES*y+i)*3+2] = SIDES*(y+1)+sides+2;
		}
		ConnectionArraySphere[(SIDES*y+i-1)*3] = SIDES*(y)+2;										//始点に戻る
	}

	//下面
	for ( i = SIDES*(1+(div_v-2)*2), sides = 0 ; sides < SIDES; ++sides, ++i )
	{
		ConnectionArraySphere[i*3]   = 2+SIDES*(SIDES-2)+sides;
		ConnectionArraySphere[i*3+1] = 1;															//センター
		ConnectionArraySphere[i*3+2] = 2+SIDES*(SIDES-2)+sides+1;
	}
	ConnectionArraySphere[SIDES*(2+(SIDES-2)*2)*3-1] = 2+SIDES*(SIDES-2);							//始点に戻る

	//法線ベクトルの計算
	for( i = 0; i < (SIDES*2+SIDES*2*(SIDES-2)) ; i++ ){
		CalculateNormal( &verticesSphere[ConnectionArraySphere[i*3+0]*3], &verticesSphere[ConnectionArraySphere[i*3+1]*3], 
		&verticesSphere[ConnectionArraySphere[i*3+2]*3], &NormalArraySphere[i*3] );
	}
}

//  角度°→ ラジアン変換
double degree2Radian( double degree )
{
        return degree / 180.0 * PI;
}

void	CalcPillarCoord(void){

	int	i, sides;
	double degree;
	float x, y;

	degree = 360 / SIDES;

	//頂点座標の設定

	//上面
	verticesPillar[0*3+0] = param3vd.parampcenterx;									//センター
	verticesPillar[0*3+1] = param3vd.parampcentery;
	verticesPillar[0*3+2] = param3vd.parampheight+param3vd.parampcenterz;

	for ( i = 1, sides = 0 ; sides < SIDES+1 ; ++sides, ++i )
	{
		x = param3vd.parampradius*sin(degree2Radian(degree*sides))+param3vd.parampcenterx;
		y = param3vd.parampradius*cos(degree2Radian(degree*sides))+param3vd.parampcentery;

		verticesPillar[i*3+0] = x;
		verticesPillar[i*3+1] = y;
		verticesPillar[i*3+2] = param3vd.parampheight+param3vd.parampcenterz;
	}

	//下面
	verticesPillar[(SIDES+1)*3+0] = param3vd.parampcenterx;							//センター
	verticesPillar[(SIDES+1)*3+1] = param3vd.parampcentery;
	verticesPillar[(SIDES+1)*3+2] = param3vd.parampcenterz;

	for ( i = SIDES+2, sides = 0 ;  sides < SIDES ; ++sides, ++i )
	{
		x = param3vd.parampradius*sin(degree2Radian(degree*sides))+param3vd.parampcenterx;
		y = param3vd.parampradius*cos(degree2Radian(degree*sides))+param3vd.parampcentery;

		verticesPillar[i*3+0] = x;
		verticesPillar[i*3+1] = y;
		verticesPillar[i*3+2] = param3vd.parampcenterz;
	}

	//ConnectionArray の設定
	//上面
	for ( i = 0, sides = 0 ; sides < SIDES; ++sides, ++i )
	{
		ConnectionArrayPillar[i*3]   = 0;											//センター
		ConnectionArrayPillar[i*3+1] = i+1;	
		ConnectionArrayPillar[i*3+2] = i+2;	
		
	}
	ConnectionArrayPillar[SIDES*1*3-1] = ConnectionArrayPillar[1];					//始点に戻る

	//下面
	for ( i = SIDES, sides = 0 ; sides < SIDES; ++sides, ++i )
	{
		ConnectionArrayPillar[i*3]   = SIDES+1;										//センター
		ConnectionArrayPillar[i*3+1] = i+3;	
		ConnectionArrayPillar[i*3+2] = i+2;	
		
	}
	ConnectionArrayPillar[SIDES*2*3-2] = SIDES*1+2;									//始点に戻る

	//側面
	for ( i = SIDES*2, sides = 0 ; sides < SIDES ; ++sides, ++i )
	{
		ConnectionArrayPillar[i*3]   = sides+1;
		ConnectionArrayPillar[i*3+1] = SIDES+sides+2;	
		ConnectionArrayPillar[i*3+2] = SIDES+sides+3;	
	}
	ConnectionArrayPillar[SIDES*3*3-1] = ConnectionArrayPillar[SIDES*2*3+1];		//始点に戻る

	//側面
	for ( i = SIDES*3, sides = 0 ; sides < SIDES ; ++sides, ++i )
	{
		ConnectionArrayPillar[i*3]   = SIDES+sides+3;	
		ConnectionArrayPillar[i*3+1] = sides+2;	
		ConnectionArrayPillar[i*3+2] = sides+1;
	}
	ConnectionArrayPillar[SIDES*4*3-3] = SIDES+2;
	ConnectionArrayPillar[SIDES*4*3-2] = 1;									//始点に戻る

	//法線ベクトルの計算
	for( i = 0; i < SIDES*4 ; i++ ){
		CalculateNormal( &verticesPillar[ConnectionArrayPillar[i*3+0]*3], &verticesPillar[ConnectionArrayPillar[i*3+1]*3], 
		&verticesPillar[ConnectionArrayPillar[i*3+2]*3], &NormalArrayPillar[i*3] );
	}
}

void	CalcPillarXZCoord(void){

	int	i, sides;
	double degree;
	float x ,z;

	degree = 360 / SIDES;

	//頂点座標の設定

	//上面
	verticesPillar[0*3+0] = param3vd.parampcenterx;									//センター
	verticesPillar[0*3+1] = param3vd.parampheight+param3vd.parampcentery;
	verticesPillar[0*3+2] = param3vd.parampcenterz;

	for ( i = 1, sides = 0 ; sides < SIDES+1 ; ++sides, ++i )
	{
		x = param3vd.parampradius*sin(degree2Radian(degree*sides))+param3vd.parampcenterx;
		z = param3vd.parampradius*cos(degree2Radian(degree*sides))+param3vd.parampcenterz;

		verticesPillar[i*3+0] = x;
		verticesPillar[i*3+1] = param3vd.parampheight+param3vd.parampcentery;
		verticesPillar[i*3+2] = z;
	}

	//下面
	verticesPillar[(SIDES+1)*3+0] = param3vd.parampcenterx;							//センター
	verticesPillar[(SIDES+1)*3+1] = param3vd.parampcentery;
	verticesPillar[(SIDES+1)*3+2] = param3vd.parampcenterz;

	for ( i = SIDES+2, sides = 0 ;  sides < SIDES ; ++sides, ++i )
	{
		x = param3vd.parampradius*sin(degree2Radian(degree*sides))+param3vd.parampcenterx;
		z = param3vd.parampradius*cos(degree2Radian(degree*sides))+param3vd.parampcenterz;
		verticesPillar[i*3+0] = x;
		verticesPillar[i*3+1] = param3vd.parampcentery;
		verticesPillar[i*3+2] = z;
	}

	//ConnectionArray の設定

	//上面
	for ( i = 0, sides = 0 ; sides < SIDES; ++sides, ++i )
	{
		ConnectionArrayPillar[i*3]   = 0;											//センター
		ConnectionArrayPillar[i*3+1] = i+1;	
		ConnectionArrayPillar[i*3+2] = i+2;	
		
	}
	ConnectionArrayPillar[SIDES*1*3-1] = ConnectionArrayPillar[1];					//始点に戻る

	//下面
	for ( i = SIDES, sides = 0 ; sides < SIDES; ++sides, ++i )
	{
		ConnectionArrayPillar[i*3]   = SIDES+1;										//センター
		ConnectionArrayPillar[i*3+1] = i+3;	
		ConnectionArrayPillar[i*3+2] = i+2;	
		
	}
	ConnectionArrayPillar[SIDES*2*3-2] = SIDES*1+2;									//始点に戻る

	//側面
	for ( i = SIDES*2, sides = 0 ; sides < SIDES ; ++sides, ++i )
	{
		ConnectionArrayPillar[i*3]   = sides+1;
		ConnectionArrayPillar[i*3+1] = SIDES+sides+2;	
		ConnectionArrayPillar[i*3+2] = SIDES+sides+3;	
	}
	ConnectionArrayPillar[SIDES*3*3-1] = ConnectionArrayPillar[SIDES*2*3+1];		//始点に戻る

	//側面
	for ( i = SIDES*3, sides = 0 ; sides < SIDES ; ++sides, ++i )
	{
		ConnectionArrayPillar[i*3]   = SIDES+sides+3;	
		ConnectionArrayPillar[i*3+1] = sides+2;	
		ConnectionArrayPillar[i*3+2] = sides+1;
	}
	ConnectionArrayPillar[SIDES*4*3-3] = SIDES+2;
	ConnectionArrayPillar[SIDES*4*3-2] = 1;									//始点に戻る

	//法線ベクトルの計算
	for( i = 0; i < SIDES*4 ; i++ ){
		CalculateNormal( &verticesPillar[ConnectionArrayPillar[i*3+0]*3], &verticesPillar[ConnectionArrayPillar[i*3+1]*3], 
		&verticesPillar[ConnectionArrayPillar[i*3+2]*3], &NormalArrayPillar[i*3] );
	}
}

void	CalcPillarYZCoord(void){

	int	i, sides;
	double degree;
	float y, z;

	degree = 360 / SIDES;

	//頂点座標の設定

	//上面
	verticesPillar[0*3+0] = param3vd.parampheight+param3vd.parampcenterx;			//センター
	verticesPillar[0*3+1] = param3vd.parampcentery;
	verticesPillar[0*3+2] = param3vd.parampcenterz;

	for ( i = 1, sides = 0 ; sides < SIDES+1 ; ++sides, ++i )
	{
		y = param3vd.parampradius*sin(degree2Radian(degree*sides))+param3vd.parampcentery;
		z = param3vd.parampradius*cos(degree2Radian(degree*sides))+param3vd.parampcenterz;

		verticesPillar[i*3+0] = param3vd.parampheight+param3vd.parampcenterx;
		verticesPillar[i*3+1] = y;
		verticesPillar[i*3+2] = z;
	}

	//下面
	verticesPillar[(SIDES+1)*3+0] = param3vd.parampcenterx;							//センター
	verticesPillar[(SIDES+1)*3+1] = param3vd.parampcentery;
	verticesPillar[(SIDES+1)*3+2] = param3vd.parampcenterz;

	for ( i = SIDES+2, sides = 0 ;  sides < SIDES ; ++sides, ++i )
	{
		y = param3vd.parampradius*sin(degree2Radian(degree*sides))+param3vd.parampcentery;
		z = param3vd.parampradius*cos(degree2Radian(degree*sides))+param3vd.parampcenterz;
		verticesPillar[i*3+0] = param3vd.parampcenterx;
		verticesPillar[i*3+1] = y;
		verticesPillar[i*3+2] = z;
	}

	//ConnectionArray の設定

	//上面
	for ( i = 0, sides = 0 ; sides < SIDES; ++sides, ++i )
	{
		ConnectionArrayPillar[i*3]   = 0;											//センター
		ConnectionArrayPillar[i*3+1] = i+1;	
		ConnectionArrayPillar[i*3+2] = i+2;	
		
	}
	ConnectionArrayPillar[SIDES*1*3-1] = ConnectionArrayPillar[1];					//始点に戻る

	//下面
	for ( i = SIDES, sides = 0 ; sides < SIDES; ++sides, ++i )
	{
		ConnectionArrayPillar[i*3]   = SIDES+1;										//センター
		ConnectionArrayPillar[i*3+1] = i+3;	
		ConnectionArrayPillar[i*3+2] = i+2;	
		
	}
	ConnectionArrayPillar[SIDES*2*3-2] = SIDES*1+2;									//始点に戻る

	//側面
	for ( i = SIDES*2, sides = 0 ; sides < SIDES ; ++sides, ++i )
	{
		ConnectionArrayPillar[i*3]   = sides+1;
		ConnectionArrayPillar[i*3+1] = SIDES+sides+2;	
		ConnectionArrayPillar[i*3+2] = SIDES+sides+3;	
	}
	ConnectionArrayPillar[SIDES*3*3-1] = ConnectionArrayPillar[SIDES*2*3+1];		//始点に戻る

	//側面
	for ( i = SIDES*3, sides = 0 ; sides < SIDES ; ++sides, ++i )
	{
		ConnectionArrayPillar[i*3]   = SIDES+sides+3;	
		ConnectionArrayPillar[i*3+1] = sides+2;	
		ConnectionArrayPillar[i*3+2] = sides+1;
	}
	ConnectionArrayPillar[SIDES*4*3-3] = SIDES+2;
	ConnectionArrayPillar[SIDES*4*3-2] = 1;									//始点に戻る

	//法線ベクトルの計算
	for( i = 0; i < SIDES*4 ; i++ ){
		CalculateNormal( &verticesPillar[ConnectionArrayPillar[i*3+0]*3], &verticesPillar[ConnectionArrayPillar[i*3+1]*3], 
		&verticesPillar[ConnectionArrayPillar[i*3+2]*3], &NormalArrayPillar[i*3] );
	}
}

//法線ベクトルの計算
int CalculateNormal( float* p1, float* p2, float* p3, float* n )
{
	float v1[3];
	float v2[3];
	float cross[3];
	float length;

	int i;

	/* v1 = p1 - p2を求める */
	for (i = 0; i < 3; i++) {
		v1[i] = p1[i] - p2[i];
	}

	/* v2 = p3 - p2を求める */
	for (i = 0; i < 3; i++) {
		v2[i] = p3[i] - p2[i];
	}

	/* 外積v2×v1（= cross）を求める */
	for (i = 0; i < 3; i++) {
		cross[i] = v2[(i+1)%3] * v1[(i+2)%3] - v2[(i+2)%3] * v1[(i+1)%3];
	}

	/* 外積v2×v1の長さ|v2×v1|（= length）を求める */
	length = sqrtf(cross[0] * cross[0] + 
	               cross[1] * cross[1] + 
	               cross[2] * cross[2]);

	/* 長さ|v2×v1|が0のときは法線ベクトルは求められない */
	if (length == 0.0f) {
		return 0;
	}

	/* 外積v2×v1を長さ|v2×v1|で割って法線ベクトルnを求める */
	for (i = 0; i < 3; i++) {
		n[i] = cross[i] / length;
		if( n[i] == -0.0F )
			n[i] = 0.0F;
	}
	return 1;
}

#ifdef NOTOPEN
//----------------------------------------------------------
//ディスプレイ・ファンクション(テスト用）
void display(void) {
	glutSetWindow(iwin_main);

	glClear(GL_COLOR_BUFFER_BIT);

	glPushMatrix();
	glMultMatrixf( rotate );
	mapscale = 1.0;

  switch( obj_3d ){
	case	CROP:
		CalcCropCoord();
		glViewport( 0, 0, MAINWINDOW_W,MAINWINDOW_H );
		crop.draw_crop(  0, 0, 0, 0, SOLID );
		glColor3f( 1.0, 0.0, 0.0 );
		glViewport( 0, 0, MAINWINDOW_W,MAINWINDOW_H );
		crop.draw_crop(  0, 0, 0, 0, WIRE );
		glDrawxisd( VEC_LEN, 0, 0, 0,  MAINWINDOW_W, 0 );
  		break;

	case	SPHERE:
		CalcSphereCoord();
		glViewport( 0, 0, MAINWINDOW_W,MAINWINDOW_H );
		sphere.draw_sphere(  0, 0, 0, 0, SOLID );
		glColor3f( 1.0, 0.0, 0.0 );
		glViewport( 0, 0, MAINWINDOW_W,MAINWINDOW_H );
		sphere.draw_sphere(  0, 0, 0, 0, WIRE );
		glDrawxisd( VEC_LEN, 0, 0, 0, MAINWINDOW_W, 0 );
 		break;

	case	PILLARXY:
		pillar.PillarChkTextBox();
		CalcPillarCoord();
		glViewport( 0, 0, MAINWINDOW_W,MAINWINDOW_H );
		pillar.draw_pillar( 0, 0, 0, 0, SOLID );
		glColor3f( 1.0, 0.0, 0.0 );
		glViewport( 0, 0, MAINWINDOW_W,MAINWINDOW_H );
		glPushMatrix();
		pillar.draw_pillar( 0, 0, 0, 0, WIRE );
		glPopMatrix();
		glDrawxisd( VEC_LEN, 0, 0, 0, MAINWINDOW_W, 0 );
 		break;

	case	PILLARYZ:
		pillarYZ.PillarChkTextBox();
		CalcPillarYZCoord();
		glViewport( 0, 0, MAINWINDOW_W,MAINWINDOW_H );
		pillarYZ.draw_pillar( 0, 0, 0, 0, SOLID );
		glColor3f( 1.0, 0.0, 0.0 );
		glViewport( 0, 0, MAINWINDOW_W,MAINWINDOW_H );
		glPushMatrix();
		pillarYZ.draw_pillar( 0, 0, 0, 0, WIRE );
		glPopMatrix();
		glDrawxisd( VEC_LEN, 0, 0, 0, MAINWINDOW_W, 0 );
 		break;

	case	PILLARXZ:
		pillarXZ.PillarChkTextBox();
		CalcPillarXZCoord();
		glViewport( 0, 0, MAINWINDOW_W,MAINWINDOW_H );
		pillarXZ.draw_pillar( 0, 0, 0, 0, SOLID );
		glColor3f( 1.0, 0.0, 0.0 );
		glViewport( 0, 0, MAINWINDOW_W,MAINWINDOW_H );
		glPushMatrix();
		pillarXZ.draw_pillar( 0, 0, 0, 0, WIRE );
		glPopMatrix();
		glDrawxisd( VEC_LEN, 0, 0, 0, MAINWINDOW_W, 0 );
 		break;

	default:
		break;
	}

	glPopMatrix();

	glutSwapBuffers();
	glutPostRedisplay();
}

//--------------------------------------------------------------
#endif

//３面図のディスプレイ・ファンクション
void display_3vd()
{

	glutSetWindow(iwin_3vd);
	init_3vd(iwin_3vd);
	mapscale = 1.0;

//	PBVRxmax = PVBRmaxcoords[0]; PBVRymax = PVBRmaxcoords[1]; PBVRzmax = PVBRmaxcoords[2];

//printf("============== display_3vd %f, %f, %f, %f, %f, %f\n", PVBRmincoords[0], PVBRmincoords[1], PVBRmincoords[2], PVBRmaxcoords[0], PVBRmaxcoords[1], PVBRmaxcoords[2] );
//printf("============== ,PBVRxmin %f, %f, %f, %f, %f, %f\n",PBVRxmin, PBVRymin, PBVRzmin, PBVRxmax, PBVRymax, PBVRzmax );


	switch( obj_3d ){

	case	CROP:
		CalcCropCoord();
		glViewport( 0, WindowHeight - VIEWPORT_HEIGHT, VIEWPORT_WIDTH, VIEWPORT_HEIGHT );
		draw_frame( 2.00 );
		draw_frame( 1.99 );
		if( win_sel == X_VIEW )
			draw_frame( 1.98 );
		glColor3f( 1.0, 0.0, 0.0 );
		crop.draw_crop(  90, 0, 1, 0, WIRE );
		glDrawxisd( VEC_LEN, 0, 1, 0, VIEWPORT_WIDTH, WindowHeight - VIEWPORT_HEIGHT );

		glViewport( VIEWPORT_WIDTH, WindowHeight - ( VIEWPORT_HEIGHT * 2 ), VIEWPORT_WIDTH, VIEWPORT_HEIGHT );
		draw_frame( 2.00 );
		draw_frame( 1.99 );
		if( win_sel == Y_VIEW )
			draw_frame( 1.98 );
 		glColor3f( 1.0, 0.0, 0.0 );
		crop.draw_crop(  90, 1, 0, 0, WIRE);
		glDrawxisd( VEC_LEN, 1, 0, 0, ( VIEWPORT_WIDTH * 2 ), WindowHeight - ( VIEWPORT_HEIGHT * 2 ));

		glViewport( VIEWPORT_WIDTH, WindowHeight - VIEWPORT_HEIGHT, VIEWPORT_WIDTH, VIEWPORT_HEIGHT );
		draw_frame( 2.00 );
		draw_frame( 1.99 );
		if( win_sel == Z_VIEW )
			draw_frame( 1.98 );
		glColor3f( 1.0, 0.0, 0.0 );
		crop.draw_crop(  0, 0, 0, 0, WIRE );
		glDrawxisd( VEC_LEN, 0, 0, 0, ( VIEWPORT_WIDTH * 2 ), WindowHeight - VIEWPORT_HEIGHT );

		break;

	case	SPHERE:
		CalcSphereCoord();
		glViewport( 0, WindowHeight - VIEWPORT_HEIGHT, VIEWPORT_WIDTH, VIEWPORT_HEIGHT );
		draw_frame( 2.00 );
		draw_frame( 1.99 );
		if( win_sel == X_VIEW )
			draw_frame( 1.98 );
 		glColor3f( 1.0, 0.0, 0.0 );
		sphere.draw_sphere( 90, 0, 1, 0, WIRE );
		glDrawxisd( VEC_LEN, 0, 1, 0, VIEWPORT_WIDTH, WindowHeight - VIEWPORT_HEIGHT );

		glViewport( VIEWPORT_WIDTH, WindowHeight - ( VIEWPORT_HEIGHT * 2 ), VIEWPORT_WIDTH, VIEWPORT_HEIGHT );
		draw_frame( 2.00 );
		draw_frame( 1.99 );
		if( win_sel == Y_VIEW )
			draw_frame( 1.98 );
 		glColor3f( 1.0, 0.0, 0.0 );
		sphere.draw_sphere(  90, 1, 0, 0, WIRE );
		glDrawxisd( VEC_LEN, 1, 0, 0, ( VIEWPORT_WIDTH * 2 ), WindowHeight - ( VIEWPORT_HEIGHT * 2 ));

		glViewport( VIEWPORT_WIDTH, WindowHeight - VIEWPORT_HEIGHT, VIEWPORT_WIDTH, VIEWPORT_HEIGHT );
		draw_frame( 2.00 );
		draw_frame( 1.99 );
		if( win_sel == Z_VIEW )
			draw_frame( 1.98 );
		glColor3f( 1.0, 0.0, 0.0 );
		sphere.draw_sphere(  0, 0, 0, 0, WIRE );
		glDrawxisd( VEC_LEN, 0, 0, 0, ( VIEWPORT_WIDTH * 2 ), WindowHeight - VIEWPORT_HEIGHT );

		break;

	case	PILLARXY:
		pillar.PillarChkTextBox();
		CalcPillarCoord();

		glViewport( 0, WindowHeight - VIEWPORT_HEIGHT, VIEWPORT_WIDTH, VIEWPORT_HEIGHT );
		draw_frame( 2.00 );
		draw_frame( 1.99 );
		if( win_sel == X_VIEW )
			draw_frame( 1.98 );
		glColor3f( 1.0, 0.0, 0.0 );
		pillar.draw_pillar( 90, 0, 1, 0, WIRE );
		glDrawxisd( VEC_LEN, 0, 1, 0, VIEWPORT_WIDTH, WindowHeight - VIEWPORT_HEIGHT );

		glViewport( VIEWPORT_WIDTH, WindowHeight - ( VIEWPORT_HEIGHT * 2 ), VIEWPORT_WIDTH, VIEWPORT_HEIGHT );
		draw_frame( 2.00 );
		draw_frame( 1.99 );
		if( win_sel == Y_VIEW )
			draw_frame( 1.98 );
 		glColor3f( 1.0, 0.0, 0.0 );
		pillar.draw_pillar( 90, 1, 0, 0, WIRE );
		glDrawxisd( VEC_LEN, 1, 0, 0, ( VIEWPORT_WIDTH * 2 ), WindowHeight - ( VIEWPORT_HEIGHT * 2 ));

		glViewport( VIEWPORT_WIDTH, WindowHeight - VIEWPORT_HEIGHT, VIEWPORT_WIDTH, VIEWPORT_HEIGHT );
		draw_frame( 2.00 );
		draw_frame( 1.99 );
		if( win_sel == Z_VIEW )
			draw_frame( 1.98 );
 		glColor3f( 1.0, 0.0, 0.0 );
		pillar.draw_pillar( 0, 0, 0, 0, WIRE );
		glDrawxisd( VEC_LEN, 0, 0, 0, ( VIEWPORT_WIDTH * 2 ), WindowHeight - VIEWPORT_HEIGHT );

		break;

	case	PILLARYZ:
		pillarYZ.PillarChkTextBox();
		CalcPillarYZCoord();

		glViewport( 0, WindowHeight - VIEWPORT_HEIGHT, VIEWPORT_WIDTH, VIEWPORT_HEIGHT );
		draw_frame( 2.00 );
		draw_frame( 1.99 );
		if( win_sel == X_VIEW )
			draw_frame( 1.98 );
		glColor3f( 1.0, 0.0, 0.0 );
		pillarYZ.draw_pillar( 90, 0, 1, 0, WIRE );
		glDrawxisd( VEC_LEN, 0, 1, 0, VIEWPORT_WIDTH, WindowHeight - VIEWPORT_HEIGHT );

		glViewport( VIEWPORT_WIDTH, WindowHeight - ( VIEWPORT_HEIGHT * 2 ), VIEWPORT_WIDTH, VIEWPORT_HEIGHT );
		draw_frame( 2.00 );
		draw_frame( 1.99 );
		if( win_sel == Y_VIEW )
			draw_frame( 1.98 );
 		glColor3f( 1.0, 0.0, 0.0 );
		pillarYZ.draw_pillar( 90, 1, 0, 0, WIRE );
		glDrawxisd( VEC_LEN, 1, 0, 0, ( VIEWPORT_WIDTH * 2 ), WindowHeight - ( VIEWPORT_HEIGHT * 2 ));

		glViewport( VIEWPORT_WIDTH, WindowHeight - VIEWPORT_HEIGHT, VIEWPORT_WIDTH, VIEWPORT_HEIGHT );
		draw_frame( 2.00 );
		draw_frame( 1.99 );
		if( win_sel == Z_VIEW )
			draw_frame( 1.98 );
 		glColor3f( 1.0, 0.0, 0.0 );
		pillarYZ.draw_pillar( 0, 0, 0, 0, WIRE );
		glDrawxisd( VEC_LEN, 0, 0, 0, ( VIEWPORT_WIDTH * 2 ), WindowHeight - VIEWPORT_HEIGHT );

		break;

	case	PILLARXZ:
		pillarXZ.PillarChkTextBox();
		CalcPillarXZCoord();

		glViewport( 0, WindowHeight - VIEWPORT_HEIGHT, VIEWPORT_WIDTH, VIEWPORT_HEIGHT );
		draw_frame( 2.00 );
		draw_frame( 1.99 );
		if( win_sel == X_VIEW )
			draw_frame( 1.98 );
		glColor3f( 1.0, 0.0, 0.0 );
		pillarXZ.draw_pillar( 90, 0, 1, 0, WIRE );
		glDrawxisd( VEC_LEN, 0, 1, 0, VIEWPORT_WIDTH, WindowHeight - VIEWPORT_HEIGHT );

		glViewport( VIEWPORT_WIDTH, WindowHeight - ( VIEWPORT_HEIGHT * 2 ), VIEWPORT_WIDTH, VIEWPORT_HEIGHT );
		draw_frame( 2.00 );
		draw_frame( 1.99 );
		if( win_sel == Y_VIEW )
			draw_frame( 1.98 );
 		glColor3f( 1.0, 0.0, 0.0 );
		pillarXZ.draw_pillar( 90, 1, 0, 0, WIRE );
		glDrawxisd( VEC_LEN, 1, 0, 0, ( VIEWPORT_WIDTH * 2 ), WindowHeight - ( VIEWPORT_HEIGHT * 2 ));

		glViewport( VIEWPORT_WIDTH, WindowHeight - VIEWPORT_HEIGHT, VIEWPORT_WIDTH, VIEWPORT_HEIGHT );
		draw_frame( 2.00 );
		draw_frame( 1.99 );
		if( win_sel == Z_VIEW )
			draw_frame( 1.98 );
 		glColor3f( 1.0, 0.0, 0.0 );
		pillarXZ.draw_pillar( 0, 0, 0, 0, WIRE );
		glDrawxisd( VEC_LEN, 0, 0, 0, ( VIEWPORT_WIDTH * 2 ), WindowHeight - VIEWPORT_HEIGHT );

		break;

	default:
		break;
	}

	end_3vd(iwin_3vd);
}

//３面図用ウィンドウの初期化
void init_3vd(int winid)
{
	glutSetWindow(winid);
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glClear(GL_COLOR_BUFFER_BIT);

	glPushMatrix();
}

//３面図用ウィンドウの終了処理
void end_3vd(int winid) {

	glPopMatrix();
//	glutSetWindow(winid);
	glutSwapBuffers();
	glutPostRedisplay();
}

//RESET ボタン用コールバック（オブジェクトを初期化）
void gui_Reset( int num )
{
 switch( obj_3d ){
	case	CROP:
		crop.motion_init();
		crop.crop_init();
		param3vd.CropParaSet();
		break;
	case	SPHERE:
		sphere.motion_init();
		sphere.sphere_init(1);
		param3vd.SphereParaSet();
		break;
	case	PILLARXY:
		pillar.motion_init();
		pillar.pillar_init(1);
            pillar.set_pillar_textbox();
		param3vd.PillarParaSet();
		break;
	case	PILLARYZ:
		pillarYZ.motion_init();
		pillarYZ.pillar_init(1);
            pillarYZ.set_pillar_textbox();
		param3vd.PillarParaSet();
		break;
	case	PILLARXZ:
		pillarXZ.motion_init();
		pillarXZ.pillar_init(1);
            pillarXZ.set_pillar_textbox();
		param3vd.PillarParaSet();
		break;
	default:
		break;
	}
}

//パラメータ用オブジェクトに値をセット
void	ParamCrop::CropParaSet(){
		paramcxmin  = cxminlevel2;
		paramcxmax  = cxmaxlevel2;
		paramcymin  = cyminlevel2;
		paramcymax  = cymaxlevel2;
		paramczmin  = czminlevel2;
		paramczmax  = czmaxlevel2;
}

void	ParamSphere::SphereParaSet(){
		paramsradius  = sradius;
		paramscenterx = scenterx;
		paramscentery = scentery;
		paramscenterz = scenterz;
}

void	ParamPillar::PillarParaSet(){
		parampradius  = pradius;
		parampheight  = pheight;
		parampcenterx = pcenterx;
		parampcentery = pcentery;
		parampcenterz = pcenterz;
}

//APPLYボタン用コールバック
void gui_Apply( int num ){
	param3vd.Apply = ON;
	param3vd.sel_area = obj_3d;

	paramCrop->cropType = (obj_3d == CROP)?     CropParam::Crop:
	                      (obj_3d == SPHERE)?   CropParam::Sphere:
	                      (obj_3d == PILLAR)?   CropParam::Pillar:
	                      (obj_3d == PILLARYZ)? CropParam::PillarYZ:
	                      (obj_3d == PILLARXZ)? CropParam::PillarXZ:
	                                            CropParam::NoCrop;
	
	paramCrop->rgcxminlevel = tbcxminlevel;
	paramCrop->rgcxmaxlevel = tbcxmaxlevel;
	paramCrop->rgcyminlevel = tbcyminlevel;
	paramCrop->rgcymaxlevel = tbcymaxlevel;
	paramCrop->rgczminlevel = tbczminlevel;
	paramCrop->rgczmaxlevel = tbczmaxlevel;
	paramCrop->rgsradius    = tbsradius;
	paramCrop->rgscenterx   = tbscenterx;
	paramCrop->rgscentery   = tbscentery;
	paramCrop->rgscenterz   = tbscenterz;
	paramCrop->rgpradius    = tbpradius;
	paramCrop->rgpheight    = tbpheight;
	paramCrop->rgpcenterx   = tbpcenterx;
	paramCrop->rgpcentery   = tbpcentery;
	paramCrop->rgpcenterz   = tbpcenterz;
}

//CLOSEボタン用コールバック
void gluiCallback(int num) {
	glutSetWindow(iwin_3vd);
	glutHideWindow();
	obj_3d = 0;
	param3vd.Apply = OFF;
        paramCrop->cropType = CropParam::NoCrop;
#ifndef NOTOPEN
	crop_flg = FALSE;
#endif
}

//表示するオブジェクトの選択
void sel_3vd(int num){

	obj_3d = obj_sel+1;

switch( obj_3d ){

	case	PILLARXY:
		pradius  = pillar.radius;
		pheight  = pillar.height;
		pcenterx = pillar.center_x;
		pcentery = pillar.center_y;
		pcenterz = pillar.center_z;
                pillar.set_pillar_textbox();
		pillar.reload_pillar_textbox();
		param3vd.PillarParaSet();
		break;

	case	PILLARYZ:
		pradius  = pillarYZ.radius;
		pheight  = pillarYZ.height;
		pcenterx = pillarYZ.center_x;
		pcentery = pillarYZ.center_y;
		pcenterz = pillarYZ.center_z;
                pillarYZ.set_pillar_textbox();
		pillarYZ.reload_pillar_textbox();
		param3vd.PillarParaSet();
		break;

	case	PILLARXZ:
		pradius  = pillarXZ.radius;
		pheight  = pillarXZ.height;
		pcenterx = pillarXZ.center_x;
		pcentery = pillarXZ.center_y;
		pcenterz = pillarXZ.center_z;
                pillarXZ.set_pillar_textbox();
		pillarXZ.reload_pillar_textbox();
		param3vd.PillarParaSet();
		break;

	default:
		break;
	}
#ifdef __APPLE__
	display_3vd();
#endif
}

// *** 球の描画 ***
void Sphere::draw_sphere( int angle ,int dirx, int diry, int dirz, int type )
{
	glPushMatrix();

	glRotated( angle, dirx, diry, dirz );
	obj_ctl();

	//ワイヤーフレーム
	if( type == WIRE ){
		DrawSphere( WIRE );
	}

	//塗りつぶし
	else if( type == SOLID ){
		DrawSphere( SOLID );
	}

	glPopMatrix();
}

// *** 立方体の描画 ***
void Crop::draw_crop( int angle, int dirx, int diry, int dirz, int type )
{
	glPushMatrix();

	glRotated( angle, dirx, diry, dirz );
	obj_ctl();

	if( type == WIRE ){
		DrawCrop( WIRE );
	}

	if( type == SOLID ){
		DrawCrop( SOLID );
	}

	glPopMatrix();
}

// *** 円柱の描画 ***
void Pillar::draw_pillar(int angle ,int dirx, int diry, int dirz, int type )
{
	glPushMatrix();

	//回転・中央に移動  
	if( dirx ){
 		glRotated( angle, 1, 0, 0 );
	 }
	if( diry ){
		glRotated( angle, 0, 1, 0 );
	}
	if( dirz ){
		glRotated( angle, 0, 0, 1 );
	} 

	obj_ctl();

	if( type == WIRE ){
		DrawPillar( WIRE );
	}

	else if( type == SOLID ){
		DrawPillar( SOLID );
	}

	glPopMatrix();
}

//法線の描画
void	glDrawxisd(double length, int dirx, int diry, int dirz, int viewport_x, int viewport_y)
{
	GLUquadricObj *arrows[3];

	glViewport( viewport_x - VECTOR_VIEW_SIZE-20, viewport_y, VECTOR_VIEW_SIZE, VECTOR_VIEW_SIZE );

	glPushMatrix();

	//回転
	if( dirx ){
 		glRotated( 90, 1, 0, 0 );
	 }
	if( diry ){
		glRotated( 90, 0, 1, 0 );
	}
	if( dirz ){
		glRotated( 90, 0, 0, 1 );
	} 

	// Draw X-axis
	glColor3ub(255, 0, 0);
	glBegin(GL_LINES);
		glVertex3d(-length, 0, 0);
		glVertex3d( length, 0, 0);
	glEnd();
	glPushMatrix();
		arrows[0] = gluNewQuadric();
		gluQuadricDrawStyle(arrows[0], GLU_FILL);
		glTranslated(length, 0.0f, 0.0f);
		glRotated(90.0f, 0,1,0);
		gluCylinder(arrows[0], length/40, 0.0f, length/10, 8, 8);

	disp_str( length/10, 0.0, 0.0, "X" );

	glPopMatrix();

	// Draw Y-axis
	glColor3ub(  0,255, 0);
	glBegin(GL_LINES);
		glVertex3d( 0,-length, 0);
		glVertex3d( 0, length, 0);
	glEnd();
	glPushMatrix();
		arrows[1] = gluNewQuadric();
		gluQuadricDrawStyle(arrows[1], GLU_FILL);
		glTranslated(0.0f, length, 0.0f);
		glRotated(-90.0f, 1,0,0);
		gluCylinder(arrows[1], length/40, 0.0f, length/10, 8, 8);
		disp_str( 0.0, length/10, 0.0, "Y" );

	glPopMatrix();

	// Draw Z-axis
	glColor3ub(  0, 0,255);
	glBegin(GL_LINES);
		glVertex3d( 0, 0,-length);
		glVertex3d( 0, 0, length);
	glEnd();
	glPushMatrix();
		arrows[2] = gluNewQuadric();
		gluQuadricDrawStyle(arrows[2], GLU_FILL);
		glTranslated(0.0f, 0.0f, length);
		gluCylinder(arrows[2], length/40, 0.0f, length/10, 8, 8);
		disp_str( 0.0, 0.0, length/10, "Z" );
	glPopMatrix();

	glPopMatrix();
}

//文字列の表示
void disp_str( float x, float  y, float z, const char* str ){
	glRasterPos3f( x, y, z );
	char* p = (char*)str;
	while(*p != '\0')glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, *p++);
}

//ビューポートの枠の描画
void	draw_frame( double size )
{
	glColor3f( 1.0, 1.0, 1.0 );
	glutWireCube( size );
}

//円柱用テキストボックスの値が変更されていたら、描画用のパラメータを更新
void	Pillar::PillarChkTextBox( void )
{
	if( tbpradius != save_tbpradius )
	{
		cbpradius( 0 );
		save_tbpradius = tbpradius;
	}
	if( tbpheight  != save_tbpheight )
	{
		cbpheight( 0 );
		save_tbpheight = tbpheight;
	}
        if( tbpcenterx != save_tbpcenterx )
	{
		cbpcenterx( 0 );
		save_tbpcenterx = tbpcenterx;
	}
        if( tbpcentery != save_tbpcentery )
 	{
		cbpcentery( 0 );
		save_tbpcentery = tbpcentery;
	}
	if( tbpcenterz != save_tbpcenterz )
	{
		cbpcenterz( 0 );
		save_tbpcenterz = tbpcenterz;
	}
}

//オブジェクトの操作
void	Motion::obj_ctl()
{
	double	x, y, z;

	x = move_x/(double)VIEWPORT_WIDTH  / scale_x;
	y = move_y/(double)VIEWPORT_HEIGHT / scale_y;
	z = move_z/(double)VIEWPORT_WIDTH  / scale_z;

//	glScaled( scale_x, scale_y, scale_z );
//	glTranslated( x*mapscale, y*mapscale, z*mapscale );
}

//各オブジェクトの初期化
void	Motion::motion_init()
{
		prev_x = 0;
		prev_y = 0;
		prev_z = 0;
		move_x = 0;
		move_y = 0;
		move_z = 0;
		save_x = 0;
		save_y = 0;
		save_z = 0;
		scale_x = 1.0F;
		scale_y = 1.0F;
		scale_z = 1.0F;	
}

void	Crop::crop_init(int flag)
{
	printf("Call Crop::crop_init()\n");
	sides = SIDES;
/*
	cxminlevel2 = CROPXMIN;
	cxmaxlevel2 = CROPXMAX;
	cyminlevel2 = CROPYMIN;
	cymaxlevel2 = CROPYMAX;
	czminlevel2 = CROPZMIN;
	czmaxlevel2 = CROPZMAX;

	save_cxmin = CROPXMIN;
	save_cxmax = CROPXMAX;
	save_cymin = CROPYMIN;
	save_cymax = CROPYMAX;
	save_czmin = CROPZMIN;
	save_czmax = CROPZMAX;
*/
        //CROP BOXの初期値をグローバルな座標のmin,maxに設定する
        double maxwidth = PBVRxmax - PBVRxmin;
        if (maxwidth < PBVRymax - PBVRymin) maxwidth = PBVRymax - PBVRymin;
        if (maxwidth < PBVRzmax - PBVRzmin) maxwidth = PBVRzmax - PBVRzmin;
        maxwidth/=WIN3VDSCALE;
        cxmaxlevel2 = (PBVRxmax - PBVRxmin)/maxwidth;
        cxminlevel2 = -cxmaxlevel2;
        cymaxlevel2 = (PBVRymax - PBVRymin)/maxwidth;
        cyminlevel2 = -cymaxlevel2;
        czmaxlevel2 = (PBVRzmax - PBVRzmin)/maxwidth;
        czminlevel2 = -czmaxlevel2;

	save_cxmin = cxminlevel2;
	save_cxmax = cxmaxlevel2;
	save_cymin = cyminlevel2;
	save_cymax = cymaxlevel2;
	save_czmin = czminlevel2;
	save_czmax = czmaxlevel2;

/*
	side_x = 1.0;
	side_y = 1.0;
	side_z = 1.0;
*/
	side_x = cxmaxlevel2 - cxminlevel2;
	side_y = cymaxlevel2 - cyminlevel2;
	side_z = czmaxlevel2 - czminlevel2;
	move_x = ( cxmaxlevel2 + cxminlevel2 ) * ( VIEWPORT_WIDTH / 2 ) / 2;
	move_y = ( cymaxlevel2 + cyminlevel2 ) * ( VIEWPORT_WIDTH / 2 ) / 2;
	move_z = ( czmaxlevel2 + czminlevel2 ) *(  VIEWPORT_WIDTH / 2 ) / 2;
	save_pos(move_x, move_y, move_z);

	if(flag==0){
		set_crop_textbox();
		crop.motion_init();
	}
}

void	Sphere::sphere_init(int flag)
{
	sides = SIDES;
        radius = (PBVRxmax-PBVRxmin)*(PBVRxmax-PBVRxmin) + (PBVRymax-PBVRymin)*(PBVRymax-PBVRymin) + (PBVRzmax-PBVRzmin)*(PBVRzmax-PBVRzmin);
        radius = sqrt (radius)/2.0F;
        radius = radius*PBVRCoordScale;
        Calc3vdCoord( PBVRxmax, PBVRxmin, PBVRxmin+(PBVRxmax-PBVRxmin)/2.0F, &center_x );
        Calc3vdCoord( PBVRymax, PBVRymin, PBVRymin+(PBVRymax-PBVRymin)/2.0F, &center_y );
        Calc3vdCoord( PBVRzmax, PBVRzmin, PBVRzmin+(PBVRzmax-PBVRzmin)/2.0F, &center_z );
        save_center_x = center_x;
        save_center_y = center_y;
        save_center_z = center_z;
        save_radius = radius;

        sradius = radius;
        scenterx = center_x;
        scentery = center_y;
        scenterz = center_z;

	move_x = center_x * ( VIEWPORT_WIDTH / 2 );
	move_y = center_y * ( VIEWPORT_HEIGHT / 2 );
	move_z = center_z * ( VIEWPORT_WIDTH / 2 );
	save_pos(move_x, move_y, move_z);

	if(flag==0){
		set_sphere_textbox();
		sphere.motion_init();
	}
	CalcPBVRCoord( PBVRxmax, PBVRxmin, scenterx, &tbscenterx );
	CalcPBVRCoord( PBVRymax, PBVRymin, scentery, &tbscentery );
	CalcPBVRCoord( PBVRzmax, PBVRzmin, scenterz, &tbscenterz );
	tbsradius = sradius / PBVRCoordScale;
}

void	Pillar::pillar_init(int flag)
{
        switch( obj_3d ){
         case    PILLARXY:
          radius = (PBVRxmax-PBVRxmin)*(PBVRxmax-PBVRxmin) + (PBVRymax-PBVRymin)*(PBVRymax-PBVRymin); 
          height = (PBVRzmax - PBVRzmin)*PBVRCoordScale;
          Calc3vdCoord( PBVRxmax, PBVRxmin, PBVRxmin+(PBVRxmax-PBVRxmin)/2.0F, &center_x );
          Calc3vdCoord( PBVRymax, PBVRymin, PBVRymin+(PBVRymax-PBVRymin)/2.0F, &center_y );
          Calc3vdCoord( PBVRzmax, PBVRzmin, PBVRzmin, &center_z );
         break;
         case    PILLARYZ:
          radius = (PBVRymax-PBVRymin)*(PBVRymax-PBVRymin) + (PBVRzmax-PBVRzmin)*(PBVRzmax-PBVRzmin); 
          height = (PBVRxmax - PBVRxmin)*PBVRCoordScale;
          Calc3vdCoord( PBVRxmax, PBVRxmin, PBVRxmin, &center_x );
          Calc3vdCoord( PBVRymax, PBVRymin, PBVRymin+(PBVRymax-PBVRymin)/2.0F, &center_y );
          Calc3vdCoord( PBVRzmax, PBVRzmin, PBVRzmin+(PBVRzmax-PBVRzmin)/2.0F, &center_z );
         break;
         case    PILLARXZ:
          radius = (PBVRxmax-PBVRxmin)*(PBVRxmax-PBVRxmin) + (PBVRzmax-PBVRzmin)*(PBVRzmax-PBVRzmin);
          height = (PBVRymax - PBVRymin)*PBVRCoordScale;
          Calc3vdCoord( PBVRxmax, PBVRxmin, PBVRxmin+(PBVRxmax-PBVRxmin)/2.0F, &center_x );
          Calc3vdCoord( PBVRymax, PBVRymin, PBVRymin, &center_y );
          Calc3vdCoord( PBVRzmax, PBVRzmin, PBVRzmin+(PBVRzmax-PBVRzmin)/2.0F, &center_z );
         break;
         default:
         break;
        }
        radius = sqrt (radius)/2.0F;
        radius = radius*PBVRCoordScale;
//printf("=== pillar_init() %f, %f, %f, %f, %f\n", center_x, center_y, center_z, radius, height);

	save_center_x = center_x; //0.0F;
	save_center_y = center_y; //0.0F;
	save_center_z = center_z; //-0.5F; //0.0F;
	save_radius = radius; //PRADIUS;
	save_height = height; //PHEIGHT;

	pradius = radius; //PRADIUS;
	pheight = height; //PHEIGHT;
	pcenterx = center_x; //0.0F;
	pcentery = center_y; //0.0F;
	pcenterz = center_z; //-0.5F; //0.0F;

	move_x = center_x * ( VIEWPORT_WIDTH / 2 );
	move_y = center_y * ( VIEWPORT_HEIGHT / 2 );
	move_z = center_z * ( VIEWPORT_WIDTH / 2 );
	save_pos(move_x, move_y, move_z);

	if(flag==0){
		set_pillar_textbox();
		motion_init();
	}

	save_tbpradius  = tbpradius;
	save_tbpheight  = tbpheight;
	save_tbpcenterx = tbpcenterx;
	save_tbpcentery = tbpcentery;
	save_tbpcenterz = tbpcenterz;
}

//Crop最大座標値のセット
void	SetCropMaxMin( float x, float y, float z )
{
	if( CropTrans | RIGHTSIDE ){
		CropXmax = save_cxmax + x/crop.scale_x;
	}
	if( CropTrans | LEFTSIDE ){
		CropXmin = save_cxmin + x/crop.scale_x;
	}
	if( CropTrans | TOPSIDE ){
		CropYmax = save_cymax + y/crop.scale_y;
	}
	if( CropTrans | BOTTOMSIDE ){
		CropYmin = save_cymin + y/crop.scale_y;
	}
	if( CropTrans | SURFSIDE ){
		CropZmax = save_czmax + z/crop.scale_z;
	}
	if( CropTrans | DEPTHSIDE ){
		CropZmin = save_czmin + z/crop.scale_z;
	}
}

//Sphere最大座標値のセット
void	SetSphereMaxMin( float x, float y, float z, float rad )
{
	if( ModifyMode == OFF ){
		if( x ){
			SphereXmin = sphere.save_center_x - sphere.radius/sphere.scale_x + x/sphere.scale_x;
			SphereXmax = sphere.save_center_x + sphere.radius/sphere.scale_x + x/sphere.scale_x;
		}
		if( y ){
			SphereYmin = sphere.save_center_y - sphere.radius/sphere.scale_y + y/sphere.scale_y;
			SphereYmax = sphere.save_center_y + sphere.radius/sphere.scale_y + y/sphere.scale_y;
		}
		if( z ){
			SphereZmin = sphere.save_center_z - sphere.radius/sphere.scale_z + z/sphere.scale_z;
			SphereZmax = sphere.save_center_z + sphere.radius/sphere.scale_z + z/sphere.scale_z;
		}
	}
	else{
		SphereXmin = sphere.save_center_x - sphere.save_radius/sphere.scale_x - rad;
		SphereXmax = sphere.save_center_x + sphere.save_radius/sphere.scale_x + rad;
		SphereYmin = sphere.save_center_y - sphere.save_radius/sphere.scale_y - rad;
		SphereYmax = sphere.save_center_y + sphere.save_radius/sphere.scale_y + rad;
		SphereZmin = sphere.save_center_z - sphere.save_radius/sphere.scale_z - rad;
		SphereZmax = sphere.save_center_z + sphere.save_radius/sphere.scale_z + rad;
	}
}


//Pillar最大座標値のセット
void	SetPillarXYMaxMin( float x, float y, float z, float rad, float heigttop, float heigtbase )
{
	if( ModifyMode == OFF ){
		if( x ){
			PillarXYXmin = pillar.save_center_x - pillar.radius / pillar.scale_x + x/pillar.scale_x;
			PillarXYXmax = pillar.save_center_x + pillar.radius / pillar.scale_x + x/pillar.scale_x;
		}
		if( y ){
			PillarXYYmin = pillar.save_center_y - pillar.radius / pillar.scale_y + y/pillar.scale_y;
			PillarXYYmax = pillar.save_center_y + pillar.radius / pillar.scale_y + y/pillar.scale_y;
		}
		if( z ){
			PillarXYZmin = pillar.save_center_z + z/pillar.scale_z;
			PillarXYZmax = pillar.save_center_z + pillar.height / pillar.scale_z + z/pillar.scale_z;
		}
	}

	else{
		PillarXYXmin = pillar.save_center_x - pillar.save_radius / pillar.scale_x - rad;
		PillarXYXmax = pillar.save_center_x + pillar.save_radius / pillar.scale_x + rad;
		PillarXYYmin = pillar.save_center_y - pillar.save_radius / pillar.scale_y - rad;
		PillarXYYmax = pillar.save_center_y + pillar.save_radius / pillar.scale_y + rad;
		if( heigttop ){
			PillarXYZmin = pillar.save_center_z;
			PillarXYZmax = pillar.save_center_z + ( pillar.save_height / pillar.scale_z ) + heigttop;
		}
		else if( heigtbase ){
			PillarXYZmin = pillar.save_center_z + heigtbase;
			PillarXYZmax = pillar.save_center_z + ( pillar.save_height / pillar.scale_z);
		}
	}
}

//Pillar最大座標値のセット
void	SetPillarXZMaxMin( float x, float y, float z, float rad, float heigttop, float heigtbase )
{
	if( ModifyMode == OFF ){
		if( x ){
			PillarXZXmin = pillarXZ.save_center_x - pillarXZ.radius / pillarXZ.scale_x + x/pillarXZ.scale_x;
			PillarXZXmax = pillarXZ.save_center_x + pillarXZ.radius / pillarXZ.scale_x + x/pillarXZ.scale_x;
		}
		if( y ){
			PillarXZYmin = pillarXZ.save_center_y + z/pillarXZ.scale_y;
			PillarXZYmax = pillarXZ.save_center_y + pillarXZ.height / pillarXZ.scale_y + y/pillarXZ.scale_y;
		}
		if( z ){
			PillarXZZmin = pillarXZ.save_center_z - pillarXZ.radius / pillarXZ.scale_z + z/pillarXZ.scale_z;
			PillarXZZmax = pillarXZ.save_center_z + pillarXZ.radius / pillarXZ.scale_z + z/pillarXZ.scale_z;
		}
	}

	else{
		PillarXZXmin = pillarXZ.save_center_x - pillarXZ.save_radius / pillarXZ.scale_x - rad;
		PillarXZXmax = pillarXZ.save_center_x + pillarXZ.save_radius / pillarXZ.scale_x + rad;
		PillarXZZmin = pillarXZ.save_center_z - pillarXZ.save_radius / pillarXZ.scale_z - rad;
		PillarXZZmax = pillarXZ.save_center_z + pillarXZ.save_radius / pillarXZ.scale_z + rad;
		if( heigttop ){
			PillarXZYmin = pillarXZ.save_center_y;
			PillarXZYmax = pillarXZ.save_center_y + ( pillarXZ.save_height / pillarXZ.scale_y ) + heigttop;
		}
		else if( heigtbase ){
			PillarXZYmin = pillarXZ.save_center_y + heigtbase;
			PillarXZYmax = pillarXZ.save_center_y + ( pillarXZ.save_height / pillarXZ.scale_y);
		}
	}
}

//Pillar最大座標値のセット
void	SetPillarYZMaxMin( float x, float y, float z, float rad, float heigttop, float heigtbase )
{
	if( ModifyMode == OFF ){
		if( x ){
			PillarYZXmin = pillarYZ.save_center_x + z/pillarYZ.scale_x;
			PillarYZXmax = pillarYZ.save_center_x + pillarYZ.height / pillarYZ.scale_x + x/pillarYZ.scale_x;
		}
		if( y ){
			PillarYZYmin = pillarYZ.save_center_y - pillarYZ.radius / pillarYZ.scale_y + y/pillarYZ.scale_y;
			PillarYZYmax = pillarYZ.save_center_y + pillarYZ.radius / pillarYZ.scale_y + y/pillarYZ.scale_y;
		}
		if( z ){
			PillarYZZmin = pillarYZ.save_center_z - pillarYZ.radius / pillarYZ.scale_z + z/pillarYZ.scale_z;
			PillarYZZmax = pillarYZ.save_center_z + pillarYZ.radius / pillarYZ.scale_z + z/pillarYZ.scale_z;
		}
	}

	else{
		PillarYZYmin = pillarYZ.save_center_y - pillarYZ.save_radius / pillarYZ.scale_y - rad;
		PillarYZYmax = pillarYZ.save_center_y + pillarYZ.save_radius / pillarYZ.scale_y + rad;
		PillarYZZmin = pillarYZ.save_center_z - pillarYZ.save_radius / pillarYZ.scale_z - rad;
		PillarYZZmax = pillarYZ.save_center_z + pillarYZ.save_radius / pillarYZ.scale_z + rad;
		if( heigttop ){
			PillarYZXmin = pillarYZ.save_center_x;
			PillarYZXmax = pillarYZ.save_center_x + ( pillarYZ.save_height / pillarYZ.scale_x ) + heigttop;
		}
		else if( heigtbase ){
			PillarYZXmin = pillarYZ.save_center_x + heigtbase;
			PillarYZXmax = pillarYZ.save_center_x + ( pillarYZ.save_height / pillarYZ.scale_x );
		}
	}
}

//拡大/縮小割合のセット
void	Motion::set_scale( float x, float y, float z )
{
	if( x )
		scale_x = x;
	if( y )
		scale_y = y;
	if( z )
		scale_z = z;
}

//拡大・縮小率の計算
void	Motion::scaling( float x, float y, float z )
{
	//０で指定された方向の倍率は更新しない
	if( x )
		scale_x *= x;
	if( y )
		scale_y *= y;
	if( z )
		scale_z *= z;
}

//マウスボタンを押したときの座標を保持
void	Motion::set_prev( int x, int y, int z )
{
	prev_x = x;
	prev_y = y;
	prev_z = z;
}

//マウスボタンを押した時から離すまでの移動量を保持
void	Motion::save_pos( int x, int y, int z )
{
	if( x )
		save_x = x;
	if( y )
		save_y = y ;
	if( z )
		save_z = z ;
}

//移動距離を計算しセット
void	Motion::set_pos( int x, int y, int z )
{
	//０で指定された方向の座標は更新しない
	if( prev_x && x){
		move_x = save_x + x - prev_x;
	}
	if( prev_y && y ){
		move_y = save_y + y - prev_y;
	}
	if( prev_z && z ){
		move_z = save_z + z - prev_z;
	}
}

//直方体・指定倍率での拡大/縮小処理
void	Crop::crop_scaling( float scalex, float scaley, float scalez ){

	ModifyMode = ON;

	if( scalex && scaley && scalez ){
		CropTrans = ( RIGHTSIDE | LEFTSIDE | TOPSIDE | BOTTOMSIDE | SURFSIDE | DEPTHSIDE );
		SetCropMaxMin( crop.side_x * ( 1 - scalex ), crop.side_y * ( 1 - scaley ), crop.side_z * ( 1 - scalez ));

		if((( crop.side_x * scalex > SCALEMIN ) && ( crop.side_y * scaley > SCALEMIN ) && ( crop.side_z * scalez > SCALEMIN ))){

			if((( CropXmin >= Xmin*2 ) && (( CropXmax <= Xmax*2 ) || ( scalex < 1.0 ))) 
				&& (( CropYmin >= Ymin*2 ) && (( CropYmax <= Ymax*2 ) || ( scaley < 1.0 )))
				&& (( CropZmin >= Zmin*2 ) && (( CropZmax <= Zmax*2 ) || ( scalez < 1.0 )))){

				crop.side_x *=  scalex;
				crop.side_y *=  scaley;
				crop.side_z *=  scalez;

				set_crop_textdata();
				param3vd.CropParaSet();
				save_cxmax = cxmaxlevel2;
				save_cxmin = cxminlevel2;
				save_cymax = cymaxlevel2;
				save_cymin = cyminlevel2;
				save_czmax = czmaxlevel2;
				save_czmin = czminlevel2;
			}

			ModifyMode = OFF;
			CropTrans = OFF;
			return;
		}
	}


	else if( scalex ){
		CropTrans |= ( RIGHTSIDE | LEFTSIDE );
		SetCropMaxMin( crop.side_x * ( 1 - scalex ), 0, 0 );
		if((( CropXmin >= Xmin*2 ) && (( CropXmax <= Xmax*2 )|| ( scalex < 1.0 )) && ( crop.side_x * scalex > SCALEMIN ))){

			crop.side_x *=  scalex;
			set_crop_textdata();
			param3vd.CropParaSet();
			save_cxmax = cxmaxlevel2;
			save_cxmin = cxminlevel2;
		}
	}

	else if( scaley ){
		CropTrans |= ( TOPSIDE | BOTTOMSIDE );
		SetCropMaxMin( 0, crop.side_y * ( 1 - scaley ), 0 );
		if((( CropYmin >= Ymin*2 ) && (( CropYmax <= Ymax*2 ) || ( scaley < 1.0 )) && ( crop.side_y * scaley > SCALEMIN ))){

			crop.side_y *=  scaley;
			set_crop_textdata();
			param3vd.CropParaSet();
			save_cymax = cymaxlevel2;
			save_cymin = cyminlevel2;
		}
	}

	else if( scalez ){
		CropTrans |= ( SURFSIDE | DEPTHSIDE );
		SetCropMaxMin( 0, 0, crop.side_z * ( 1 - scalez ));
		if((( CropZmin >= Zmin*2 ) && (( CropZmax <= Zmax*2 ) || ( scalez < 1.0 )) && ( crop.side_z * scalez > SCALEMIN ))){

			crop.side_z *=  scalez;
			set_crop_textdata();
			param3vd.CropParaSet();
			save_czmax = czmaxlevel2;
			save_czmin = czminlevel2;
		}
	}
	ModifyMode = OFF;
	CropTrans = OFF;
}

//球・指定倍率での拡大/縮小処理
void	Sphere::sphere_scaling( float scalex, float scaley, float scalez ){

	ModifyMode = ON;
	SetSphereMaxMin( 0, 0, 0, sphere.radius * ( scalex - 1 ) );

	if(( SphereXmin >= Xmin*2 ) && (( SphereXmax <= Xmax*2 ) || ( scalex < 1.0 ))
		&& ( SphereYmin >= Ymin*2 ) && (( SphereYmax <= Ymax*2 ) || ( scaley < 1.0 ))
		&& ( SphereZmin >= Zmin*2 ) && (( SphereZmax <= Zmax*2 ) || ( scalez < 1.0 )) && ( sphere.radius * scalex > SCALEMIN )){

			sphere.radius *= scalex;
			set_sphere_textdata();
			param3vd.SphereParaSet();
			save_radius = radius;
	}

	ModifyMode = OFF;
}

//円柱・指定倍率での拡大/縮小処理
void	Pillar::pillar_scaling( float scalex, float scaley, float scalez ){

	ModifyMode = ON;
	if( scalex && scaley && scalez ){
	switch( obj_3d ){

		case	PILLARXY:

			SetPillarXYMaxMin( 0, 0, 0, pillar.radius * ( scalex - 1 ), pillar.height * ( scalez - 1 ), 0 );

			if(( PillarXYXmin >= Xmin*2 ) && (( PillarXYXmax <= Xmax*2 ) || ( scalex < 1.0 ))
				&& ( PillarXYYmin >= Ymin*2 ) && (( PillarXYYmax <= Ymax*2 ) || ( scaley < 1.0 ))
				&& ( PillarXYZmin >= Zmin*2 ) && (( PillarXYZmax <= Zmax*2 ) || ( scalez < 1.0 ))){
				if(( pillar.radius * scalex > SCALEMIN ) && ( pillar.height * scalez > SCALEMIN )){

					pillar.radius *= scaley;
					pillar.height *= scalez;
					set_pillar_textdata();
					param3vd.PillarParaSet();
					save_radius = radius;
					save_height = height;
				}
			}
		break;

		case	PILLARYZ:
			SetPillarYZMaxMin( 0, 0, 0, pillarYZ.radius * ( scaley - 1 ), pillarYZ.height * ( scalex - 1 ), 0 );

			if(( PillarYZXmin >= Xmin*2 ) && (( PillarYZXmax <= Xmax*2 ) || ( scalex < 1.0 ))
				&& ( PillarYZYmin >= Ymin*2 ) && (( PillarYZYmax <= Ymax*2 ) || ( scaley < 1.0 ))
				&& ( PillarYZZmin >= Zmin*2 ) && (( PillarYZZmax <= Zmax*2 ) || ( scalez < 1.0 ))){
				if(( pillarYZ.radius * scaley > SCALEMIN ) && ( pillarYZ.height * scalex > SCALEMIN )){

					pillarYZ.radius *= scaley;
					pillarYZ.height *= scalex;
					set_pillar_textdata();
					param3vd.PillarParaSet();
					save_radius = radius;
					save_height = height;
				}
			}
		break;

		case	PILLARXZ:

			SetPillarXZMaxMin( 0, 0, 0, pillarXZ.radius * ( scalex - 1 ), pillarXZ.height * ( scaley - 1 ), 0 );

			if(( PillarXZXmin >= Xmin*2 ) && (( PillarXZXmax <= Xmax*2 ) || ( scalex < 1.0 ))
				&& ( PillarXZYmin >= Ymin*2 ) && (( PillarXZYmax <= Ymax*2 ) || ( scaley < 1.0 ))
				&& ( PillarXZZmin >= Zmin*2 ) && (( PillarXZZmax <= Zmax*2 ) || ( scalez < 1.0 ))){
				if(( pillarXZ.radius * scalex > SCALEMIN ) && ( pillarXZ.height * scaley > SCALEMIN )){

					pillarXZ.radius *= scaley;
					pillarXZ.height *= scalez;
					set_pillar_textdata();
					param3vd.PillarParaSet();
					save_radius = radius;
					save_height = height;
				}
			}
		break;

	default:
		break;
	}

	ModifyMode = OFF;
	return;
	}

	switch( obj_3d ){

		case	PILLARXY:

		if( scalex ){
			SetPillarXYMaxMin( 0, 0, 0, pillar.radius * ( scalex - 1 ), 0, 0 );

			if(( PillarXYXmin >= Xmin ) && (( PillarXYXmax <= Xmax*2 ) || ( scalex < 1.0 )) && ( pillar.radius * scalex >= SCALEMIN )){ 
				pillar.radius *= scalex;
				set_pillar_textdata();
				param3vd.PillarParaSet();
				save_radius = radius;
			}	
		}

		if( scaley ){
			SetPillarXYMaxMin( 0, 0, 0, pillar.radius * ( scaley - 1 ), 0, 0 );

			if(( PillarXYYmin >= Ymin ) && (( PillarXYYmax <= Ymax*2 ) || ( scaley < 1.0 )) && ( pillar.radius * scaley >= SCALEMIN )){ 
				pillar.radius *= scaley;
				set_pillar_textdata();
				param3vd.PillarParaSet();
				save_radius = radius;
			}	
		}

		if( scalez ){
			SetPillarXYMaxMin( 0, 0, 0, 0, pillar.height * ( scalez - 1 ), 0 );
			if(( PillarXYZmin >= Zmin ) && (( PillarXYZmax <= Zmax*2 ) || ( scalez < 1.0 )) && ( pillar.height * scalez > SCALEMIN )){ 
				pillar.height *= scalez;
				set_pillar_textdata();
				param3vd.PillarParaSet();
				save_height = height;
				}
			}
		break;

		case	PILLARYZ:

		if( scalex ){
			SetPillarYZMaxMin( 0, 0, 0, pillarYZ.height * ( scalex - 1 ), 0, 0 );

			if(( PillarYZXmin >= Xmin*2 ) && (( PillarYZXmax <= Xmax*2 ) || ( scalex < 1.0 )) && ( pillarYZ.height * scalex >= SCALEMIN )){ 
				pillarYZ.height *= scalex;
				set_pillar_textdata();
				param3vd.PillarParaSet();
				save_height = height;
			}	
		}

		if( scaley ){
			SetPillarYZMaxMin( 0, 0, 0, pillarYZ.radius * ( scaley - 1 ), 0, 0 );

			if(( PillarYZYmin >= Ymin*2 ) && (( PillarYZYmax <= Ymax*2 ) || ( scaley < 1.0 )) && ( pillarYZ.radius * scaley >= SCALEMIN )){ 
				pillarYZ.radius *= scaley;
				set_pillar_textdata();
				param3vd.PillarParaSet();
				save_radius = radius;
			}	
		}

		if( scalez ){
			SetPillarYZMaxMin( 0, 0, 0, 0, pillarYZ.radius * ( scalez - 1 ), 0 );
			if(( PillarYZZmin >= Zmin*2 ) && (( PillarYZZmax <= Zmax*2 ) || ( scalez < 1.0 )) && ( pillarYZ.radius * scalez > SCALEMIN )){ 
				pillar.radius *= scalez;
				set_pillar_textdata();
				param3vd.PillarParaSet();
				save_radius = radius;
				}
			}
		break;

		case	PILLARXZ:

		if( scalex ){
			SetPillarXZMaxMin( 0, 0, 0, pillarXZ.radius * ( scalex - 1 ), 0, 0 );

			if(( PillarXZXmin >= Xmin*2 ) && (( PillarXZXmax <= Xmax*2 ) || ( scalex < 1.0 )) && ( pillarXZ.radius * scalex >= SCALEMIN )){ 
				pillarXZ.radius *= scalex;
				set_pillar_textdata();
				param3vd.PillarParaSet();
				save_radius = radius;
			}	
		}

		if( scaley ){
			SetPillarXZMaxMin( 0, 0, 0, pillarXZ.height * ( scaley - 1 ), 0, 0 );

			if(( PillarXZYmin >= Ymin*2 ) && (( PillarXZYmax <= Ymax*2 ) || ( scaley < 1.0 )) && ( pillarXZ.height * scaley >= SCALEMIN )){ 
				pillarXZ.height *= scaley;
				set_pillar_textdata();
				param3vd.PillarParaSet();
				save_height = height;
			}	
		}

		if( scalez ){
			SetPillarXZMaxMin( 0, 0, 0, 0, pillarXZ.radius * ( scalez - 1 ), 0 );
			if(( PillarXZZmin >= Zmin*2 ) && (( PillarXZZmax <= Zmax*2 ) || ( scalez < 1.0 )) && ( pillarXZ.radius * scalez > SCALEMIN )){ 
				pillarXZ.radius *= scalez;
				set_pillar_textdata();
				param3vd.PillarParaSet();
				save_radius = radius;
				}
			}
		break;

	default:
		break;
	}

	ModifyMode = OFF;
}

//マウスイベント コールバック
void	MouseFunc( int button, int state, int x, int y)
{
	//特殊キー押下状態
	modifier = glutGetModifiers();

	switch (button ) {

		case ( GLUT_LEFT_BUTTON ):

		//マウス左ボタンDOWN
		if (state == GLUT_DOWN){

			//コントロールキーが押されていたら、変形モード
			if( modifier == GLUT_ACTIVE_CTRL ){
				ModifyMode |= MODIFIMODE;
			}

			//シフトキーが押されていたら、拡大モード
			if( modifier == GLUT_ACTIVE_SHIFT ){
 				switch( obj_3d ){
					case	CROP:
						crop.crop_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
						break;
					case	SPHERE:
						sphere.sphere_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
						break;
					case	PILLARXY:
						pillar.pillar_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
						break;
					case	PILLARYZ:
						pillarYZ.pillar_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
						break;
					case	PILLARXZ:
						pillarXZ.pillar_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
						break;
					default:
						break;
				}
			}

			//移動モード or 変形モード
			else{
				if(( 0 <= x ) && ( x < VIEWPORT_WIDTH)  && ( 0 <= y ) && ( y < VIEWPORT_HEIGHT )){
					win_sel = X_VIEW;
					clicking = ON;
	  				switch( obj_3d ){
						case	CROP:
							MouseCropX(  button, state, x, y );
							break;
						case	SPHERE:
							MouseSphereX(  button, state, x, y );
							break;
						case	PILLARXY:
							MousePillarXY_X(  button, state, x, y );
							break;
						case	PILLARYZ:
							MousePillarYZ_X(  button, state, x, y );
							break;
						case	PILLARXZ:
							MousePillarXZ_X(  button, state, x, y );
							break;
						default:
							break;
					}
				}
				else if(( VIEWPORT_WIDTH <= x ) && ( x <= VIEWPORT_WIDTH * 2) && ( y > VIEWPORT_HEIGHT  ) && ( VIEWPORT_HEIGHT * 2 >= y )){
					win_sel = Y_VIEW;
					clicking = ON;
	  				switch( obj_3d ){
						case	CROP:
							MouseCropY(  button, state, x, y );
							break;
						case	SPHERE:
							MouseSphereY(  button, state, x, y );
							break;
						case	PILLARXY:
							MousePillarXY_Y(  button, state, x, y );
							break;
						case	PILLARYZ:
							MousePillarYZ_Y(  button, state, x, y );
							break;
						case	PILLARXZ:
							MousePillarXZ_Y(  button, state, x, y );
							break;
						default:
							break;
					}
				}
				else if(( VIEWPORT_WIDTH <= x ) && ( x <= VIEWPORT_WIDTH * 2)  && ( 0 <= y ) && ( y < VIEWPORT_HEIGHT )){
					win_sel = Z_VIEW;
					clicking = ON;
	  				switch( obj_3d ){
						case	CROP:
							MouseCropZ(  button, state, x, y );
							break;
						case	SPHERE:
							MouseSphereZ(  button, state, x, y );
							break;
						case	PILLARXY:
							MousePillarXY_Z(  button, state, x, y );
							break;
						case	PILLARYZ:
							MousePillarYZ_Z(  button, state, x, y );
							break;
						case	PILLARXZ:
							MousePillarXZ_Z(  button, state, x, y );
							break;
						default:
							break;
					}
				}
			}
#ifdef __APPLE__
			display_3vd();
#endif
		}

		//マウス左ボタンUP
		else if (state == GLUT_UP){

			if( win_sel == X_VIEW ){
	  			switch( obj_3d ){
					case	CROP:
						MouseCropX(  button, state, x, y );
						break;
					case	SPHERE:
						MouseSphereX(  button, state, x, y );
						break;
					case	PILLARXY:
						MousePillarXY_X(  button, state, x, y );
						break;
					case	PILLARYZ:
						MousePillarYZ_X(  button, state, x, y );
						break;
					case	PILLARXZ:
						MousePillarXZ_X(  button, state, x, y );
						break;
					default:
						break;
				}
			}
			else if( win_sel == Y_VIEW ){
	  			switch( obj_3d ){
					case	CROP:
						MouseCropY(  button, state, x, y );
						break;
					case	SPHERE:
						MouseSphereY(  button, state, x, y );
						break;
					case	PILLARXY:
						MousePillarXY_Y(  button, state, x, y );
						break;
					case	PILLARYZ:
						MousePillarYZ_Y(  button, state, x, y );
						break;
					case	PILLARXZ:
						MousePillarXZ_Y(  button, state, x, y );
						break;
					default:
						break;
				}
			}
			else if( win_sel == Z_VIEW ){
	  			switch( obj_3d ){
					case	CROP:
						MouseCropZ(  button, state, x, y );
						break;
					case	SPHERE:
						MouseSphereZ(  button, state, x, y );
						break;
					case	PILLARXY:
						MousePillarXY_Z(  button, state, x, y );
						break;
					case	PILLARYZ:
						MousePillarYZ_Z(  button, state, x, y );
						break;
					case	PILLARXZ:
						MousePillarXZ_Z(  button, state, x, y );
						break;
					default:
						break;
				}
			}
			clicking = OFF;
		}

		break;

	case ( GLUT_RIGHT_BUTTON ):

		//マウス右ボタンDOWN
		if (state == GLUT_DOWN){

			//シフトキーが押されていたら、縮小モード
			if( modifier == GLUT_ACTIVE_SHIFT )
				{
				switch( obj_3d ){
					case	CROP:
						crop.crop_scaling( REDSCALE, REDSCALE, REDSCALE );
						break;
					case	SPHERE:
						sphere.sphere_scaling( REDSCALE, REDSCALE, REDSCALE );
						break;
					case	PILLARXY:
						pillar.pillar_scaling( REDSCALE, REDSCALE, REDSCALE );
						break;
					case	PILLARYZ:
						pillarYZ.pillar_scaling( REDSCALE, REDSCALE, REDSCALE );
						break;
					case	PILLARXZ:
						pillarXZ.pillar_scaling( REDSCALE, REDSCALE, REDSCALE );
						break;
					default:
						break;
					}
				}
			}
	default:
		break;
	}
}

//マウスボタン押下処理（直方体・X軸視点）
void	MouseCropX( int button, int state, int x, int y){

	//マウス左ボタンDOWN
	if (state == GLUT_DOWN){
		crop.set_prev( 0, VIEWPORT_HEIGHT - y, x );

		//＋コントロールキー＝直方体の変形
		if( ModifyMode ){

			// 直方体の上半分を掴むと、上辺を変形
			if(((( crop.prev_y-VIEWPORT_HEIGHT/2)/((float)VIEWPORT_HEIGHT/2 ))) >=  ( save_cymin + ( save_cymax - save_cymin) / 2 )){
				ModifyMode |= TOPSIDE;
			}

			// 直方体の下半分を掴むと、下辺を変形
			else{
				ModifyMode |= BOTTOMSIDE;
			}

			// 直方体の右半分を掴むと、右辺を変形
			if(((( crop.prev_z - VIEWPORT_WIDTH/2 )/((float)VIEWPORT_WIDTH/2 ))  ) >=  ( save_czmin + ( save_czmax - save_czmin) / 2 )){
				ModifyMode |= RIGHTSIDE;
			}

			// 直方体の左半分を掴むと、左辺を変形
			else{
				ModifyMode |= LEFTSIDE;
			}
		}
	}

	//左ボタンUP  移動量と変形された形を保持
	else if (state == GLUT_UP){
		crop.save_pos( 0, crop.move_y, crop.move_z );
		save_cxmax = cxmaxlevel2;
		save_cxmin = cxminlevel2;
		save_cymax = cymaxlevel2;
		save_cymin = cyminlevel2;
		save_czmax = czmaxlevel2;
		save_czmin = czminlevel2;

		if( ModifyMode )
			ModifyMode = OFF;
	}
}

//マウスボタン押下処理（球・X軸視点）
void	MouseSphereX( int button, int state, int x, int y){

	//マウス左ボタンDOWN
	if (state == GLUT_DOWN){		//マウスが押された状態
		sphere.set_prev( 0, VIEWPORT_HEIGHT - y, x );

		//＋コントロールキー＝球の変形

		if( ModifyMode ){
			// 球の上半分を掴むと、上辺を変形
			if(((sphere.prev_y-VIEWPORT_HEIGHT/2)/((float)VIEWPORT_HEIGHT/2 )) >=  sphere.save_center_y ){
				ModifyMode |= TOPSIDE;
			}
			// 球の下半分を掴むと、下辺を変形
			else{
				ModifyMode |= BOTTOMSIDE;
			}

			// 球の右半分を掴むと、右辺を変形
			if((( sphere.prev_z - VIEWPORT_WIDTH/2 )/((float)VIEWPORT_WIDTH/2 )) >=  sphere.save_center_z ){
				ModifyMode |= RIGHTSIDE;
			}

			// 球の左半分を掴むと、左辺を変形
			else{
				ModifyMode |= LEFTSIDE;
			}
		}
	}
	else if (state == GLUT_UP){
		sphere.save_pos( 0, sphere.move_y, sphere.move_z );

		sphere.save_center_x = sphere.center_x;
		sphere.save_center_y = sphere.center_y;
		sphere.save_center_z = sphere.center_z;
		sphere.save_radius = sphere.radius;

		if( ModifyMode )
			ModifyMode = OFF;
	}
}

//マウスボタン押下処理（円柱・X軸視点）
void	MousePillarXY_X( int button, int state, int x, int y){

	//マウス左ボタンDOWN
	if (state == GLUT_DOWN){		//マウスが押された状態
		pillar.set_prev( 0, VIEWPORT_HEIGHT - y, x );

		//＋コントロールキー＝円柱の変形
		if( ModifyMode ){

			// 円柱の上半分を掴むと、上辺を変形
			if((( pillar.prev_y-VIEWPORT_HEIGHT/2)/((float)VIEWPORT_HEIGHT/2 )) >=  pillar.save_center_y ){
				ModifyMode |= TOPSIDE;
			}

			// 円柱の下半分を掴むと、下辺を変形
			else{
				ModifyMode |= BOTTOMSIDE;
			}

			// 円柱の右半分を掴むと、右辺を変形
			if((( pillar.prev_z - VIEWPORT_WIDTH/2 )/((float)VIEWPORT_WIDTH/2 )) >=  pillar.save_center_z + pillar.save_height/2 ){
				ModifyMode |= RIGHTSIDE;
			}

			// 円柱の左半分を掴むと、左辺を変形
			else{
				ModifyMode |= LEFTSIDE;
			}
		}
	}

	else if (state == GLUT_UP){
		pillar.save_pos( 0, pillar.move_y, pillar.move_z );
		pillar.save_center_x = pillar.center_x;
		pillar.save_center_y = pillar.center_y;
		pillar.save_center_z = pillar.center_z;
		pillar.save_radius = pillar.radius;
		pillar.save_height = pillar.height;

	if( ModifyMode )
		ModifyMode = OFF;
	}
}

void	MousePillarXZ_X( int button, int state, int x, int y){

	//マウス左ボタンDOWN
	if (state == GLUT_DOWN){		//マウスが押された状態
		pillarXZ.set_prev( 0, VIEWPORT_HEIGHT - y, x );

		//＋コントロールキー＝円柱の変形
		if( ModifyMode ){

			// 円柱の上半分を掴むと、上辺を変形
			if((( pillarXZ.prev_y-VIEWPORT_HEIGHT/2)/((float)VIEWPORT_HEIGHT/2 )) >=  pillarXZ.save_center_y + pillarXZ.save_height/2 ){
				ModifyMode |= TOPSIDE;
			}

			// 円柱の下半分を掴むと、下辺を変形
			else{
				ModifyMode |= BOTTOMSIDE;
			}

			// 円柱の右半分を掴むと、右辺を変形
			if((( pillarXZ.prev_z - VIEWPORT_WIDTH/2 )/((float)VIEWPORT_WIDTH/2 )) >=  pillarXZ.save_center_z ){
				ModifyMode |= RIGHTSIDE;
			}

			// 円柱の左半分を掴むと、左辺を変形
			else{
				ModifyMode |= LEFTSIDE;
			}
		}
	}

	else if (state == GLUT_UP){
		pillarXZ.save_pos( 0, pillarXZ.move_y, pillarXZ.move_z );
		pillarXZ.save_center_x = pillarXZ.center_x;
		pillarXZ.save_center_y = pillarXZ.center_y;
		pillarXZ.save_center_z = pillarXZ.center_z;
		pillarXZ.save_radius = pillarXZ.radius;
		pillarXZ.save_height = pillarXZ.height;

	if( ModifyMode )
		ModifyMode = OFF;
	}
}

void	MousePillarYZ_X( int button, int state, int x, int y){

	//マウス左ボタンDOWN
	if (state == GLUT_DOWN){		//マウスが押された状態
		pillarYZ.set_prev( 0, VIEWPORT_HEIGHT - y, x );

		//＋コントロールキー＝円柱の変形
		if( ModifyMode ){

			// 円柱の上半分を掴むと、上辺を変形
			if((( pillarYZ.prev_y-VIEWPORT_HEIGHT/2)/((float)VIEWPORT_HEIGHT/2 )) >=  pillarYZ.save_center_y ){
				ModifyMode |= TOPSIDE;
			}

			// 円柱の下半分を掴むと、下辺を変形
			else{
				ModifyMode |= BOTTOMSIDE;
			}

			// 円柱の右半分を掴むと、右辺を変形
			if((( pillarYZ.prev_z - VIEWPORT_WIDTH/2 )/((float)VIEWPORT_WIDTH/2 )) >=  pillarYZ.save_center_z ){
				ModifyMode |= RIGHTSIDE;
			}

			// 円柱の左半分を掴むと、左辺を変形
			else{
				ModifyMode |= LEFTSIDE;
			}
		}
	}

	else if (state == GLUT_UP){

		pillarYZ.save_pos( 0, pillarYZ.move_y, pillarYZ.move_z );
		pillarYZ.save_center_x = pillarYZ.center_x;
		pillarYZ.save_center_y = pillarYZ.center_y;
		pillarYZ.save_center_z = pillarYZ.center_z;
		pillarYZ.save_radius = pillarYZ.radius;
		pillarYZ.save_height = pillarYZ.height;

	if( ModifyMode )
		ModifyMode = OFF;
	}
}

//マウスボタン押下処理（直方体・Y軸視点）
void	MouseCropY( int button, int state, int x, int y){

	//マウス左ボタンDOWN
	if (state == GLUT_DOWN){
	
		crop.set_prev( x, 0, y );

		//＋コントロールキー＝直方体の変形
		if( ModifyMode ){

			// 直方体の上半分を掴むと、上辺を変形
			if(((( crop.prev_z - VIEWPORT_HEIGHT/2 - VIEWPORT_HEIGHT )/((float)VIEWPORT_HEIGHT/2 ))) >=  ( save_czmin + ( save_czmax - save_czmin) / 2 )){
				ModifyMode |= TOPSIDE;
			}

			// 直方体の下半分を掴むと、下辺を変形
			else{
				ModifyMode |= BOTTOMSIDE;
			}

			// 直方体の右半分を掴むと、右辺を変形
			if(((( crop.prev_x-VIEWPORT_WIDTH/2 - VIEWPORT_WIDTH )/((float)VIEWPORT_WIDTH/2 ))  ) >=  ( save_cxmin + ( save_cxmax - save_cxmin) / 2 )){
				ModifyMode |= RIGHTSIDE;
			}

			// 直方体の左半分を掴むと、左辺を変形
			else{
				ModifyMode |= LEFTSIDE;
			}
		}
	}

	//左ボタンUP  移動量と変形された形を保持
	else if (state == GLUT_UP){
		crop.save_pos( crop.move_x, 0, crop.move_z );
		save_cxmax = cxmaxlevel2;
		save_cxmin = cxminlevel2;
		save_cymax = cymaxlevel2;
		save_cymin = cyminlevel2;
		save_czmax = czmaxlevel2;
		save_czmin = czminlevel2;

		if( ModifyMode )
			ModifyMode = OFF;
	}
}

//マウスボタン押下処理（球・Y軸視点）
void	MouseSphereY( int button, int state, int x, int y){

	//マウス左ボタンDOWN
	if (state == GLUT_DOWN){

		sphere.set_prev( x, 0, y );

		//＋コントロールキー＝球の変形

		if( ModifyMode ){
			// 球の上半分を掴むと、上辺を変形
			if(-((sphere.prev_z-VIEWPORT_HEIGHT-VIEWPORT_HEIGHT/2)/((float)VIEWPORT_HEIGHT/2 )) >=  -sphere.save_center_z ){
				ModifyMode |= TOPSIDE;
			}
			// 球の下半分を掴むと、下辺を変形
			else{
				ModifyMode |= BOTTOMSIDE;
			}

			// 球の右半分を掴むと、右辺を変形
			if((( sphere.prev_x - VIEWPORT_WIDTH - VIEWPORT_WIDTH/2 )/((float)VIEWPORT_WIDTH/2 )) >=  sphere.save_center_x ){
				ModifyMode |= RIGHTSIDE;
			}

			// 球の左半分を掴むと、左辺を変形
			else{
				ModifyMode |= LEFTSIDE;
			}
		}
	}

	else if (state == GLUT_UP){
		sphere.save_pos( sphere.move_x, 0, sphere.move_z );
		sphere.save_center_x = sphere.center_x;
		sphere.save_center_y = sphere.center_y;
		sphere.save_center_z = sphere.center_z;
		sphere.save_radius = sphere.radius;

		if( ModifyMode )
			ModifyMode = OFF;
	}
}

//マウスボタン押下処理（円柱・Y軸視点）
void	MousePillarXY_Y( int button, int state, int x, int y){

	//マウス左ボタンDOWN
	if (state == GLUT_DOWN){

		pillar.set_prev( x, 0, -( VIEWPORT_HEIGHT - y ));

		//＋コントロールキー＝円柱の変形
		if( ModifyMode ){

			// 円柱の上半分を掴むと、上辺を変形
			if(((( pillar.prev_z-VIEWPORT_HEIGHT/2 )/((float)VIEWPORT_HEIGHT/2 ))/pillar.scale_z) >=  pillar.save_center_z + pillar.save_height/2 ){
				ModifyMode |= TOPSIDE;
			}

			// 円柱の下半分を掴むと、下辺を変形
			else{
				ModifyMode |= BOTTOMSIDE;
			}

			// 円柱の右半分を掴むと、右辺を変形
			if(((( pillar.prev_x-VIEWPORT_HEIGHT-VIEWPORT_WIDTH/2)/((float)VIEWPORT_WIDTH/2 ))/pillar.scale_x) >=  pillar.save_center_x ){
				ModifyMode |= RIGHTSIDE;
			}

			// 円柱の左半分を掴むと、左辺を変形
			else{
				ModifyMode |= LEFTSIDE;
			}
		}
	}

	else if (state == GLUT_UP){

		pillar.save_pos( pillar.move_x, 0, pillar.move_z );
		pillar.save_center_x = pillar.center_x;
		pillar.save_center_y = pillar.center_y;
		pillar.save_center_z = pillar.center_z;
		pillar.save_radius = pillar.radius;
		pillar.save_height = pillar.height;

		if( ModifyMode )
			ModifyMode = OFF;
	}
}

//マウスボタン押下処理（円柱・Y軸視点）
void	MousePillarXZ_Y( int button, int state, int x, int y){

	//マウス左ボタンDOWN
	if (state == GLUT_DOWN){

		pillarXZ.set_prev( x, 0, -( VIEWPORT_HEIGHT - y ));

		//＋コントロールキー＝円柱の変形
		if( ModifyMode ){

			// 円柱の上半分を掴むと、上辺を変形
			if(((( pillarXZ.prev_z-VIEWPORT_HEIGHT/2 )/((float)VIEWPORT_HEIGHT/2 ))/pillarXZ.scale_z) >=  pillarXZ.save_center_z ){
				ModifyMode |= TOPSIDE;
			}

			// 円柱の下半分を掴むと、下辺を変形
			else{
				ModifyMode |= BOTTOMSIDE;
			}

			// 円柱の右半分を掴むと、右辺を変形
			if(((( pillarXZ.prev_x-VIEWPORT_HEIGHT-VIEWPORT_WIDTH/2)/((float)VIEWPORT_WIDTH/2 ))/pillarXZ.scale_x) >=  pillarXZ.save_center_x ){
				ModifyMode |= RIGHTSIDE;
			}

			// 円柱の左半分を掴むと、左辺を変形
			else{
				ModifyMode |= LEFTSIDE;
			}
		}
	}

	else if (state == GLUT_UP){

		pillarXZ.save_pos( pillarXZ.move_x, 0, pillarXZ.move_z );
		pillarXZ.save_center_x = pillarXZ.center_x;
		pillarXZ.save_center_y = pillarXZ.center_y;
		pillarXZ.save_center_z = pillarXZ.center_z;
		pillarXZ.save_radius = pillarXZ.radius;
		pillarXZ.save_height = pillarXZ.height;

		if( ModifyMode )
			ModifyMode = OFF;
	}
}

//マウスボタン押下処理（円柱・Y軸視点）
void	MousePillarYZ_Y( int button, int state, int x, int y){

	//マウス左ボタンDOWN
	if (state == GLUT_DOWN){

		pillarYZ.set_prev( x, 0, -( VIEWPORT_HEIGHT - y ));

		//＋コントロールキー＝円柱の変形
		if( ModifyMode ){

			// 円柱の上半分を掴むと、上辺を変形
			if(((( pillarYZ.prev_z-VIEWPORT_HEIGHT/2 )/((float)VIEWPORT_HEIGHT/2 ))/pillarYZ.scale_z) >=  pillarYZ.save_center_z ){
				ModifyMode |= TOPSIDE;
			}

			// 円柱の下半分を掴むと、下辺を変形
			else{
				ModifyMode |= BOTTOMSIDE;
			}

			// 円柱の右半分を掴むと、右辺を変形
			if(((( pillarYZ.prev_x-VIEWPORT_HEIGHT-VIEWPORT_WIDTH/2)/((float)VIEWPORT_WIDTH/2 ))/pillarYZ.scale_x) >=  pillarYZ.save_center_x + pillarYZ.save_height/2 ){
				ModifyMode |= RIGHTSIDE;
			}

			// 円柱の左半分を掴むと、左辺を変形
			else{
				ModifyMode |= LEFTSIDE;
			}
		}
	}

	else if (state == GLUT_UP){

		pillarYZ.save_pos( pillarYZ.move_x, 0, pillarYZ.move_z );
		pillarYZ.save_center_x = pillarYZ.center_x;
		pillarYZ.save_center_y = pillarYZ.center_y;
		pillarYZ.save_center_z = pillarYZ.center_z;
		pillarYZ.save_radius = pillarYZ.radius;
		pillarYZ.save_height = pillarYZ.height;

		if( ModifyMode )
			ModifyMode = OFF;
	}
}

//マウスボタン押下処理（直方体・Z軸視点）
void	MouseCropZ( int button, int state, int x, int y){

	//マウス左ボタンDOWN
	if (state == GLUT_DOWN){

		crop.set_prev( x, VIEWPORT_HEIGHT - y, 0 );

		//＋コントロールキー＝直方体の変形
		if( ModifyMode ){

			// 直方体の上半分を掴むと、上辺を変形
			if(((( crop.prev_y- VIEWPORT_HEIGHT/2 )/((float)VIEWPORT_HEIGHT/2 ))) >=  ( save_cymin + ( save_cymax - save_cymin) / 2 )){
				ModifyMode |= TOPSIDE;
			}

			// 直方体の下半分を掴むと、下辺を変形
			else{
				ModifyMode |= BOTTOMSIDE;
			}

			// 直方体の右半分を掴むと、右辺を変形
			if(((( crop.prev_x - VIEWPORT_WIDTH/2 - VIEWPORT_WIDTH )/((float)VIEWPORT_WIDTH/2 ))  ) >=  ( save_cxmin + ( save_cxmax - save_cxmin) / 2 )){
				ModifyMode |= RIGHTSIDE;
			}

			// 直方体の左半分を掴むと、左辺を変形
			else{
				ModifyMode |= LEFTSIDE;
			}
		}
	}

	//左ボタンUP  移動量と変形された形を保持
	else if (state == GLUT_UP){

		crop.save_pos( crop.move_x, crop.move_y, 0 );
		save_cxmax = cxmaxlevel2;
		save_cxmin = cxminlevel2;
		save_cymax = cymaxlevel2;
		save_cymin = cyminlevel2;
		save_czmax = czmaxlevel2;
		save_czmin = czminlevel2;

		if( ModifyMode )
			ModifyMode = OFF;
	}
}

//マウスボタン押下処理（球・Z軸視点）
void	MouseSphereZ( int button, int state, int x, int y){

	//マウス左ボタンDOWN
	if (state == GLUT_DOWN){

		sphere.set_prev( x, VIEWPORT_HEIGHT - y, 0 );

		//＋コントロールキー＝球の変形

		if( ModifyMode ){
			// 球の上半分を掴むと、上辺を変形
			if(((sphere.prev_y-VIEWPORT_HEIGHT/2)/((float)VIEWPORT_HEIGHT/2 )) >=  sphere.save_center_y ){
				ModifyMode |= TOPSIDE;
			}
			// 球の下半分を掴むと、下辺を変形
			else{
				ModifyMode |= BOTTOMSIDE;
			}

			// 球の右半分を掴むと、右辺を変形
			if((( sphere.prev_x - VIEWPORT_WIDTH - VIEWPORT_WIDTH/2 )/((float)VIEWPORT_WIDTH/2 )) >=  sphere.save_center_x ){
				ModifyMode |= RIGHTSIDE;
			}

			// 球の左半分を掴むと、左辺を変形
			else{
				ModifyMode |= LEFTSIDE;
			}
		}
	}

	else if (state == GLUT_UP){

		sphere.save_pos( sphere.move_x, sphere.move_y, 0 );
		sphere.save_center_x = sphere.center_x;
		sphere.save_center_y = sphere.center_y;
		sphere.save_center_z = sphere.center_z;
		sphere.save_radius = sphere.radius;

		if( ModifyMode )
			ModifyMode = OFF;
	}
}

//マウスボタン押下処理（円柱・Z軸視点）
void	MousePillarXY_Z( int button, int state, int x, int y){

	//マウス左ボタンDOWN
	if (state == GLUT_DOWN){

		pillar.set_prev( x, VIEWPORT_HEIGHT - y, 0 );

		//＋コントロールキー＝円柱の変形
		if( ModifyMode ){

			// 円柱の上半分を掴むと、上辺を変形
			if((( pillar.prev_y - VIEWPORT_HEIGHT/2 )/((float)VIEWPORT_HEIGHT/2 )) >=  pillar.save_center_y ){
				ModifyMode |= TOPSIDE;
			}

			// 円柱の下半分を掴むと、下辺を変形
			else{
				ModifyMode |= BOTTOMSIDE;
			}

			// 円柱の右半分を掴むと、右辺を変形
			if((( pillar.prev_x - VIEWPORT_WIDTH - VIEWPORT_WIDTH/2)/((float)VIEWPORT_WIDTH/2 )) >=  pillar.save_center_x ){
				ModifyMode |= RIGHTSIDE;
			}

			// 円柱の左半分を掴むと、左辺を変形
			else{
				ModifyMode |= LEFTSIDE;
			}
		}
	}

	else if (state == GLUT_UP){

		pillar.save_pos( pillar.move_x, pillar.move_y, 0 );
		pillar.save_center_x = pillar.center_x;
		pillar.save_center_y = pillar.center_y;
		pillar.save_center_z = pillar.center_z;
		pillar.save_radius = pillar.radius;
		pillar.save_height = pillar.height;

		if( ModifyMode )
			ModifyMode = OFF;
	}
}

//マウスボタン押下処理（円柱・Z軸視点）
void	MousePillarXZ_Z( int button, int state, int x, int y){

	//マウス左ボタンDOWN
	if (state == GLUT_DOWN){

		pillarXZ.set_prev( x, VIEWPORT_HEIGHT - y, 0 );

		//＋コントロールキー＝円柱の変形
		if( ModifyMode ){

			// 円柱の上半分を掴むと、上辺を変形
			if((( pillarXZ.prev_y - VIEWPORT_HEIGHT/2 )/((float)VIEWPORT_HEIGHT/2 )) >=  pillarXZ.save_center_y + pillarXZ.save_height/2 ){
				ModifyMode |= TOPSIDE;
			}
			// 円柱の下半分を掴むと、下辺を変形
			else{
				ModifyMode |= BOTTOMSIDE;
			}

			// 円柱の右半分を掴むと、右辺を変形
			if((( pillarXZ.prev_x - VIEWPORT_WIDTH - VIEWPORT_WIDTH/2)/((float)VIEWPORT_WIDTH/2 )) >=  pillarXZ.save_center_x ){
				ModifyMode |= RIGHTSIDE;
			}

			// 円柱の左半分を掴むと、左辺を変形
			else{
				ModifyMode |= LEFTSIDE;
			}
		}
	}

	else if (state == GLUT_UP){

		pillarXZ.save_pos( pillarXZ.move_x, pillarXZ.move_y, 0 );
		pillarXZ.save_center_x = pillarXZ.center_x;
		pillarXZ.save_center_y = pillarXZ.center_y;
		pillarXZ.save_center_z = pillarXZ.center_z;
		pillarXZ.save_radius = pillarXZ.radius;
		pillarXZ.save_height = pillarXZ.height;

		if( ModifyMode )
			ModifyMode = OFF;
	}
}

//マウスボタン押下処理（円柱・Z軸視点）
void	MousePillarYZ_Z( int button, int state, int x, int y){

	//マウス左ボタンDOWN
	if (state == GLUT_DOWN){

		pillarYZ.set_prev( x, VIEWPORT_HEIGHT - y, 0 );

		//＋コントロールキー＝円柱の変形
		if( ModifyMode ){

			// 円柱の上半分を掴むと、上辺を変形
			if((( pillarYZ.prev_y - VIEWPORT_HEIGHT/2 )/((float)VIEWPORT_HEIGHT/2 )) >=  pillarYZ.save_center_y ){
				ModifyMode |= TOPSIDE;
			}

			// 円柱の下半分を掴むと、下辺を変形
			else{
				ModifyMode |= BOTTOMSIDE;
			}

			// 円柱の右半分を掴むと、右辺を変形
			if((( pillarYZ.prev_x - VIEWPORT_WIDTH - VIEWPORT_WIDTH/2)/((float)VIEWPORT_WIDTH/2 )) >=  pillarYZ.save_center_x + pillarYZ.save_height/2 ){
				ModifyMode |= RIGHTSIDE;
			}

			// 円柱の左半分を掴むと、左辺を変形
			else{
				ModifyMode |= LEFTSIDE;
			}
		}
	}

	else if (state == GLUT_UP){

		pillarYZ.save_pos( pillarYZ.move_x, pillarYZ.move_y, 0 );
		pillarYZ.save_center_x = pillarYZ.center_x;
		pillarYZ.save_center_y = pillarYZ.center_y;
		pillarYZ.save_center_z = pillarYZ.center_z;
		pillarYZ.save_radius = pillarYZ.radius;
		pillarYZ.save_height = pillarYZ.height;

		if( ModifyMode )
			ModifyMode = OFF;
	}
}

//マウス・モーションイベント  コールバック
void	MouseMotion( int x, int y )
{
	//マウスボタンが押されていなければ、リターン
	if (clicking != ON)
		return;

	//X軸視点ビューポートの選択中
	if(( 0 <= x ) && ( x < VIEWPORT_WIDTH)  && ( 0 <= y ) && ( y < VIEWPORT_HEIGHT )){

		switch( obj_3d ){
			case	CROP:
				MotionCropX( x, y );
				break;
			case	SPHERE:
				MotionSphereX( x, y );
				break;
			case	PILLARXY:
				MotionPillarXY_X( x, y );
				break;
			case	PILLARYZ:
				MotionPillarYZ_X( x, y );
				break;
			case	PILLARXZ:
				MotionPillarXZ_X( x, y );
				break;
			default:
				break;
		}
	}
	//Y軸視点ビューポートの選択中
	else if(( VIEWPORT_WIDTH <= x ) && ( x <= VIEWPORT_WIDTH * 2)  && ( y > VIEWPORT_HEIGHT  ) && ( VIEWPORT_HEIGHT * 2 >= y )){

		switch( obj_3d ){
			case	CROP:
				MotionCropY( x, y );
				break;
			case	SPHERE:
				MotionSphereY( x, y );
				break;
			case	PILLARXY:
				MotionPillarXY_Y( x, y );
				break;
			case	PILLARYZ:
				MotionPillarYZ_Y( x, y );
				break;
			case	PILLARXZ:
				MotionPillarXZ_Y( x, y );
				break;
			default:
				break;
		}
	}
	//Z軸視点ビューポートの選択中
	else if(( VIEWPORT_WIDTH <= x ) && ( x <= VIEWPORT_WIDTH * 2)  && ( 0 <= y ) && ( y < VIEWPORT_HEIGHT )){
		switch( obj_3d ){
			case	CROP:
				MotionCropZ( x, y );
				break;
			case	SPHERE:
				MotionSphereZ( x, y );
				break;
			case	PILLARXY:
				MotionPillarXY_Z( x, y );
				break;
			case	PILLARYZ:
				MotionPillarYZ_Z( x, y );
				break;
			case	PILLARXZ:
				MotionPillarXZ_Z( x, y );
				break;
			default:
				break;
		}
	}
}

//マウスモーション処理（直方体・X軸視点）
void	MotionCropX( int x, int y ){
	
	float	wkx, wky;					//x,y 方向の移動量
	
	//Xビューポートの選択中でなければ、なければ、リターン
	if( win_sel != X_VIEW )
		return;

	wkx = (( x  - crop.prev_z )/((float)VIEWPORT_WIDTH/2 ));											//x軸方向のマウスの移動量
	wky = (( VIEWPORT_HEIGHT - y ) - crop.prev_y )/((float)VIEWPORT_HEIGHT/2 );							//y軸方向のマウスの移動量
	CropTrans = OFF;

	//移動処理
	if ( ModifyMode == OFF ){
		CropTrans = (TOPSIDE | BOTTOMSIDE | SURFSIDE | DEPTHSIDE );
		SetCropMaxMin( 0, wky, wkx );

		if(( CropYmax <= Ymax*2 ) && ( CropYmin >= Ymin*2 ) 
			&& ( CropZmax <= Zmax*2 ) && ( CropZmin >= Zmin*2 )){

			crop.set_pos( 0, VIEWPORT_HEIGHT - y, x );
			crop.set_crop_textdata();
			param3vd.CropParaSet();
		}
		return;
	}

	//＋コントロールキー ＝ 直方体の変形


	// 直方体の上半分を掴むと、上辺を変形
	if( ModifyMode & TOPSIDE){
		CropTrans = TOPSIDE;
		SetCropMaxMin( 0.0F, wky, 0.0F );
		if(( CropYmax <= Ymax*2 ) && ( CropYmax > cyminlevel2 ))
			cymaxlevel2 = CropYmax;
	}
		// 直方体の下半分を掴むと、下辺を変形
	if( ModifyMode & BOTTOMSIDE){
		CropTrans = BOTTOMSIDE;
		SetCropMaxMin( 0.0F, wky, 0.0F );
		if(( CropYmin >= Ymin*2 ) && ( CropYmin < cymaxlevel2 ))
			cyminlevel2 = CropYmin;
	}

	// 直方体の右半分を掴むと、右辺を変形
	if( ModifyMode & RIGHTSIDE ){
		CropTrans = SURFSIDE;
		SetCropMaxMin( 0.0F, 0.0F, wkx );
		if(( CropZmax <= Zmax*2 ) && ( CropZmax > czminlevel2 ))
			czmaxlevel2 = CropZmax;
		}

	// 直方体の左半分を掴むと、左辺を変形
	if( ModifyMode & LEFTSIDE ){
		CropTrans = DEPTHSIDE;
		SetCropMaxMin( 0.0F, 0.0F, wkx );
		if(( CropZmin >= Zmin*2 ) && ( CropZmin < czmaxlevel2 ))
			czminlevel2 = CropZmin;
		}

	//値を計算し、テキストボックスにセット
	crop.side_y = cymaxlevel2 - cyminlevel2;
	crop.move_y = ( cymaxlevel2 + cyminlevel2 ) *( VIEWPORT_HEIGHT / 2 ) / 2;

	crop.side_z = czmaxlevel2 - czminlevel2;
	crop.move_z = ( czmaxlevel2 + czminlevel2 ) * ( VIEWPORT_WIDTH / 2 ) / 2;

	crop.set_crop_textbox();
	param3vd.CropParaSet();
}

//マウスモーション処理（球・X軸視点）
void	MotionSphereX( int x, int y ){

	float	wkx, wky;					//x,y 方向の移動量
	float	radiusmod;					//半径の変化量

	//Xビューポートの選択中でなければ、なければ、リターン
	if( win_sel != X_VIEW )
		return;

	wkx =( x - sphere.prev_z)/((float)VIEWPORT_WIDTH/2);												//x軸方向のマウスの移動量
	wky = (( VIEWPORT_HEIGHT - y ) - sphere.prev_y  )/((float)VIEWPORT_HEIGHT/2);						//y軸方向のマウスの移動量

	//移動処理
	if ( ModifyMode == OFF ){
		SetSphereMaxMin( 0, wky, wkx, 0 );

		if(( SphereYmax <= Ymax*2 ) && ( SphereYmin >= Ymin*2 ) 
			&& ( SphereZmax <= Zmax*2 ) && ( SphereZmin >= Zmin*2 )){

			sphere.set_pos( 0, VIEWPORT_HEIGHT - y, x );
			sphere.set_sphere_textdata();
			param3vd.SphereParaSet();
		}
	}


	// 球の右上を掴む
	if(( ModifyMode & TOPSIDE) && ( ModifyMode & RIGHTSIDE )){
		radiusmod = ( wkx/sphere.scale_z )  + ( wky/sphere.scale_y );									//半径の変化量
		SetSphereMaxMin( 0, 0, 0, radiusmod );
		if(( SphereYmax <= Ymax*2 ) && ( SphereZmax <= Zmax*2 )){
			if(( sphere.save_radius*sphere.scale_z + radiusmod ) >= RADIUSMIN ){
				sphere.radius = sphere.save_radius + radiusmod;
			}
		}
	}

	// 球の左上を掴む
	else if(( ModifyMode & TOPSIDE) && ( ModifyMode & LEFTSIDE )){
		radiusmod = -( wkx/sphere.scale_z )  + ( wky/sphere.scale_y );									//半径の変化量
		SetSphereMaxMin( 0, 0, 0, radiusmod );
		if(( SphereYmax <= Ymax*2 ) && ( SphereZmin >= Zmin*2 )){
			if(( sphere.save_radius*sphere.scale_z + radiusmod ) >= RADIUSMIN ){
				sphere.radius = sphere.save_radius + radiusmod;
			}
		}
	}

	// 球の右下半分を掴む
	else if(( ModifyMode & BOTTOMSIDE) && ( ModifyMode & RIGHTSIDE )){
		radiusmod = ( wkx/sphere.scale_z )  - ( wky/sphere.scale_y );									//半径の変化量
		SetSphereMaxMin( 0, 0, 0, radiusmod );
		if(( SphereYmin >= Ymin*2 ) && ( SphereZmax <= Zmax*2 )){
			if(( sphere.save_radius*sphere.scale_z + radiusmod ) >= RADIUSMIN ){
				sphere.radius = sphere.save_radius + radiusmod;
			}
		}
	}

	// 球の左下半分を掴む
	else if(( ModifyMode & BOTTOMSIDE) && ( ModifyMode & LEFTSIDE )){
		radiusmod = -( wkx/sphere.scale_z ) - ( wky/sphere.scale_y );									//半径の変化量
		SetSphereMaxMin( 0, 0, 0, radiusmod );
		if(( SphereXmin >= Xmin*2 ) && ( SphereYmin >= Ymin*2 )){
			if(( sphere.save_radius*sphere.scale_z + radiusmod ) >= RADIUSMIN ){
				sphere.radius = sphere.save_radius + radiusmod;
			}
		}
	}

	//値を計算し、テキストボックスにセット
	sphere.set_sphere_textdata();
	param3vd.SphereParaSet();
}

//マウスモーション処理（円柱・X軸視点）
void	MotionPillarXY_X( int x, int y ){

	float	wkx, wky;					//x,y 方向の移動量
	float	radiusmod, heightmod;		//半径、高さの変化量

	//Xビューポートの選択中でなければ、なければ、リターン
	if( win_sel != X_VIEW )
		return;

	wkx = ( x - pillar.prev_z)/((float)VIEWPORT_WIDTH/2);									//x軸方向のマウスの移動量
	wky = ((float)VIEWPORT_HEIGHT - pillar.prev_y - y )/((float)VIEWPORT_HEIGHT/2);			//y軸方向のマウスの移動量

	//移動処理
	if ( ModifyMode == OFF ){
		SetPillarXYMaxMin( 0, wky, wkx, 0, 0, 0 );

		if(( PillarXYYmax <= Ymax*2 ) && ( PillarXYYmin >= Ymin*2 ) 
			&& ( PillarXYZmax <= Zmax*2 ) && ( PillarXYZmin >= Zmin*2 )){

			pillar.set_pos( 0, VIEWPORT_HEIGHT - y, x );
			pillar.set_pillar_textdata();
			param3vd.PillarParaSet();
			return;
		}
	}

	radiusmod = wky/pillar.scale_y;														//半径の変化量
	heightmod = wkx/pillar.scale_z;														//高さの変化量

	// 円柱の上半分を掴むと、上辺を変形
	if( ModifyMode & TOPSIDE){
		SetPillarXYMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarXYYmax <= Ymax*2 ) && ( PillarXYYmax > PillarXYYmin )){
			pillar.radius = pillar.save_radius + radiusmod;
		}
	}
		// 円柱の下半分を掴むと、下辺を変形
	else if( ModifyMode & BOTTOMSIDE){
		SetPillarXYMaxMin( 0, 0, 0, -radiusmod, 0, 0 );
		if(( PillarXYYmin >= Ymin*2 ) && ( PillarXYYmin < PillarXYYmax )){
			pillar.radius = pillar.save_radius - radiusmod;
		}
	}

	// 円柱の右半分を掴むと、右辺を変形
	if( ModifyMode & RIGHTSIDE ){
		SetPillarXYMaxMin( 0, 0, 0, 0, heightmod, 0 );
		if(( PillarXYZmax <= Zmax*2 ) && ( PillarXYZmax > PillarXYZmin )){
			pillar.height = pillar.save_height + heightmod;
		}
	}

	// 円柱の左半分を掴むと、左辺を変形
	else if( ModifyMode & LEFTSIDE ){
		SetPillarXYMaxMin( 0, 0, 0, 0, 0, heightmod );
		if(( PillarXYZmin >= Zmin*2 ) && ( PillarXYZmin < PillarXYZmax )){
			pillar.height = pillar.save_height - heightmod;
			pillar.center_z = pillar.save_center_z + heightmod;
			pillar.set_pos( 0, 0, x);
		}
	}

	//値を計算し、テキストボックスにセット
	pillar.set_pillar_textbox();
	param3vd.PillarParaSet();
}

//マウスモーション処理（円柱・X軸視点）
void	MotionPillarXZ_X( int x, int y ){

	float	wkx, wky;					//x,y 方向の移動量
	float	radiusmod, heightmod;		//半径、高さの変化量

	//Xビューポートの選択中でなければ、なければ、リターン
	if( win_sel != X_VIEW )
		return;

	wkx = ( x - pillarXZ.prev_z)/((float)VIEWPORT_WIDTH/2);									//x軸方向のマウスの移動量
	wky = ((float)VIEWPORT_HEIGHT - pillarXZ.prev_y - y )/((float)VIEWPORT_HEIGHT/2);		//y軸方向のマウスの移動量

	//移動処理
	if ( ModifyMode == OFF ){
		SetPillarXZMaxMin( 0, wky, wkx, 0, 0, 0 );

		if(( PillarXZYmax <= Ymax*2 ) && ( PillarXZYmin >= Ymin*2 ) 
			&& ( PillarXZZmax <= Zmax*2 ) && ( PillarXZZmin >= Zmin*2 )){

			pillarXZ.set_pos( 0, VIEWPORT_HEIGHT - y, x );
			pillarXZ.set_pillar_textdata();
			param3vd.PillarParaSet();
			return;
		}
	}

	radiusmod = wkx/pillarXZ.scale_z;														//半径の変化量
	heightmod = wky/pillarXZ.scale_y;														//高さの変化量

	// 円柱の上半分を掴むと、上辺を変形
	if( ModifyMode & TOPSIDE){
		SetPillarXZMaxMin( 0, 0, 0, 0, heightmod, 0 );
		if(( PillarXZYmax <= Ymax*2 ) && ( PillarXZYmax > PillarXZYmin )){
			pillarXZ.height = pillarXZ.save_height + heightmod;
		}
	}
		// 円柱の下半分を掴むと、下辺を変形
	else if( ModifyMode & BOTTOMSIDE){
		SetPillarXZMaxMin( 0, 0, 0, 0, 0, heightmod );
		if(( PillarXZYmin >= Ymin*2 ) && ( PillarXZYmin < PillarXZYmax )){
			pillarXZ.height = pillarXZ.save_height - heightmod;
			pillarXZ.center_y = pillarXZ.save_center_y + heightmod;
			pillarXZ.set_pos( 0, VIEWPORT_HEIGHT - y, 0 );
		}
	}

	// 円柱の右半分を掴むと、右辺を変形
	if( ModifyMode & RIGHTSIDE ){
		SetPillarXZMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarXZZmax <= Zmax*2 ) && ( PillarXZZmax > PillarXZZmin )){
			pillarXZ.radius = pillarXZ.save_radius + radiusmod;
		}
	}

	// 円柱の左半分を掴むと、左辺を変形
	else if( ModifyMode & LEFTSIDE ){
		SetPillarXZMaxMin( 0, 0, 0, -radiusmod, 0, 0 );
		if(( PillarXZZmin >= Zmin*2 ) && ( PillarXZZmin < PillarXZZmax )){
			pillarXZ.radius = pillarXZ.save_radius - radiusmod;
		}
	}

	//値を計算し、テキストボックスにセット
	pillarXZ.set_pillar_textbox();
	param3vd.PillarParaSet();
}

//マウスモーション処理（円柱・X軸視点）
void	MotionPillarYZ_X( int x, int y ){

	float	wkx, wky;					//x,y 方向の移動量
	float	radiusmod;					//半径の変化量

	//Xビューポートの選択中でなければ、なければ、リターン
	if( win_sel != X_VIEW )
		return;

	wkx = ( x - pillarYZ.prev_z)/((float)VIEWPORT_WIDTH/2);									//x軸方向のマウスの移動量
	wky = ((float)VIEWPORT_HEIGHT - pillarYZ.prev_y - y )/((float)VIEWPORT_HEIGHT/2);		//y軸方向のマウスの移動量

	//移動処理
	if ( ModifyMode == OFF ){
		SetPillarYZMaxMin( 0, wky, wkx, 0, 0, 0 );

		if(( PillarYZYmax <= Ymax*2 ) && ( PillarYZYmin >= Ymin*2 ) 
			&& ( PillarYZZmax <= Zmax*2 ) && ( PillarYZZmin >= Zmin*2 )){

			pillarYZ.set_pos( 0, VIEWPORT_HEIGHT - y, x );
			pillarYZ.set_pillar_textdata();
			param3vd.PillarParaSet();
			return;
		}
	}

	// 円柱の右上を掴む
	if(( ModifyMode & TOPSIDE) && ( ModifyMode & RIGHTSIDE )){
		radiusmod = ( wkx/pillarYZ.scale_z )  + ( wky/pillarYZ.scale_y );									//半径の変化量
		SetPillarYZMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarYZYmax <= Ymax*2 ) && ( PillarYZZmax <= Zmax*2 )){
			if(( pillarYZ.save_radius*pillarYZ.scale_z + radiusmod ) >= RADIUSMIN ){
				pillarYZ.radius = pillarYZ.save_radius + radiusmod;
			}
		}
	}
	// 円柱の左上を掴む
	else if(( ModifyMode & TOPSIDE) && ( ModifyMode & LEFTSIDE )){
		radiusmod = -( wkx/pillarYZ.scale_z )  + ( wky/pillarYZ.scale_y );									//半径の変化量
		SetPillarYZMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarXZYmax <= Ymax*2 ) && ( PillarYZZmin >= Zmin*2 )){
			if(( pillarYZ.save_radius*pillarYZ.scale_z + radiusmod ) >= RADIUSMIN ){
				pillarYZ.radius = pillarYZ.save_radius + radiusmod;
			}
		}
	}

	// 円柱の右下を掴む
	else if(( ModifyMode & BOTTOMSIDE) && ( ModifyMode & RIGHTSIDE )){
		radiusmod = ( wkx/pillarYZ.scale_z )  - ( wky/pillarYZ.scale_y );									//半径の変化量
		SetPillarYZMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarYZZmax <= Zmax*2 ) && ( PillarYZYmin >= Ymin*2 )){
			if(( pillarYZ.save_radius*pillarYZ.scale_z + radiusmod ) >= RADIUSMIN ){
				pillarYZ.radius = pillarYZ.save_radius + radiusmod;
			}
		}
	}


	// 円柱の左下を掴む
	else if(( ModifyMode & BOTTOMSIDE) && ( ModifyMode & LEFTSIDE )){
		radiusmod = -( wkx/pillarYZ.scale_z ) - ( wky/pillarYZ.scale_y );									//半径の変化量
		SetPillarYZMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarYZZmin >= Zmin*2 ) && ( PillarYZYmin >= Ymin*2 )){
			if(( pillarYZ.save_radius*pillarYZ.scale_z + radiusmod ) >= RADIUSMIN ){
				pillarYZ.radius = pillarYZ.save_radius + radiusmod;
			}
		}
	}

	//値を計算し、テキストボックスにセット
	pillarYZ.set_pillar_textbox();
	param3vd.PillarParaSet();
}

//マウスモーション処理（直方体・Y軸視点）
void	MotionCropY( int x, int y ){

	float	wkx, wky;					//x,y 方向の移動量

	//マウスの左ボタンが押されていなければ、リターン
	if (clicking != ON)
		return;

	//Yビューポートの選択中でなければ、なければ、リターン
	if( win_sel != Y_VIEW )
		return;

	wkx = ( x - crop.prev_x )/((float)VIEWPORT_WIDTH/2);										//x軸方向のマウスの移動量
	wky = ( y - crop.prev_z )/((float)VIEWPORT_HEIGHT/2);										//y軸方向のマウスの移動量
	CropTrans = OFF;

	//移動処理
	if ( ModifyMode == OFF ){
		CropTrans = ( RIGHTSIDE | LEFTSIDE | TOPSIDE | BOTTOMSIDE );
		SetCropMaxMin( wkx, 0.0F, wky );

		if(( CropXmax <= Xmax*2 ) && ( CropXmin >= Xmin*2 ) 
			&& ( CropZmax <= Zmax*2 ) && ( CropZmin >= Zmin*2 )){
			crop.set_pos( x, 0, y );
			crop.set_crop_textdata();
			param3vd.CropParaSet();
		}
		return;
	}

	//＋コントロールキー ＝ 直方体の変形

	// 直方体の上半分を掴むと、上辺を変形
	if( ModifyMode & TOPSIDE){
		CropTrans |= DEPTHSIDE;
		SetCropMaxMin( 0.0F,  0.0F, wky );
		if(( CropZmax <= Zmax*2 ) && ( CropZmax >czminlevel2 ))
			czmaxlevel2 = CropZmax;
	}

		// 直方体の下半分を掴むと、下辺を変形
	if( ModifyMode & BOTTOMSIDE){
		CropTrans |= SURFSIDE;
		SetCropMaxMin( 0.0F,  0.0F, wky );
		if(( CropZmin >= Zmin*2 ) && ( CropZmin < czmaxlevel2 ))
			czminlevel2 = CropZmin;
	}

	// 直方体の右半分を掴むと、右辺を変形
	if( ModifyMode & RIGHTSIDE ){
		CropTrans |= RIGHTSIDE;
		SetCropMaxMin( wkx, 0.0F,  0.0F );
		if(( CropXmax <= Xmax*2 ) && ( CropXmax > cxminlevel2 ))
			cxmaxlevel2 = CropXmax;
	}

	// 直方体の左半分を掴むと、左辺を変形
	if( ModifyMode & LEFTSIDE ){
		CropTrans |= LEFTSIDE;
		SetCropMaxMin( wkx, 0.0F,  0.0F );
		if(( CropXmin >= Xmin*2 ) && ( CropXmin < cxmaxlevel2 ))
			cxminlevel2 =CropXmin;
	}


	//値を計算し、テキストボックスにセット
	crop.side_z = czmaxlevel2 - czminlevel2;
	crop.move_z = ( czmaxlevel2 + czminlevel2 ) *(  VIEWPORT_HEIGHT / 2 ) / 2;

	crop.side_x = cxmaxlevel2 - cxminlevel2;
	crop.move_x = ( cxmaxlevel2 + cxminlevel2 ) * ( VIEWPORT_WIDTH / 2 ) / 2;

	crop.set_crop_textbox();
	param3vd.CropParaSet();
}

//マウスモーション処理（球・Y軸視点）
void	MotionSphereY( int x, int y ){

	float	wkx, wky;					//x,y 方向の移動量
	float	radiusmod;					//半径の変化量

	//Yビューポートの選択中でなければ、なければ、リターン
	if( win_sel != Y_VIEW )
		return;

	wkx = (( x - sphere.prev_x)/((float)VIEWPORT_WIDTH/2));										//x軸方向のマウスの移動量
	wky = (( y - sphere.prev_z )/((float)VIEWPORT_HEIGHT/2));									//y軸方向のマウスの移動量

	//移動処理
	if ( ModifyMode == OFF ){
		SetSphereMaxMin( wkx, 0.0F, wky, 0.0F );

		if(( SphereXmax <= Xmax*2 ) && ( SphereXmin >= Xmin*2 ) 
			&& ( SphereZmax <= Zmax*2 ) && ( SphereZmin >= Zmin*2 )){

			sphere.set_pos( x, 0, y );
			sphere.set_sphere_textdata();
			param3vd.SphereParaSet();
		return;
		}
	}

	// 球の右上を掴む
	if(( ModifyMode & TOPSIDE) && ( ModifyMode & RIGHTSIDE )){
		radiusmod = ( wkx/sphere.scale_x ) - ( wky/sphere.scale_z );									//半径の変化量
		SetSphereMaxMin( 0, 0, 0, radiusmod );
		if(( SphereXmax <= Xmax*2 ) && ( SphereZmin >= Zmin*2 )){
			if(( sphere.save_radius*sphere.scale_x + radiusmod ) >= RADIUSMIN ){
				sphere.radius = sphere.save_radius + radiusmod;
			}
		}
	}

	// 球の左上を掴む
	else if(( ModifyMode & TOPSIDE) && ( ModifyMode & LEFTSIDE )){
		radiusmod = -( wkx/sphere.scale_x )  - ( wky/sphere.scale_z );									//半径の変化量
		SetSphereMaxMin( 0, 0, 0, radiusmod );
		if(( SphereXmin >= Xmin*2 ) && ( SphereZmin >= Zmin*2 )){
			if(( sphere.save_radius*sphere.scale_x + radiusmod ) >= RADIUSMIN ){
				sphere.radius = sphere.save_radius + radiusmod;
			}
		}
	}

	// 球の右下半分を掴む
	else if(( ModifyMode & BOTTOMSIDE) && ( ModifyMode & RIGHTSIDE )){
		radiusmod = ( wkx/sphere.scale_z )  + ( wky/sphere.scale_y );									//半径の変化量
		SetSphereMaxMin( 0, 0, 0, radiusmod );
		if(( SphereXmax <= Xmax*2 ) && ( SphereZmax <= Zmax*2 )){
			if(( sphere.save_radius*sphere.scale_x + radiusmod ) >= RADIUSMIN ){
				sphere.radius = sphere.save_radius + radiusmod;
			}
		}
	}

	// 球の左下半分を掴む
	else if(( ModifyMode & BOTTOMSIDE) && ( ModifyMode & LEFTSIDE )){
		radiusmod = -( wkx/sphere.scale_x ) + ( wky/sphere.scale_z );									//半径の変化量
		SetSphereMaxMin( 0, 0, 0, radiusmod );
		if(( SphereXmin >= Xmin*2 ) && ( SphereZmax <= Zmax*2 )){
			if(( sphere.save_radius*sphere.scale_x + radiusmod ) >= RADIUSMIN ){
				sphere.radius = sphere.save_radius + radiusmod;
			}
		}
	}

	//値を計算し、テキストボックスにセット
	sphere.set_sphere_textdata();
	param3vd.SphereParaSet();
}

//マウスモーション処理（円柱・Y軸視点）
void	MotionPillarXY_Y( int x, int y ){

	float	wkx, wky;					//x,y 方向の移動量
	float	radiusmod, heightmod;		//半径、高さの変化量

	//Yビューポートの選択中でなければ、なければ、リターン
	if( win_sel != Y_VIEW )
		return;

	wkx = (( x - pillar.prev_x)/((float)VIEWPORT_WIDTH/2));										//x軸方向のマウスの移動量
	wky = - ( pillar.prev_z - ( y - VIEWPORT_HEIGHT ))/((float)VIEWPORT_HEIGHT/2);				//y軸方向のマウスの移動量

	//移動処理
	if ( ModifyMode == OFF ){
		SetPillarXYMaxMin( wkx, 0.0F, wky, 0.0F, 0.0F, 0.0F );

		if(( PillarXYXmax <= Xmax*2 ) && ( PillarXYXmin >= Xmin*2 ) 
			&& ( PillarXYZmax <= Zmax*2 ) && ( PillarXYZmin >= Zmin*2 )){

			pillar.set_pos( x, 0, -( VIEWPORT_HEIGHT - y ));
			pillar.set_pillar_textdata();
			param3vd.PillarParaSet();
			return;
		}
	}

	radiusmod = wkx/pillar.scale_x;														//半径の変化量
	heightmod = wky/pillar.scale_z;														//高さの変化量

	// 円柱の上半分を掴むと、上辺を変形
	if( ModifyMode & TOPSIDE){
		SetPillarXYMaxMin( wkx, 0, wky, radiusmod, heightmod, 0 );
		if(( PillarXYZmin >= Zmin*2 ) && ( PillarXYZmin < PillarXYZmax )){
			pillar.height = pillar.save_height + heightmod;
		}
	}

	// 円柱の下半分を掴むと、下辺を変形
	else if( ModifyMode & BOTTOMSIDE){
		SetPillarXYMaxMin( wkx, 0, wky, radiusmod, 0, heightmod );
		if(( PillarXYZmax <= Zmax*2 ) && ( PillarXYZmax > PillarXYZmin )){
			pillar.height = pillar.save_height - heightmod;
			pillar.center_z = pillar.save_center_z + heightmod;
			pillar.set_pos( 0, 0, -( VIEWPORT_HEIGHT - y ));
		}
	}

	// 円柱の右半分を掴むと、右辺を変形
	if( ModifyMode & RIGHTSIDE ){
		SetPillarXYMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarXYXmax <= Xmax*2 ) && ( PillarXYXmax > PillarXYXmin )){
			pillar.radius = pillar.save_radius + radiusmod;
		}
	}

	// 円柱の左半分を掴むと、左辺を変形
	if( ModifyMode & LEFTSIDE ){
		SetPillarXYMaxMin( 0, 0, 0, -radiusmod, 0, 0 );
		if(( PillarXYXmin >= Xmin*2 ) && ( PillarXYXmin < PillarXYXmax )){
			pillar.radius = pillar.save_radius - radiusmod;
		}
	}

	//値を計算し、テキストボックスにセット
	pillar.set_pillar_textbox();
	param3vd.PillarParaSet();
}

//マウスモーション処理（円柱・Y軸視点）
void	MotionPillarXZ_Y( int x, int y ){

	float	wkx, wky;					//x,y 方向の移動量
	float	radiusmod;					//半径の変化量

	//Yビューポートの選択中でなければ、なければ、リターン
	if( win_sel != Y_VIEW )
		return;

	wkx = (( x - pillarXZ.prev_x)/((float)VIEWPORT_WIDTH/2));									//x軸方向のマウスの移動量
	wky = - ( pillarXZ.prev_z - ( y - VIEWPORT_HEIGHT ))/((float)VIEWPORT_HEIGHT/2);			//y軸方向のマウスの移動量

	//移動処理
	if ( ModifyMode == OFF ){
		SetPillarXZMaxMin( wkx, 0.0F, wky, 0.0F, 0.0F, 0.0F );

		if(( PillarXZXmax <= Xmax*2 ) && ( PillarXZXmin >= Xmin*2 ) 
			&& ( PillarXZZmax <= Zmax*2 ) && ( PillarXZZmin >= Zmin*2 )){

			pillarXZ.set_pos( x, 0, -( VIEWPORT_HEIGHT - y ));
			pillarXZ.set_pillar_textdata();
			param3vd.PillarParaSet();
			return;
		}
	}

	// 円柱の右上を掴む
	if(( ModifyMode & TOPSIDE) && ( ModifyMode & RIGHTSIDE )){
		radiusmod = ( wkx/pillarXZ.scale_x )  + ( wky/pillarXZ.scale_z );									//半径の変化量
		SetPillarXZMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarXZXmax < Xmax*2 ) && ( PillarXZZmax <= Zmax*2 )){
			if(( pillarXZ.save_radius*pillarXZ.scale_x + radiusmod ) >= RADIUSMIN ){
				pillarXZ.radius = pillarXZ.save_radius + radiusmod;
			}
		}
	}

	// 円柱の左上を掴む
	else if(( ModifyMode & TOPSIDE) && ( ModifyMode & LEFTSIDE )){
		radiusmod = -( wkx/pillarXZ.scale_x )  + ( wky/pillarXZ.scale_z );									//半径の変化量
		SetPillarXZMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarXZXmin >= Xmin*2 ) && ( PillarXZZmax <= Zmax*2 )){
			if(( pillarXZ.save_radius*pillarXZ.scale_x + radiusmod ) >= RADIUSMIN ){
				pillarXZ.radius = pillarXZ.save_radius + radiusmod;
			}
		}
	}

	// 円柱の右下を掴む
	else if(( ModifyMode & BOTTOMSIDE) && ( ModifyMode & RIGHTSIDE )){
		radiusmod = ( wkx/pillarXZ.scale_x )  - ( wky/pillarXZ.scale_z );									//半径の変化量
		SetPillarXZMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarXZXmax < Xmax*2 ) && ( PillarXZZmin >= Zmin*2 )){
			if(( pillarXZ.save_radius*pillarXZ.scale_x + radiusmod ) >= RADIUSMIN ){
				pillarXZ.radius = pillarXZ.save_radius + radiusmod;
			}
		}
	}

	// 円柱の左下を掴む
	else if(( ModifyMode & BOTTOMSIDE) && ( ModifyMode & LEFTSIDE )){
		radiusmod = -( wkx/pillarXZ.scale_x ) - ( wky/pillarXZ.scale_z );									//半径の変化量
		SetPillarXZMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarXZXmin >= Xmin*2 ) && ( PillarXZZmin >= Zmin*2 )){
			if(( pillarXZ.save_radius*pillarXZ.scale_x + radiusmod ) >= RADIUSMIN ){
				pillarXZ.radius = pillarXZ.save_radius + radiusmod;
			}
		}
	}

	//値を計算し、テキストボックスにセット
	pillarXZ.set_pillar_textbox();
	param3vd.PillarParaSet();
}

//マウスモーション処理（円柱・Y軸視点）
void	MotionPillarYZ_Y( int x, int y ){

	float	wkx, wky;					//x,y 方向の移動量
	float	radiusmod, heightmod;		//半径、高さの変化量

	//Yビューポートの選択中でなければ、なければ、リターン
	if( win_sel != Y_VIEW )
		return;

	wkx = (( x - pillarYZ.prev_x)/((float)VIEWPORT_WIDTH/2));										//x軸方向のマウスの移動量
	wky = - ( pillarYZ.prev_z - ( y - VIEWPORT_HEIGHT ))/((float)VIEWPORT_HEIGHT/2);				//y軸方向のマウスの移動量

	//移動処理
	if ( ModifyMode == OFF ){
		SetPillarYZMaxMin( wkx, 0.0F, wky, 0.0F, 0.0F, 0.0F );

		if(( PillarYZXmax <= Xmax*2 ) && ( PillarYZXmin >= Xmin*2 ) 
			&& ( PillarYZZmax <= Zmax*2 ) && ( PillarYZZmin >= Zmin*2 )){

			pillarYZ.set_pos( x, 0, -( VIEWPORT_HEIGHT - y ));
			pillarYZ.set_pillar_textdata();
			param3vd.PillarParaSet();
			return;
		}
	}

	radiusmod = wky/pillarYZ.scale_z;														//半径の変化量
	heightmod = wkx/pillarYZ.scale_x;														//高さの変化量

	// 円柱の上半分を掴むと、上辺を変形
	if( ModifyMode & TOPSIDE){
		SetPillarYZMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarYZZmin >= Zmin*2 ) && ( PillarYZZmin <  PillarYZZmax )){
			pillarYZ.radius = pillarYZ.save_radius + radiusmod;
		}
	}

	// 円柱の下半分を掴むと、下辺を変形
	else if( ModifyMode & BOTTOMSIDE){
		SetPillarYZMaxMin( 0, 0, 0, -radiusmod, 0, 0 );
		if(( PillarYZZmax <= Zmax*2 ) && ( PillarYZZmax >  PillarYZZmin )){
			pillarYZ.radius = pillarYZ.save_radius - radiusmod;
		}
	}

	// 円柱の右半分を掴むと、右辺を変形
	if( ModifyMode & RIGHTSIDE ){
		SetPillarYZMaxMin( 0, 0, 0, 0, heightmod, 0 );
		if(( PillarYZXmax <= Xmax*2 ) && ( PillarYZXmax >  PillarYZXmin )){
			pillarYZ.height = pillarYZ.save_height + heightmod;
		}
	}

	// 円柱の左半分を掴むと、左辺を変形
	if( ModifyMode & LEFTSIDE ){
		SetPillarYZMaxMin( 0, 0, 0, 0, 0, heightmod );
		if(( PillarYZXmin >= Xmin*2 ) && ( PillarYZXmin < PillarYZXmax )){
			pillarYZ.height = pillarYZ.save_height - heightmod;
			pillarYZ.center_x = pillarYZ.save_center_x + heightmod;
			pillarYZ.set_pos( x, 0, 0 );
		}
	}

	//値を計算し、テキストボックスにセット
	pillarYZ.set_pillar_textbox();
	param3vd.PillarParaSet();
}

//マウスモーション処理（直方体・Z軸視点）
void	MotionCropZ( int x, int y ){

	float	wkx, wky;					//x,y 方向の移動量

	//Zビューポートの選択中でなければ、なければ、リターン
	if( win_sel != Z_VIEW )
		return;

	wkx = ( x  - crop.prev_x )/((float)VIEWPORT_WIDTH/2);										//x軸方向のマウスの移動量
	wky = (( VIEWPORT_HEIGHT - y ) - crop.prev_y )/((float)VIEWPORT_HEIGHT/2);					//y軸方向のマウスの移動量
	CropTrans = OFF;

	//移動処理
	if ( ModifyMode == OFF ){
		CropTrans = ( RIGHTSIDE | LEFTSIDE | TOPSIDE | BOTTOMSIDE );
		SetCropMaxMin( wkx, wky, 0.0F );
		if(( CropXmax <= Xmax*2 ) && ( CropXmin >= Xmin*2 ) 
			&& ( CropYmax <= Ymax*2 ) && ( CropYmin >= Ymin*2 )){

			crop.set_pos( x, VIEWPORT_HEIGHT - y, 0 );
			crop.set_crop_textdata();
			param3vd.CropParaSet();
		}
		return;
	}

	//＋コントロールキー ＝ 直方体の変形

	// 直方体の上半分を掴むと、上辺を変形
	if( ModifyMode & TOPSIDE){
		CropTrans |= TOPSIDE;
		SetCropMaxMin( 0.0F, wky, 0.0F );
		if(( CropYmax <= Ymax*2 ) && ( CropYmax > cyminlevel2 ))
			cymaxlevel2 = CropYmax;
	}
		// 直方体の下半分を掴むと、下辺を変形
	if( ModifyMode & BOTTOMSIDE){
		CropTrans |= BOTTOMSIDE;
		SetCropMaxMin( 0.0F, wky, 0.0F );
		if(( CropYmin >= Ymin*2 ) && ( CropYmin < cymaxlevel2 ))
			cyminlevel2 = CropYmin;
	}

	// 直方体の右半分を掴むと、右辺を変形
	if( ModifyMode & RIGHTSIDE ){
		CropTrans |= RIGHTSIDE;
		SetCropMaxMin( wkx, 0.0F, 0.0F );
		if(( CropXmax <= Xmax*2 ) && ( CropXmax > cxminlevel2 ))
			cxmaxlevel2 = CropXmax;
	}

	// 直方体の左半分を掴むと、左辺を変形
	if( ModifyMode & LEFTSIDE ){
		CropTrans |= LEFTSIDE;
		SetCropMaxMin( wkx, 0.0F, 0.0F );
		if(( CropXmin >= Xmin*2 ) && ( CropXmin < cxmaxlevel2 ))
			cxminlevel2 = CropXmin;
	}

	//値を計算し、テキストボックスにセット
	crop.side_y = cymaxlevel2 - cyminlevel2;
	crop.move_y = ( cymaxlevel2 + cyminlevel2 ) * ( VIEWPORT_HEIGHT/2 ) / 2;

	crop.side_x = cxmaxlevel2 - cxminlevel2;
	crop.move_x = ( cxmaxlevel2 + cxminlevel2 ) * ( VIEWPORT_WIDTH/2 ) / 2;

	crop.set_crop_textbox();
	param3vd.CropParaSet();
}

//マウスモーション処理（球・Z軸視点）
void	MotionSphereZ( int x, int y ){

	float	wkx, wky;					//x,y 方向の移動量
	float	radiusmod;					//半径の変化量

	//Zビューポートの選択中でなければ、なければ、リターン
	if( win_sel != Z_VIEW )
		return;

	wkx = ( x - sphere.prev_x)/((float)VIEWPORT_WIDTH/2);										//x軸方向のマウスの移動量
	wky = (( VIEWPORT_HEIGHT - y ) - sphere.prev_y )/((float)VIEWPORT_HEIGHT/2);				//y軸方向のマウスの移動量

	//移動処理
	if ( ModifyMode == OFF ){
		SetSphereMaxMin( wkx, wky, 0.0F , 0.0F );

		if(( SphereXmax <= Xmax*2 ) && ( SphereXmin >= Xmin*2 ) 
			&& ( SphereYmax <= Ymax*2 ) && ( SphereYmin >= Ymin*2 )){

			sphere.set_pos( x, VIEWPORT_HEIGHT - y, 0  );
			sphere.set_sphere_textdata();
			param3vd.SphereParaSet();
		}
	}

	// 球の右上を掴む
	if(( ModifyMode & TOPSIDE) && ( ModifyMode & RIGHTSIDE )){
		radiusmod = ( wkx/sphere.scale_x )  + ( wky/sphere.scale_y );									//半径の変化量
		SetSphereMaxMin( 0, 0, 0, radiusmod );
		if(( SphereXmax <= Xmax*2 ) && ( SphereYmax <= Ymax*2 )){
			if(( sphere.save_radius*sphere.scale_x + radiusmod ) >= RADIUSMIN ){
				sphere.radius = sphere.save_radius + radiusmod;
			}
		}
	}

	// 球の左上を掴む
	else if(( ModifyMode & TOPSIDE) && ( ModifyMode & LEFTSIDE )){
		radiusmod = -( wkx/sphere.scale_x )  + ( wky/sphere.scale_y );									//半径の変化量
		SetSphereMaxMin( 0, 0, 0, radiusmod );
		if(( SphereXmin >= Xmin*2 ) && ( SphereYmax <= Ymax*2 )){
			if(( sphere.save_radius*sphere.scale_x + radiusmod ) >= RADIUSMIN ){
				sphere.radius = sphere.save_radius + radiusmod;
			}
		}
	}

	// 球の右下半分を掴む
	else if(( ModifyMode & BOTTOMSIDE) && ( ModifyMode & RIGHTSIDE )){
		radiusmod = ( wkx/sphere.scale_x )  - ( wky/sphere.scale_y );									//半径の変化量
		SetSphereMaxMin( 0, 0, 0, radiusmod );
		if(( SphereXmax <= Xmax*2 ) && ( SphereYmin >= Ymin*2 )){
			if(( sphere.save_radius*sphere.scale_x + radiusmod ) >= RADIUSMIN ){
				sphere.radius = sphere.save_radius + radiusmod;
			}
		}
	}

	// 球の左下半分を掴む
	else if(( ModifyMode & BOTTOMSIDE) && ( ModifyMode & LEFTSIDE )){
		radiusmod = -( wkx/sphere.scale_x ) - ( wky/sphere.scale_y );									//半径の変化量
		SetSphereMaxMin( 0, 0, 0, radiusmod );
		if(( SphereXmin >= Xmin*2 ) && ( SphereYmin >= Ymin*2 )){
			if(( sphere.save_radius*sphere.scale_x + radiusmod ) >= RADIUSMIN ){
				sphere.radius = sphere.save_radius + radiusmod;
			}
		}
	}

	//値を計算し、テキストボックスにセット
	sphere.set_sphere_textdata();
	param3vd.SphereParaSet();
}

//マウスモーション処理（円柱・Z軸視点）
void	MotionPillarXY_Z( int x, int y ){

	float	wkx, wky;					//x,y 方向の移動量
	float	radiusmod;					//半径の変化量

	//Zビューポートの選択中でなければ、なければ、リターン
	if( win_sel != Z_VIEW )
		return;

	wkx = ( x - pillar.prev_x)/((float)VIEWPORT_WIDTH/2);						//x軸方向のマウスの移動量
	wky = (( VIEWPORT_HEIGHT - y ) - pillar.prev_y )/((float)VIEWPORT_HEIGHT/2);  //y軸方向のマウスの移動量

	//移動処理
	if ( ModifyMode == OFF ){
		SetPillarXYMaxMin( wkx, wky, 0.0F, 0.0F, 0.0F, 0.0F );

		if(( PillarXYXmax <= Xmax*2 ) && ( PillarXYXmin >= Xmin*2 ) 
			&& ( PillarXYYmax <= Ymax*2 ) && ( PillarXYYmin >= Ymin*2 )){

			pillar.set_pos( x, VIEWPORT_HEIGHT - y, 0 );
			pillar.set_pillar_textdata();
			param3vd.PillarParaSet();
			return;
		}
	}

	// 円柱の右上を掴む
	if(( ModifyMode & TOPSIDE) && ( ModifyMode & RIGHTSIDE )){
		radiusmod = ( wkx/pillar.scale_x )  + ( wky/pillar.scale_y );									//半径の変化量
		SetPillarXYMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarXYXmax <= Xmax*2 ) && ( PillarXYYmax <= Ymax*2 )){
			if(( pillar.save_radius*pillar.scale_x + radiusmod ) >= RADIUSMIN ){
				pillar.radius = pillar.save_radius + radiusmod;
			}
		}
	}

	// 円柱の左上を掴む
	else if(( ModifyMode & TOPSIDE) && ( ModifyMode & LEFTSIDE )){
		radiusmod = -( wkx/pillar.scale_x )  + ( wky/pillar.scale_y );									//半径の変化量
		SetPillarXYMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarXYXmin >= Xmin*2 ) && ( PillarXYYmax <= Ymax*2 )){
			if(( pillar.save_radius*pillar.scale_x + radiusmod ) >= RADIUSMIN ){
				pillar.radius = pillar.save_radius + radiusmod;
			}
		}
	}

	// 円柱の右下半分を掴む
	else if(( ModifyMode & BOTTOMSIDE) && ( ModifyMode & RIGHTSIDE )){
		radiusmod = ( wkx/pillar.scale_x )  - ( wky/pillar.scale_y );									//半径の変化量
		SetPillarXYMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarXYXmax <= Xmax*2 ) && ( PillarXYYmin >= Ymin*2 )){
			if(( pillar.save_radius*pillar.scale_x + radiusmod ) >= RADIUSMIN ){
				pillar.radius = pillar.save_radius + radiusmod;
			}
		}
	}

	// 円柱の左下半分を掴む
	else if(( ModifyMode & BOTTOMSIDE) && ( ModifyMode & LEFTSIDE )){
		radiusmod = -( wkx/pillar.scale_x ) - ( wky/pillar.scale_y );									//半径の変化量
		SetPillarXYMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarXYXmin >= Xmin*2 ) && ( PillarXYYmin >= Ymin*2 )){
			if(( pillar.save_radius*pillar.scale_x + radiusmod ) >= RADIUSMIN ){
				pillar.radius = pillar.save_radius + radiusmod;
			}
		}
	}

	//値を計算し、テキストボックスにセット
	pillar.set_pillar_textbox();
	param3vd.PillarParaSet();
}

//マウスモーション処理（円柱・Z軸視点）
void	MotionPillarXZ_Z( int x, int y ){

	float	wkx, wky;					//x,y 方向の移動量
	float	radiusmod, heightmod;		//半径、高さの変化量

	//Zビューポートの選択中でなければ、なければ、リターン
	if( win_sel != Z_VIEW )
		return;

	wkx = ( x - pillarXZ.prev_x)/((float)VIEWPORT_WIDTH/2);							//x軸方向のマウスの移動量
	wky = (( VIEWPORT_HEIGHT - y ) - pillarXZ.prev_y )/((float)VIEWPORT_HEIGHT/2);  //y軸方向のマウスの移動量

	//移動処理
	if ( ModifyMode == OFF ){
		SetPillarXZMaxMin( wkx, wky, 0.0F, 0.0F, 0.0F, 0.0F );

		if(( PillarXZXmax <= Xmax*2 ) && ( PillarXZXmin >= Xmin*2 ) 
			&& ( PillarXZYmax <= Ymax*2 ) && ( PillarXZYmin >= Ymin*2 )){

			pillarXZ.set_pos( x, VIEWPORT_HEIGHT - y, 0 );
			pillarXZ.set_pillar_textdata();
			param3vd.PillarParaSet();
			return;
		}
	}

	radiusmod = wkx/pillarXZ.scale_z;														//半径の変化量
	heightmod = wky/pillarXZ.scale_y;														//高さの変化量

	// 円柱の上半分を掴むと、上辺を変形
	if( ModifyMode & TOPSIDE){
		SetPillarXZMaxMin( 0, 0, 0, 0, heightmod, 0 );
		if(( PillarXZYmax <= Ymax*2 ) && ( PillarXZYmax > PillarXZYmin )){
			pillarXZ.height = pillarXZ.save_height + heightmod;
		}
	}

	// 円柱の下半分を掴むと、下辺を変形
	else if( ModifyMode & BOTTOMSIDE){
		SetPillarXZMaxMin( 0, 0, 0, 0, 0, heightmod );
		if(( PillarXZYmin >= Ymin*2 ) && ( PillarXZYmin < PillarXZYmax )){
			pillarXZ.height = pillarXZ.save_height - heightmod;
			pillarXZ.center_y = pillarXZ.save_center_y + heightmod;
			pillarXZ.set_pos( 0, VIEWPORT_HEIGHT - y, 0 );
		}
	}

	// 円柱の右半分を掴むと、右辺を変形
	if( ModifyMode & RIGHTSIDE ){
		SetPillarXZMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarXZXmax <= Xmax*2 ) && ( PillarXZXmax > PillarXZXmin )){
			pillarXZ.radius = pillarXZ.save_radius + radiusmod;
		}
	}

	// 円柱の左半分を掴むと、左辺を変形
	else if( ModifyMode & LEFTSIDE ){
		SetPillarXZMaxMin( 0, 0, 0, -radiusmod, 0, 0 );
		if(( PillarXZXmin >= Xmin*2 ) && ( PillarXZXmin < PillarXZXmax )){
			pillarXZ.radius = pillarXZ.save_radius - radiusmod;
		}
	}

	//値を計算し、テキストボックスにセット
	pillarXZ.set_pillar_textbox();
	param3vd.PillarParaSet();
}

//マウスモーション処理（円柱・Z軸視点）
void	MotionPillarYZ_Z( int x, int y ){

	float	wkx, wky;					//x,y 方向の移動量
	float	radiusmod, heightmod;		//半径、高さの変化量

	//Zビューポートの選択中でなければ、なければ、リターン
	if( win_sel != Z_VIEW )
		return;

	wkx = ( x - pillarYZ.prev_x)/((float)VIEWPORT_WIDTH/2);						//x軸方向のマウスの移動量
	wky = (( VIEWPORT_HEIGHT - y ) - pillarYZ.prev_y )/((float)VIEWPORT_HEIGHT/2);  //y軸方向のマウスの移動量

	//移動処理
	if ( ModifyMode == OFF ){
		SetPillarYZMaxMin( wkx, wky, 0.0F, 0.0F, 0.0F, 0.0F );

		if(( PillarYZXmax <= Xmax*2 ) && ( PillarYZXmin >= Xmin*2 ) 
			&& ( PillarYZYmax <= Ymax*2 ) && ( PillarYZYmin >= Ymin*2 )){

			pillarYZ.set_pos( x, VIEWPORT_HEIGHT - y, 0 );
			pillarYZ.set_pillar_textdata();
			param3vd.PillarParaSet();
			return;
		}
	}

	radiusmod = wky/pillarXZ.scale_y;														//半径の変化量
	heightmod = wkx/pillarXZ.scale_x;														//高さの変化量

	// 円柱の上半分を掴むと、上辺を変形
	if( ModifyMode & TOPSIDE){
		SetPillarYZMaxMin( 0, 0, 0, radiusmod, 0, 0 );
		if(( PillarYZYmax <= Ymax*2 ) && ( PillarYZYmax > PillarYZYmin )){
			pillarYZ.radius = pillarYZ.save_radius + radiusmod;
		}
	}

		// 円柱の下半分を掴むと、下辺を変形
	else if( ModifyMode & BOTTOMSIDE){
		SetPillarYZMaxMin( 0, 0, 0, -radiusmod, 0, 0 );
		if(( PillarYZYmin >= Ymin*2 ) && ( PillarYZYmin < PillarYZYmax )){
			pillarYZ.radius = pillarYZ.save_radius - radiusmod;
		}
	}

	// 円柱の右半分を掴むと、右辺を変形
	if( ModifyMode & RIGHTSIDE ){
		SetPillarYZMaxMin( 0, 0, 0, 0, heightmod, 0 );
		if(( PillarYZXmax <= Xmax*2 ) && ( PillarYZXmax > PillarYZXmin )){
			pillarYZ.height = pillarYZ.save_height + heightmod;
		}
	}

	// 円柱の左半分を掴むと、左辺を変形
	else if( ModifyMode & LEFTSIDE ){
		SetPillarYZMaxMin( 0, 0, 0, 0, 0, heightmod );
		if(( PillarYZXmin >= Xmin*2 ) && ( PillarYZXmin < PillarYZXmax )){
			pillarYZ.height = pillarYZ.save_height - heightmod;
			pillarYZ.center_x = pillarYZ.save_center_x + heightmod;
			pillarYZ.set_pos( x, 0, 0);
		}
	}

	//値を計算し、テキストボックスにセット
	pillarYZ.set_pillar_textbox();
	param3vd.PillarParaSet();
}

//特殊キー用コールバック
void SpecialFunc( int key, int x, int y )
{
	//X軸視点ビューポートの選択中
	if(( 0 <= x ) && ( x < VIEWPORT_WIDTH)  && ( 0 <= y ) && ( y < VIEWPORT_HEIGHT ))
	{
		switch( obj_3d ){
			case	CROP:
				SpecialFuncCropX( key, x, y );
				break;
			case	SPHERE:
				SpecialFuncSphereX( key, x, y );
				break;
			case	PILLARXY:
				SpecialFuncPillarXY_X( key, x, y );
				break;
			case	PILLARYZ:
				SpecialFuncPillarYZ_X( key, x, y );
				break;
			case	PILLARXZ:
				SpecialFuncPillarXZ_X( key, x, y );
				break;
			default:
				break;
		}
	}

	//Y軸視点ビューポートの選択中
	else if(( VIEWPORT_WIDTH <= x ) && ( x <= VIEWPORT_WIDTH * 2 ) && ( y > VIEWPORT_HEIGHT  ) && ( VIEWPORT_HEIGHT * 2 >= y ))
		{
		switch( obj_3d ){
			case	CROP:
				SpecialFuncCropY( key, x, y );
				break;
			case	SPHERE:
				SpecialFuncSphereY( key, x, y );
				break;
			case	PILLARXY:
				SpecialFuncPillarXY_Y( key, x, y );
				break;
			case	PILLARYZ:
				SpecialFuncPillarYZ_Y( key, x, y );
				break;
			case	PILLARXZ:
				SpecialFuncPillarXZ_Y( key, x, y );
				break;
			default:
				break;
		}
	}

	//Z軸視点ビューポートの選択中
	else if(( VIEWPORT_WIDTH <= x ) && ( x <= VIEWPORT_WIDTH * 2 ) && ( 0 <= y ) && ( y < VIEWPORT_HEIGHT ))
		{
		switch( obj_3d ){
			case	CROP:
				SpecialFuncCropZ( key, x, y );
				break;
			case	SPHERE:
				SpecialFuncSphereZ( key, x, y );
				break;
			case	PILLARXY:
				SpecialFuncPillarXY_Z( key, x, y );
				break;
			case	PILLARYZ:
				SpecialFuncPillarYZ_Z( key, x, y );
				break;
			case	PILLARXZ:
				SpecialFuncPillarXZ_Z( key, x, y );
				break;
			default:
				break;
		}
	}
}

//特殊キー押下処理（直方体・X軸視点）
void	SpecialFuncCropX( int key, int x, int y ){

	switch( key ){

		case GLUT_KEY_RIGHT:
			crop.crop_scaling( 0, 0, MAGSCALE );
			break;
		case GLUT_KEY_LEFT:
			crop.crop_scaling( 0, 0, REDSCALE );
			break;
		case GLUT_KEY_UP:
			crop.crop_scaling( 0, MAGSCALE, 0 );
			break;		
		case GLUT_KEY_DOWN:
			crop.crop_scaling( 0, REDSCALE, 0 );
			break;		
		case GLUT_KEY_PAGE_UP:
			crop.crop_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_PAGE_DOWN:
			crop.crop_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		default:
			break;
	}
}

//特殊キー押下処理（直方体・Y軸視点）
void	SpecialFuncCropY( int key, int x, int y ){

	switch( key ){

		case GLUT_KEY_RIGHT:
			crop.crop_scaling( MAGSCALE, 0, 0 );
			break;
		case GLUT_KEY_LEFT:
			crop.crop_scaling( REDSCALE, 0, 0);
			break;
		case GLUT_KEY_UP:
			crop.crop_scaling( 0, 0, MAGSCALE );
			break;		
		case GLUT_KEY_DOWN:
			crop.crop_scaling( 0, 0, REDSCALE );
			break;		
		case GLUT_KEY_PAGE_UP:
			crop.crop_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_PAGE_DOWN:
			crop.crop_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		default:
			break;
	}
}

//特殊キー押下処理（直方体・Z軸視点）
void	SpecialFuncCropZ( int key, int x, int y ){

	switch( key ){
		case GLUT_KEY_RIGHT:
			crop.crop_scaling( MAGSCALE, 0, 0 );
			break;
		case GLUT_KEY_LEFT:
			crop.crop_scaling( REDSCALE, 0, 0);
			break;
		case GLUT_KEY_UP:
			crop.crop_scaling( 0, MAGSCALE,  0 );
			break;		
		case GLUT_KEY_DOWN:
			crop.crop_scaling( 0, REDSCALE, 0 );
			break;		
		case GLUT_KEY_PAGE_UP:
			crop.crop_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_PAGE_DOWN:
			crop.crop_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		default:
			break;
	}
}

//特殊キー押下処理（球・X軸視点）
void	SpecialFuncSphereX( int key, int x, int y ){

	switch( key ){
		case GLUT_KEY_RIGHT:
			sphere.sphere_scaling(MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_LEFT:
			sphere.sphere_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		case GLUT_KEY_UP:
			sphere.sphere_scaling(MAGSCALE, MAGSCALE, MAGSCALE );
			break;		
		case GLUT_KEY_DOWN:
			sphere.sphere_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;		
		case GLUT_KEY_PAGE_UP:
			sphere.sphere_scaling(MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_PAGE_DOWN:
			sphere.sphere_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		default:
			break;
	}
}

//特殊キー押下処理（球・Y軸視点）
void	SpecialFuncSphereY( int key, int x, int y ){

	switch( key ){
		case GLUT_KEY_RIGHT:
			sphere.sphere_scaling(MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_LEFT:
			sphere.sphere_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		case GLUT_KEY_UP:
			sphere.sphere_scaling(MAGSCALE, MAGSCALE, MAGSCALE );
			break;		
		case GLUT_KEY_DOWN:
			sphere.sphere_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;		
		case GLUT_KEY_PAGE_UP:
			sphere.sphere_scaling(MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_PAGE_DOWN:
			sphere.sphere_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		default:
			break;
	}
}

//特殊キー押下処理（球・Z軸視点）
void	SpecialFuncSphereZ( int key, int x, int y ){

	switch( key ){
		case GLUT_KEY_RIGHT:
			sphere.sphere_scaling(MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_LEFT:
			sphere.sphere_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		case GLUT_KEY_UP:
			sphere.sphere_scaling(MAGSCALE, MAGSCALE, MAGSCALE );
			break;		
		case GLUT_KEY_DOWN:
			sphere.sphere_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;		
		case GLUT_KEY_PAGE_UP:
			sphere.sphere_scaling(MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_PAGE_DOWN:
			sphere.sphere_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		default:
			break;
	}
}

//特殊キー押下処理（円柱・X軸視点）
void	SpecialFuncPillarXY_X( int key, int x, int y ){

	switch( key ){
		case GLUT_KEY_RIGHT:
			pillar.pillar_scaling( 0, 0, MAGSCALE );
			break;
		case GLUT_KEY_LEFT:
			pillar.pillar_scaling( 0, 0, REDSCALE );
			break;
		case GLUT_KEY_UP:
			pillar.pillar_scaling( 0, MAGSCALE, 0 );
			break;		
		case GLUT_KEY_DOWN:
			pillar.pillar_scaling( 0, REDSCALE, 0 );
			break;		
		case GLUT_KEY_PAGE_UP:
			pillar.pillar_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_PAGE_DOWN:
			pillar.pillar_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		default:
			break;
	}
}

//特殊キー押下処理（円柱・Y軸視点）
void	SpecialFuncPillarXY_Y( int key, int x, int y ){

	switch( key ){
		case GLUT_KEY_RIGHT:
			pillar.pillar_scaling( MAGSCALE, 0, 0 );
			break;
		case GLUT_KEY_LEFT:
			pillar.pillar_scaling( REDSCALE, 0, 0 );
			break;
		case GLUT_KEY_UP:
			pillar.pillar_scaling( 0, 0, MAGSCALE );
			break;		
		case GLUT_KEY_DOWN:
			pillar.pillar_scaling( 0, 0, REDSCALE );
			break;		
		case GLUT_KEY_PAGE_UP:
			pillar.pillar_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_PAGE_DOWN:
			pillar.pillar_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		default:
			break;
	}
}

//特殊キー押下処理（円柱・Z軸視点）
void	SpecialFuncPillarXY_Z( int key, int x, int y ){

	switch( key ){
		case GLUT_KEY_RIGHT:
			pillar.pillar_scaling( MAGSCALE, MAGSCALE, 0 ) ;
			break;
		case GLUT_KEY_LEFT:
			pillar.pillar_scaling( REDSCALE, REDSCALE, 0 );
			break;
		case GLUT_KEY_UP:
			pillar.pillar_scaling( 0, MAGSCALE, 0 );
			break;		
		case GLUT_KEY_DOWN:
			pillar.pillar_scaling( 0, REDSCALE, 0 );
			break;		
		case GLUT_KEY_PAGE_UP:
			pillar.pillar_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_PAGE_DOWN:
			pillar.pillar_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		default:
			break;
	}
}

//------------
//特殊キー押下処理（円柱・X軸視点）
void	SpecialFuncPillarXZ_X( int key, int x, int y ){

	switch( key ){
		case GLUT_KEY_RIGHT:
			pillarXZ.pillar_scaling( MAGSCALE, 0, MAGSCALE );
			break;
		case GLUT_KEY_LEFT:
			pillarXZ.pillar_scaling( REDSCALE, 0, REDSCALE );
			break;
		case GLUT_KEY_UP:
			pillarXZ.pillar_scaling( 0, MAGSCALE, 0 );
			break;		
		case GLUT_KEY_DOWN:
			pillarXZ.pillar_scaling( 0, REDSCALE, 0 );
			break;		
		case GLUT_KEY_PAGE_UP:
			pillarXZ.pillar_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_PAGE_DOWN:
			pillarXZ.pillar_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		default:
			break;
	}
}

//特殊キー押下処理（円柱・Y軸視点）
void	SpecialFuncPillarXZ_Y( int key, int x, int y ){

	switch( key ){
		case GLUT_KEY_RIGHT:
			pillarXZ.pillar_scaling( MAGSCALE, 0, MAGSCALE );
			break;
		case GLUT_KEY_LEFT:
			pillarXZ.pillar_scaling( REDSCALE, 0, REDSCALE );
			break;
		case GLUT_KEY_UP:
			pillarXZ.pillar_scaling( MAGSCALE, 0, MAGSCALE );
			break;		
		case GLUT_KEY_DOWN:
			pillarXZ.pillar_scaling( REDSCALE, 0, REDSCALE );
			break;		
		case GLUT_KEY_PAGE_UP:
			pillarXZ.pillar_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_PAGE_DOWN:
			pillarXZ.pillar_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		default:
			break;
	}
}

//特殊キー押下処理（円柱・Z軸視点）
void	SpecialFuncPillarXZ_Z( int key, int x, int y ){

	switch( key ){
		case GLUT_KEY_RIGHT:
			pillarXZ.pillar_scaling( MAGSCALE, 0, MAGSCALE ) ;
			break;
		case GLUT_KEY_LEFT:
			pillarXZ.pillar_scaling( REDSCALE, 0, REDSCALE );
			break;
		case GLUT_KEY_UP:
			pillarXZ.pillar_scaling( 0, MAGSCALE, 0 );
			break;		
		case GLUT_KEY_DOWN:
			pillarXZ.pillar_scaling( 0, REDSCALE, 0 );
			break;		
		case GLUT_KEY_PAGE_UP:
			pillarXZ.pillar_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_PAGE_DOWN:
			pillarXZ.pillar_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		default:
			break;
	}
}

//-------------
//特殊キー押下処理（円柱・X軸視点）
void	SpecialFuncPillarYZ_X( int key, int x, int y ){

	switch( key ){
		case GLUT_KEY_RIGHT:
			pillarYZ.pillar_scaling( 0, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_LEFT:
			pillarYZ.pillar_scaling( 0, MAGSCALE, REDSCALE );
			break;
		case GLUT_KEY_UP:
			pillarYZ.pillar_scaling( 0, MAGSCALE, 0 );
			break;		
		case GLUT_KEY_DOWN:
			pillarYZ.pillar_scaling( 0, REDSCALE, 0 );
			break;		
		case GLUT_KEY_PAGE_UP:
			pillarYZ.pillar_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_PAGE_DOWN:
			pillarYZ.pillar_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		default:
			break;
	}
}

//特殊キー押下処理（円柱・Y軸視点）
void	SpecialFuncPillarYZ_Y( int key, int x, int y ){

	switch( key ){
		case GLUT_KEY_RIGHT:
			pillarYZ.pillar_scaling( MAGSCALE, 0, 0 );
			break;
		case GLUT_KEY_LEFT:
			pillarYZ.pillar_scaling( REDSCALE, 0, 0 );
			break;
		case GLUT_KEY_UP:
			pillarYZ.pillar_scaling( 0, MAGSCALE, MAGSCALE );
			break;		
		case GLUT_KEY_DOWN:
			pillarYZ.pillar_scaling( 0, REDSCALE, REDSCALE );
			break;		
		case GLUT_KEY_PAGE_UP:
			pillarYZ.pillar_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_PAGE_DOWN:
			pillarYZ.pillar_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		default:
			break;
	}
}

//特殊キー押下処理（円柱・Z軸視点）
void	SpecialFuncPillarYZ_Z( int key, int x, int y ){

	switch( key ){
		case GLUT_KEY_RIGHT:
			pillarYZ.pillar_scaling( MAGSCALE, 0, 0 ) ;
			break;
		case GLUT_KEY_LEFT:
			pillarYZ.pillar_scaling( REDSCALE, 0, 0 );
			break;
		case GLUT_KEY_UP:
			pillarYZ.pillar_scaling( 0, MAGSCALE, MAGSCALE );
			break;		
		case GLUT_KEY_DOWN:
			pillarYZ.pillar_scaling( 0, REDSCALE, REDSCALE );
			break;		
		case GLUT_KEY_PAGE_UP:
			pillarYZ.pillar_scaling( MAGSCALE, MAGSCALE, MAGSCALE );
			break;
		case GLUT_KEY_PAGE_DOWN:
			pillarYZ.pillar_scaling( REDSCALE, REDSCALE, REDSCALE );
			break;
		default:
			break;
	}
}
//----------------
	
//ウィンドウリサイズ用コールバック
void Resize( int w, int h )
{
	WindowWidth = w;
	WindowHeight = h;

	init_3vd(iwin_3vd);
	end_3vd(iwin_3vd);
}

//
void	Win3vd( void )
{
std::cout<<"void Win3vd( void )"<<std::endl;
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);

	//三面図用ウィンドウの生成
	glutInitWindowSize( WINDOW_W,WINDOW_H );
	glutInitWindowPosition(1130,360);
	iwin_3vd = glutCreateWindow("3vd");

	//コールバック関数を登録
	glutDisplayFunc(display_3vd);
	glutMouseFunc( MouseFunc );
	glutMotionFunc( MouseMotion );
	glutSpecialFunc( SpecialFunc );
 	glutReshapeFunc( Resize );

	//guiパネルの生成
	init_PBVRpara( );
std::cout << " ### init_PBVRpara( ) done " << std::endl;
	gui_panel();
std::cout << " ### gui_panel() done " << std::endl;
	glutSetWindow(iwin_3vd);
std::cout << " ### glutSetWindow(iwin_3vd) done " << std::endl;

#ifndef NOTOPEN
	glutHideWindow();
#endif
}



#ifdef NOTOPEN
int main(int argc, char *argv[])
{
//テスト用メインウィンドウ--------------------------
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);

	glutInitWindowSize( MAINWINDOW_W, MAINWINDOW_H );
	glutInitWindowPosition(300,300);
	iwin_main = glutCreateWindow("Main Win");

	glutDisplayFunc(display);
	glClearColor(0.0, 0.0, 0.0, 0.0);

	glutInitWindowPosition(600,600);
	GLUI *gluitest = GLUI_Master.create_glui( "control",0, 450, 630 );

	GLUI_Rotation *view_rot= gluitest->add_rotation("Rotation",rotate);

//--------------------------------------------------
	obj_3d = obj_sel+1;

//	Win3vd();

	glutMainLoop();
	return 0;
}
#endif

#ifndef NOTOPEN
#include <kvs/glut/Application>
#include <kvs/glut/Screen>
#include <kvs/OpenGL>
#include <kvs/PaintEventListener>

// tantan
class PaintEvent : public kvs::PaintEventListener
{
public:
	void update();
};

void	PBVRScaling(){

   mapscale = PBVRscale/WIN3VDSCALE;
}

//PBVRペイントイベント・PBVRウィンドウに選択領域を表示
void PaintEvent::update()
{
	//CROPボタンが押されていなかったら、リターン
	if( crop_flg == FALSE )
		return;

	glPushMatrix();

	PBVRScaling();

	switch( obj_3d )
	{
	case	CROP:

		DrawCrop( WIRE );
		DrawCrop( SOLID );

	break;

	case	SPHERE:

		DrawSphere( WIRE );
		DrawSphere( SOLID );

	break;
	
	case	PILLARXY:

		DrawPillar( WIRE );
		DrawPillar( SOLID );

	break;

	case	PILLARYZ:

		DrawPillar( WIRE );
		DrawPillar( SOLID );

	break;

	case	PILLARXZ:

		DrawPillar( WIRE );
		DrawPillar( SOLID );

	break;

	default:
	break;
	}

	glFlush();
	glPopMatrix();
}
#endif

void	CropCallback(int num)
{
	glutSetWindow( iwin_3vd );
	glutShowWindow();	
	crop_flg = TRUE;
	obj_3d = obj_sel+1;
	param3vd.sel_area = obj_sel+1;
#ifdef __APPLE__
        display_3vd();
#endif
}

// APPEND START FP)K.YAJIMA 2015.03.11
void	FileCallback(int num)
{
	if(FileCallback_Cancel) return;
	FileCallback_Cancel = true;
	g_glui_filepanel->show();
}
// APPEND END FP)K.YAJIMA 2015.03.11

// APPEND START FP)K.YAJIMA 2015.02.20
// MODIFY START FP)K.YAJIMA 2015.03.11
//void	FileCallback(int num)
void	FILEpanelCreate(void)
// MODIFY END FP)K.YAJIMA 2015.03.11
{

// MODIFY START FP)K.YAJIMA 2015.03.11
	//if(FileCallback_Cancel) return;
	//FileCallback_Cancel = true;
	//GLUI *glui = GLUI_Master.create_glui("FILE Panel");
	
	g_glui_filepanel = GLUI_Master.create_glui("FILE Panel");
// MODIFY END FP)K.YAJIMA 2015.03.11

// DELETE START FP)K.YAJIMA 2015.03.02
//TO DO:いずれ元に戻す
//	// VOLUME DATA FILE (SERVER)
//	GLUI_StaticText *lbl_PFIF;
//	lbl_PFIF = glui->add_statictext("PBVR Filter Infomation FILE: (SERVER)");
//	GLUI_Panel *obj_panelvold = glui->add_panel("", 3);
//	obj_panelvold->set_alignment(GLUI_ALIGN_LEFT);
//	GLUI_EditText *volumedata;
//	char buff_volumedata[100] = "/work/filter/case/case";
//	//char buff_volumedata[100] = "/work/filter/binary08/binary";
//	//glui->add_statictext("pfi FILE: (SERVER)");
//	//volumedata = glui->add_edittext( "", GLUI_EDITTEXT_TEXT, buff_volumedata );
//	volumedata = glui->add_edittext_to_panel(obj_panelvold, "", GLUI_EDITTEXT_TEXT, buff_volumedata );
//	volumedata->set_w(250);
// DELETE END FP)K.YAJIMA 2015.03.02

// DELETE START FP)K.YAJIMA 2015.03.02
//	// WORK DIRECTORY (CLIENT)
//	glui->add_statictext("WORK DIR. (CLIENT):");
//	GLUI_Panel *obj_panelworkd = glui->add_panel("", 3);
//	obj_panelworkd->set_alignment(GLUI_ALIGN_LEFT);
//	GLUI_EditText *workdir;
//	//char buff_workdir[100] = "c:\\temp\0";
//	//glui->add_statictext("WORK DIR. (CLIENT):");
//	//workdir = glui->add_edittext("", GLUI_EDITTEXT_TEXT, buff_workdir );
//	//workdir->set_w(250);
//	workdir = glui->add_edittext_to_panel(obj_panelworkd, "",GLUI_EDITTEXT_TEXT,buff_workdir);
//	workdir->set_w(250);
//	
//	glui->add_column_to_panel(obj_panelworkd,false);
//
//	//ワークディレクトリのディレクトリダイアログボタン
//	GLUI_Button *btn_wdd;
//	btn_wdd = glui->add_button_to_panel(obj_panelworkd, "Browse...",1,DdCallback); // TO DO:機能未実装
//	btn_wdd->set_alignment(GLUI_ALIGN_CENTER);
// DELETE END FP)K.YAJIMA 2015.03.02

//	glui->add_separator();
        
	// ヴィズパラメータファイル
	g_glui_filepanel->add_statictext("VIZ PARAMETER FILE:");
	GLUI_Panel *obj_panelvizp = g_glui_filepanel->add_panel("", 3);
	obj_panelvizp->set_alignment(GLUI_ALIGN_LEFT);

	GLUI_EditText *paramfile;
	// char buff_paramfile[100] = "c:\\temp\\param.in";
	//glui->add_statictext("VIZ PARAMETER FILE:");
	//paramfile = glui->add_edittext("", GLUI_EDITTEXT_TEXT, buff_paramfile );
	//paramfile->set_w(250);
	paramfile = g_glui_filepanel->add_edittext_to_panel(obj_panelvizp, "",GLUI_EDITTEXT_TEXT,buff_paramfile);
	paramfile->set_w(250);

	g_glui_filepanel->add_column_to_panel(obj_panelvizp,false);
	
	//ヴィズパラメータのファイルダイアログボタン
	GLUI_Button *btn_vdd;
	btn_vdd = g_glui_filepanel->add_button_to_panel(obj_panelvizp, "Browse...",1,FdCallback); // TO DO:機能未実装
	btn_vdd->set_alignment(GLUI_ALIGN_CENTER);

// APPEND START FP)M.Tanaka 2015.03.02
	g_btn_vdd = btn_vdd;
	g_paramfile = paramfile;
// APPEND END   FP)M.Tanaka 2015.03.02

	GLUI_Panel *obj_panelei = g_glui_filepanel->add_panel("",3);
	obj_panelei->set_alignment(GLUI_ALIGN_LEFT);

	/* 下記、エクスポートファイルボタンを右詰めにするために
	縦線設置*/
	g_glui_filepanel->add_column_to_panel(obj_panelei,false);
	g_glui_filepanel->add_column_to_panel(obj_panelei,false);
	g_glui_filepanel->add_column_to_panel(obj_panelei,false);
	g_glui_filepanel->add_column_to_panel(obj_panelei,false);
	g_glui_filepanel->add_column_to_panel(obj_panelei,false);

	//Export FILE(PARAMETER FILE SAVE)
	GLUI_Button *btn_paramfile;
	btn_paramfile = g_glui_filepanel->add_button_to_panel(obj_panelei,"Export FILE", 1, cbparamfile);
	btn_paramfile->set_alignment(GLUI_ALIGN_LEFT);

	g_glui_filepanel->add_column_to_panel(obj_panelei,false);
	
	// Import FILE
	GLUI_Button *btn_importfile;
	btn_importfile = g_glui_filepanel->add_button_to_panel(obj_panelei,"Import FILE", 1, cbreadfile);
	btn_importfile->set_alignment(GLUI_ALIGN_LEFT);


// APPEND START FP)M.Tanaka 2015.03.05
	g_glui_filepanel->add_statictext("");
	// Close Button
	GLUI_Button *btn_fileclose;
	btn_fileclose = g_glui_filepanel->add_button("Close", 1, cbfileclose);
	btn_fileclose->set_alignment(GLUI_ALIGN_CENTER);
	g_glui_filepanel = g_glui_filepanel;
// APPEND END   FP)M.Tanaka 2015.03.05

// APPEND START FP)K.YAJIMA 2015.03.11
	g_glui_filepanel->hide();
// APPEND END FP)K.YAJIMA 2015.03.11
}

// APPEND START FP)M.Tanaka 2015.03.05
void cbfileclose(int num) {
	FileCallback_Cancel = false;
	g_glui_filepanel->hide();
}
// APPEND END   FP)M.Tanaka 2015.03.05


// ファイルダイアログ
void	FdCallback(int num)
{
// APPEND START FP)M.Tanaka 2015.03.02

        GLUI *glui = GLUI_Master.create_glui("FileDialog");
	FileDialog* fd = new FileDialog(glui, g_btn_vdd, 0, g_paramfile->get_text(), g_paramfile);
}
// APPEND START FP)M.Tanaka 2015.03.02

void	ParticleCallback(int num)
{
        //glutWinFd = glutCreateWindow("FILEDialog");
	//GLUIの初期設定
        //GLUI *glui = GLUI_Master.create_glui("FILEDialog");
}
// APPEND END FP)K.YAJIMA 2015.02.20

void	CalcCoordnatesScaling( double xmin, double xmax, 
double ymin, double ymax, double zmin, double zmax,  double* sides, double* CScale )
{
/*
[座標値]
  最小値: (x,y,z)=(-272.465, -159.000,   0.000)
  最大値: (x,y,z)=( 577.994,  159.000, 577.994)

forkの最少／最大値
X：-1.75　1.75
Y： 0　7.945124149
Z： 0　8.007808685 
*/

	*sides = (( xmax - xmin ) > ( ymax - ymin )) ? ( xmax - xmin ) : ( ymax - ymin );
	*sides = ( *sides > ( zmax - zmin )) ? *sides : ( zmax - zmin );

	*CScale = ( WIN3VDSCALE * 2 ) / *sides;
}

//PBVRウィンドウの座標値を3vdウィンドウの座標値に変換
void	Calc3vdCoord( float max, float min, float p, float* point )
{
//中心を3vdウィンドウの（０，０）に移動し、最大スケールの座標のスケールを掛ける
	*point = ( p - (( max + min ) / 2)) * PBVRCoordScale;
}

//3vdウィンドウ上の座標をPBVRウィンドウの座標値に変換
void	CalcPBVRCoord( float max, float min, float p, float* point )
{
//最大スケールの座標のスケールで割り、中心(0, 0)をPBVR領域の中心に移動する
	*point = ( p / PBVRCoordScale ) + (( max + min ) / 2);
}

//PBVR用パラメータ初期化
void	init_PBVRpara( void )
{
std::cout<<"void init_PBVRpara( void )"<<std::endl;
/*
[座標値]
  最小値: (x,y,z)=(-272.465, -159.000,   0.000)
  最大値: (x,y,z)=( 577.994,  159.000, 577.994)

forkの最少／最大値
X：-1.75	1.75
Y： 0		7.75
Z： -1		0.0F
*/

//#ifdef NOTOPEN
//	PBVRxmin = -272.465; PBVRymin =  -159.000;  PBVRzmin = 0.000;
//	PBVRxmax =  577.994; PBVRymax =   159.000;  PBVRzmax = 577.994;
//#else
	PBVRxmin = (double)PVBRmincoords[0];
	PBVRymin = (double)PVBRmincoords[1];
	PBVRzmin = (double)PVBRmincoords[2];
	PBVRxmax = (double)PVBRmaxcoords[0];
	PBVRymax = (double)PVBRmaxcoords[1];
	PBVRzmax = (double)PVBRmaxcoords[2];
//#endif

printf("============== init_PBVRpara %f, %f, %f, %f, %f, %f\n", PBVRxmin, PBVRymin, PBVRzmin, PBVRxmax, PBVRymax, PBVRzmax );

//	PBVRxmin = -272.465; PBVRymin =  -159.000;  PBVRzmin = 0.000;
//	PBVRxmax =  577.994; PBVRymax =   159.000;  PBVRzmax = 577.994;

//	PBVRxmin = -1.75;	PBVRymin =  0.0F;			PBVRzmin = -1.0F;
//	PBVRxmax = 1.75;	PBVRymax =  7.75;			PBVRzmax = 0.0F;
//
        //CROP BOXの初期値をグローバルな座標のmin,maxに設定する
        crop.crop_init(1);
/*
        double maxwidth = PBVRxmax - PBVRxmin;
        if (maxwidth < PBVRymax - PBVRymin) maxwidth = PBVRymax - PBVRymin;
        if (maxwidth < PBVRzmax - PBVRzmin) maxwidth = PBVRzmax - PBVRzmin;
        cxmaxlevel2 = (PBVRxmax - PBVRxmin)/maxwidth;
        cxminlevel2 = -cxmaxlevel2;
        cymaxlevel2 = (PBVRymax - PBVRymin)/maxwidth;
        cyminlevel2 = -cymaxlevel2;
        czmaxlevel2 = (PBVRzmax - PBVRzmin)/maxwidth;
        czminlevel2 = -czmaxlevel2;
        param3vd.CropParaSet();
	crop.side_x = cxmaxlevel2 - cxminlevel2;
	crop.side_y = cymaxlevel2 - cyminlevel2;
	crop.side_z = czmaxlevel2 - czminlevel2;
	crop.move_x = ( cxmaxlevel2 + cxminlevel2 ) * ( VIEWPORT_WIDTH / 2 ) / 2;
	crop.move_y = ( cymaxlevel2 + cyminlevel2 ) * ( VIEWPORT_WIDTH / 2 ) / 2;
	crop.move_z = ( czmaxlevel2 + czminlevel2 ) *(  VIEWPORT_WIDTH / 2 ) / 2;
	crop.save_pos(crop.move_x, crop.move_y, crop.move_z);
	save_cxmin = cxminlevel2;
	save_cxmax = cxmaxlevel2;
	save_cymin = cyminlevel2;
	save_cymax = cymaxlevel2;
	save_czmin = czminlevel2;
	save_czmax = czmaxlevel2;
*/
	param3vd.CropParaSet();

	CalcCoordnatesScaling( PBVRxmin, PBVRxmax, PBVRymin, PBVRymax, PBVRzmin, PBVRzmax, &PBVRsides, &PBVRCoordScale );

	//最大値/最小値をセット
	set_3vdmax( WIN3VDSCALE, -WIN3VDSCALE, &Xmax, &Xmin );
	set_3vdmax( WIN3VDSCALE, -WIN3VDSCALE, &Ymax, &Ymin );
	set_3vdmax( WIN3VDSCALE, -WIN3VDSCALE, &Zmax, &Zmin );

	set_PBVRmax( PBVRxmax, PBVRxmin, &PBVRxmaxChk, &PBVRxminChk );
	set_PBVRmax( PBVRymax, PBVRymin, &PBVRymaxChk, &PBVRyminChk );
	set_PBVRmax( PBVRzmax, PBVRzmin, &PBVRzmaxChk, &PBVRzminChk );

	//テキストボックスデフォルト値をPBVRウィンドウの座標に変換
	CalcPBVRCoord( PBVRxmax, PBVRxmin, cxminlevel2, &tbcxminlevel );
	CalcPBVRCoord( PBVRxmax, PBVRxmin, cxmaxlevel2, &tbcxmaxlevel );
	CalcPBVRCoord( PBVRymax, PBVRymin, cyminlevel2, &tbcyminlevel );
	CalcPBVRCoord( PBVRymax, PBVRymin, cymaxlevel2, &tbcymaxlevel );
	CalcPBVRCoord( PBVRzmax, PBVRzmin, czminlevel2, &tbczminlevel );
	CalcPBVRCoord( PBVRzmax, PBVRzmin, czmaxlevel2, &tbczmaxlevel );

        Calc3vdCoord( PBVRxmax, PBVRxmin, PBVRxmin+(PBVRxmax-PBVRxmin)/2.0F, &scenterx );
        Calc3vdCoord( PBVRymax, PBVRymin, PBVRymin+(PBVRymax-PBVRymin)/2.0F, &scentery );
        Calc3vdCoord( PBVRzmax, PBVRzmin, PBVRzmin+(PBVRzmax-PBVRzmin)/2.0F, &scenterz );
	CalcPBVRCoord( PBVRxmax, PBVRxmin, scenterx, &tbscenterx );
	CalcPBVRCoord( PBVRymax, PBVRymin, scentery, &tbscentery );
	CalcPBVRCoord( PBVRzmax, PBVRzmin, scenterz, &tbscenterz );
/*
        sradius = (PBVRxmax-PBVRxmin)*(PBVRxmax-PBVRxmin) + (PBVRymax-PBVRymin)*(PBVRymax-PBVRymin) + (PBVRzmax-PBVRzmin)*(PBVRzmax-PBVRzmin); 
        sradius = sqrt (sradius)/2.0F;
        sradius = sradius*PBVRCoordScale;
	tbsradius = sradius / PBVRCoordScale;
*/
	sphere.sphere_init(1);
        param3vd.SphereParaSet();

/*
        pillar.radius = (PBVRxmax-PBVRxmin)*(PBVRxmax-PBVRxmin) + (PBVRymax-PBVRymin)*(PBVRymax-PBVRymin);
        pillar.radius = sqrt (pillar.radius)/2.0F;
        pillar.radius = pillar.radius*PBVRCoordScale;
        pillar.height = (PBVRzmax - PBVRzmin)*PBVRCoordScale;
        Calc3vdCoord( PBVRxmax, PBVRxmin, PBVRxmin+(PBVRxmax-PBVRxmin)/2.0F, &pillar.center_x );
        Calc3vdCoord( PBVRymax, PBVRymin, PBVRymin+(PBVRymax-PBVRymin)/2.0F, &pillar.center_y );
        Calc3vdCoord( PBVRzmax, PBVRzmin, PBVRzmin, &pillar.center_z );
*/
	obj_3d = PILLAR;
	pillar.pillar_init(1);
	pillar.reload_pillar();

/*
        pillarYZ.radius = (PBVRymax-PBVRymin)*(PBVRymax-PBVRymin) + (PBVRzmax-PBVRzmin)*(PBVRzmax-PBVRzmin);
        pillarYZ.radius = sqrt (pillarYZ.radius)/2.0F;
        pillarYZ.radius = pillarYZ.radius*PBVRCoordScale;
        pillarYZ.height = (PBVRxmax - PBVRxmin)*PBVRCoordScale;
        Calc3vdCoord( PBVRxmax, PBVRxmin, PBVRxmin, &pillarYZ.center_x );
        Calc3vdCoord( PBVRymax, PBVRymin, PBVRymin+(PBVRymax-PBVRymin)/2.0F, &pillarYZ.center_y );
        Calc3vdCoord( PBVRzmax, PBVRzmin, PBVRzmin+(PBVRzmax-PBVRzmin)/2.0F, &pillarYZ.center_z );
*/
	obj_3d = PILLARYZ;
	pillarYZ.pillar_init(1);
	pillarYZ.reload_pillar();

/*
        pillarXZ.radius = (PBVRxmax-PBVRxmin)*(PBVRxmax-PBVRxmin) + (PBVRzmax-PBVRzmin)*(PBVRzmax-PBVRzmin);
        pillarXZ.radius = sqrt (pillarXZ.radius)/2.0F;
        pillarXZ.radius = pillarXZ.radius*PBVRCoordScale;
        pillarXZ.height = (PBVRymax - PBVRymin)*PBVRCoordScale;
        Calc3vdCoord( PBVRxmax, PBVRxmin, PBVRxmin+(PBVRxmax-PBVRxmin)/2.0F, &pillarXZ.center_x );
        Calc3vdCoord( PBVRymax, PBVRymin, PBVRymin, &pillarXZ.center_y );
        Calc3vdCoord( PBVRzmax, PBVRzmin, PBVRzmin+(PBVRzmax-PBVRzmin)/2.0F, &pillarXZ.center_z );
*/
	obj_3d = PILLARXZ;
	pillarXZ.pillar_init(1);
	pillarXZ.reload_pillar();
	obj_3d = CROP;

        pradius = pillar.radius;
        pheight = pillar.height;
        pcenterx = pillar.center_x;
        pcentery = pillar.center_y;
        pcenterz = pillar.center_z;

        CalcPBVRCoord( PBVRxmax, PBVRxmin, pcenterx, &tbpcenterx );
        CalcPBVRCoord( PBVRymax, PBVRymin, pcentery, &tbpcentery );
        CalcPBVRCoord( PBVRzmax, PBVRzmin, scenterz, &tbpcenterz );
        tbpradius = pradius / PBVRCoordScale;
        tbpheight = pheight / PBVRCoordScale;
	param3vd.PillarParaSet();
}

//3vdウィンドウ内の最大／最小値をセット
void	set_3vdmax( float max, float min, float* areamax, float* areamin )
{
	*areamax = max;
	*areamin = min;
}

//PBVRウィンドウ内の最大／最小値をセット
void	set_PBVRmax( double max, double min, double* areamax, double* areamin )
{
	*areamax =  PBVRsides + ( max + min ) / 2;
	*areamin = -PBVRsides + ( max + min ) / 2;
}

void	DrawCrop( int type )
{
	int	i, j;

	if( type == WIRE ){
		glColor3f( 1.0, 0.0, 0.0 );
		for( i = 0; i < 6 ; i++ ){
			glBegin(GL_LINE_LOOP);
			for( j = 0; j < 4 ; j++ ){
				glVertex3f( verticesCrop[(ConnectionArrayCrop[i*4+j])*3]*mapscale,
							verticesCrop[(ConnectionArrayCrop[i*4+j])*3+1]*mapscale,
							verticesCrop[(ConnectionArrayCrop[i*4+j])*3+2]*mapscale );
			}
			glEnd();
		}
	}

	if( type == SOLID ){
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glColor4f( 0.5, 0.5, 0.5, ALPHA );
		glEnable(GL_NORMALIZE);

		glBegin(GL_QUADS);
		for( i = 0; i < 6 ; i++ ){
			glNormal3fv(&NormalArrayCrop[i*3]);
			for( j = 0; j < 4 ; j++ ){
				glVertex3f( verticesCrop[(ConnectionArrayCrop[i*4+j])*3]*mapscale,
							verticesCrop[(ConnectionArrayCrop[i*4+j])*3+1]*mapscale,
						verticesCrop[(ConnectionArrayCrop[i*4+j])*3+2]*mapscale );
			}
		}
	}
	glEnd();
	glDisable(GL_BLEND);
}

void	DrawSphere( int type ){

	int	i, j, sides;

	if( type == WIRE ){

		glColor3f( 1.0, 0.0, 0.0 );
		for ( i = 0, sides = 0 ; sides < (SIDES*2+SIDES*2*(SIDES-2)); ++sides, ++i )
		{
			glBegin(GL_LINE_STRIP);
			for ( j = 0; j < 3; j++ ){
				glVertex3f( verticesSphere[(ConnectionArraySphere[i*3+j])*3]*mapscale,
							verticesSphere[(ConnectionArraySphere[i*3+j])*3+1]*mapscale,
							verticesSphere[(ConnectionArraySphere[i*3+j])*3+2]*mapscale );
			}
			glEnd();
		}
	}

	if( type == SOLID ){
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glColor4f( 0.5, 0.5, 0.5, ALPHA );
		glEnable(GL_NORMALIZE);

		glBegin(GL_TRIANGLES);													//上面
		for ( i = 0, sides = 0 ; sides < SIDES; ++sides, ++i )
		{
			glNormal3fv(&NormalArraySphere[i*3]);
			for ( j = 0; j < 3; j++ ){
				glVertex3f( verticesSphere[(ConnectionArraySphere[i*3+j])*3]*mapscale,
							verticesSphere[(ConnectionArraySphere[i*3+j])*3+1]*mapscale,
							verticesSphere[(ConnectionArraySphere[i*3+j])*3+2]*mapscale );
			}
		}
		glEnd();

		glBegin(GL_TRIANGLES);													//側面
		for ( i = SIDES, sides = 0 ; sides < (SIDES*(SIDES-2)); ++sides, ++i )
		{
			glNormal3fv(&NormalArraySphere[i*3]);
			for ( j = 0; j < 3; j++ )
			{
				glVertex3f( verticesSphere[(ConnectionArraySphere[i*3+j])*3]*mapscale,
							verticesSphere[(ConnectionArraySphere[i*3+j])*3+1]*mapscale,
							verticesSphere[(ConnectionArraySphere[i*3+j])*3+2]*mapscale );
			}
			for ( j = 0; j < 3; j++ )
			{
				glVertex3f( verticesSphere[(ConnectionArraySphere[(i+SIDES*(SIDES-2))*3+j])*3]*mapscale,
							verticesSphere[(ConnectionArraySphere[(i+SIDES*(SIDES-2))*3+j])*3+1]*mapscale,
							verticesSphere[(ConnectionArraySphere[(i+SIDES*(SIDES-2))*3+j])*3+2]*mapscale );
			}
		}
		glEnd();

		glBegin(GL_TRIANGLES);													//下面
		for ( i = (SIDES+SIDES*2*(SIDES-2)), sides = 0 ; sides < SIDES; ++sides, ++i )
		{
			glNormal3fv(&NormalArraySphere[i*3]);
			for ( j = 0; j < 3; j++ )
			{
				glVertex3f( verticesSphere[(ConnectionArraySphere[i*3+j])*3]*mapscale,
							verticesSphere[(ConnectionArraySphere[i*3+j])*3+1]*mapscale,
							verticesSphere[(ConnectionArraySphere[i*3+j])*3+2]*mapscale );
			}
		}
		glEnd();
		glDisable(GL_BLEND);
	}
}

void	DrawPillar( int type ){

	int	i, j, sides;

	if( type == WIRE ){

		glColor3f( 1.0, 0.0, 0.0 );
		for ( i = 0, sides = 0 ; sides < SIDES*4; ++sides, ++i )
		{
		glBegin(GL_LINE_STRIP);
			for ( j = 0; j < 3; j++ )
			{
			glVertex3f( verticesPillar[(ConnectionArrayPillar[i*3+j])*3]*mapscale,
						verticesPillar[(ConnectionArrayPillar[i*3+j])*3+1]*mapscale,
						verticesPillar[(ConnectionArrayPillar[i*3+j])*3+2]*mapscale );
			}
		glEnd();
		}
	}

	if( type == SOLID ){
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glColor4f( 0.5, 0.5, 0.5, ALPHA );
		glEnable(GL_NORMALIZE);

		glBegin(GL_TRIANGLES);
		glNormal3fv(&NormalArrayPillar[0]);
		for ( i = 0, sides = 0 ; sides < SIDES; ++sides, ++i )											//上面
		{
			for ( j = 0; j < 3; j++ )
			{
				glVertex3f( verticesPillar[(ConnectionArrayPillar[i*3+j])*3]*mapscale,
							verticesPillar[(ConnectionArrayPillar[i*3+j])*3+1]*mapscale,
							verticesPillar[(ConnectionArrayPillar[i*3+j])*3+2]*mapscale );
			}
		}
		glEnd();

		glBegin(GL_TRIANGLES);
		glNormal3fv(&NormalArrayPillar[SIDES*3]);
		for ( i = SIDES, sides = 0 ; sides < SIDES; ++sides, ++i )										//底面
		{
			for ( j = 0; j < 3; j++ )
			{
				glVertex3f( verticesPillar[(ConnectionArrayPillar[i*3+j])*3]*mapscale,
							verticesPillar[(ConnectionArrayPillar[i*3+j])*3+1]*mapscale,
							verticesPillar[(ConnectionArrayPillar[i*3+j])*3+2]*mapscale );
			}
		}
		glEnd();

		for ( i = SIDES*2, sides = 0 ; sides < SIDES; ++sides, ++i )									//側面
		{
		glBegin(GL_TRIANGLES);
			glNormal3fv(&NormalArrayPillar[i*3]);
			for ( j = 0; j < 3; j++ )
			{
				glVertex3f( verticesPillar[(ConnectionArrayPillar[i*3+j])*3]*mapscale,
							verticesPillar[(ConnectionArrayPillar[i*3+j])*3+1]*mapscale,
							verticesPillar[(ConnectionArrayPillar[i*3+j])*3+2]*mapscale );
			}
			for ( j = 0; j < 3; j++ )
			{
				glVertex3f( verticesPillar[(ConnectionArrayPillar[(i+SIDES)*3+j])*3]*mapscale,
							verticesPillar[(ConnectionArrayPillar[(i+SIDES)*3+j])*3+1]*mapscale,
							verticesPillar[(ConnectionArrayPillar[(i+SIDES)*3+j])*3+2]*mapscale );
			}
		glEnd();
		}

		glDisable(GL_BLEND);
	}
}
